SystemOrganization addCategory: #'HandleVirtualMachine-FCR'!
SystemOrganization addCategory: #'HandleVirtualMachine-SmartCloneInterpreterExperiment'!
SystemOrganization addCategory: #'HandleVirtualMachine-SmartCloneInterpreter'!
SystemOrganization addCategory: #'HandleVirtualMachine-Interpreter'!
SystemOrganization addCategory: #'HandleVirtualMachine-Config'!

StackInterpreterPrimitives subclass: #HSCStackInterpreterRoot
	instanceVariableNames: ''
	classVariableNames: 'ClassHandle HandleClassLookupIndex HandleCloneIndex HandleConfigurationIndex HandlePropagationSelectorIndex HandleReceiverIndex'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-SmartCloneInterpreter'!

HSCStackInterpreterRoot subclass: #HSCStackInterpreterPrimitives
	instanceVariableNames: 'hPrimitiveTable'
	classVariableNames: 'HPrimitiveTable'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-SmartCloneInterpreter'!

!HSCStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
declareCVarsIn: aCCodeGenerator
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator var: #hPrimitiveTable
		declareC: 'void (*hPrimitiveTable[MaxPrimitiveIndex + 2 /* ', (MaxPrimitiveIndex +2) printString, ' */])(void) = ', self hPrimitiveTableString.
	! !

!HSCStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
hPrimitiveTable

	^ HPrimitiveTable! !

!HSCStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
hPrimitiveTableString
	"StackInterpreter initializePrimitiveTable primitiveTableString"
	^String streamContents:
		[:s | 
		s nextPut: ${.
		self hPrimitiveTable withIndexDo:
			[:primSpec :index |
			s
				crtab;
				nextPutAll: '/* ';
				print: index - 1;
				nextPutAll: ' */ ';
				nextPutAll: (primSpec isString
								ifTrue: [primSpec == #primitiveFail
											ifTrue: ['(void (*)(void))0']
											ifFalse: [primSpec]]
								ifFalse: ['(void (*)(void))', primSpec printString]);
				nextPut: $,].
			s cr; nextPutAll: ' 0 }']! !

!HSCStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/25/2011 18:11'!
initializeHandlePrimitiveTables 
	"self initializeHandlePrimitiveTables"
	HPrimitiveTable := Array new: MaxPrimitiveIndex + 1.
	self table: HPrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called")
		(1 primitiveAdd)				"not need handle version"
		(2 primitiveSubtract)			"not need handle version"
		(3 primitiveLessThan)			"not need handle version"
		(4 primitiveGreaterThan)		"not need handle version"
		(5 primitiveLessOrEqual)		"not need handle version"
		(6 primitiveGreaterOrEqual)		"not need handle version"
		(7 primitiveEqual)				"not need handle version"
		(8 primitiveNotEqual)			"not need handle version"
		(9 primitiveMultiply)				"not need handle version"
		(10 primitiveDivide)				"not need handle version"
		(11 primitiveMod)				"not need handle version"
		(12 primitiveDiv)				"not need handle version"
		(13 primitiveQuo)				"not need handle version"
		(14 primitiveBitAnd)			"not need handle version"
		(15 primitiveBitOr)				"not need handle version"
		(16 primitiveBitXor)				"not need handle version"
		(17 primitiveBitShift)			"not need handle version"
		(18 primitiveMakePoint)			"not need handle version"
		(19 0) "somtime we need to do bad thing"
		
		"LargeInteger Primitives (20-37)"
		(20 0)								"not need handle version"
		(21 primitiveAddLargeIntegers)					"not need handle version"
		(22 primitiveSubtractLargeIntegers)			"not need handle version"
		(23 primitiveLessThanLargeIntegers)			"not need handle version"
		(24 primitiveGreaterThanLargeIntegers)		"not need handle version"
		(25 primitiveLessOrEqualLargeIntegers)		"not need handle version"
		(26 primitiveGreaterOrEqualLargeIntegers)		"not need handle version"
		(27 primitiveEqualLargeIntegers)				"not need handle version"
		(28 primitiveNotEqualLargeIntegers)			"not need handle version"
		(29 primitiveMultiplyLargeIntegers)				"not need handle version"
		(30 primitiveDivideLargeIntegers)				"not need handle version"
		(31 primitiveModLargeIntegers)				"not need handle version"
		(32 primitiveDivLargeIntegers)					"not need handle version"
		(33 primitiveQuoLargeIntegers)				"not need handle version"
		(34 primitiveBitAndLargeIntegers)				"not need handle version"
		(35 primitiveBitOrLargeIntegers)				"not need handle version"
		(36 primitiveBitXorLargeIntegers)				"not need handle version"
		(37 primitiveBitShiftLargeIntegers)				"not need handle version"

		"Float Primitives (38-59)"
		(38 primitiveFloatAt)							"not need handle version"
		(39 primitiveFloatAtPut)							"not need handle version"
		(40 primitiveAsFloat)							"not need handle version"
		(41 primitiveFloatAdd)							"not need handle version"
		(42 primitiveFloatSubtract)						"not need handle version"
		(43 primitiveFloatLessThan)					"not need handle version"
		(44 primitiveFloatGreaterThan)					"not need handle version"
		(45 primitiveFloatLessOrEqual)					"not need handle version"
		(46 primitiveFloatGreaterOrEqual)				"not need handle version"
		(47 primitiveFloatEqual)							"not need handle version"
		(48 primitiveFloatNotEqual)						"not need handle version"
		(49 primitiveFloatMultiply)						"not need handle version"
		(50 primitiveFloatDivide)						"not need handle version"
		(51 primitiveTruncated)							"not need handle version"
		(52 primitiveFractionalPart)						"not need handle version"
		(53 primitiveExponent)							"not need handle version"
		(54 primitiveTimesTwoPower)					"not need handle version"
		(55 primitiveSquareRoot)						"not need handle version"
		(56 primitiveSine)								"not need handle version"
		(57 primitiveArctan)							"not need handle version"
		(58 primitiveLogN)								"not need handle version"
		(59 primitiveExp)								"not need handle version"

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveHAt)									"state handle"
		(61 primitiveHAtPut)								"state handle"
		(62 primitiveHSize)								"fixed field handle"				
		(63 primitiveStringAt)							"fixed field handle"
		(64 primitiveStringAtPut)						"fixed field handle"
		"The stream primitives no longer pay their way; normal Smalltalk code is faster."
		(65 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(66 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(67 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"

		"StorageManagement Primitives (68-79)"
		(68 primitiveHObjectAt)						"fixed field handle"
		(69 primitiveHObjectAtPut)						"fixed field handle"
		(70 primitiveHNew)								"class handle"
		(71 primitiveHNewWithArg)						"class handle"
		(72 primitiveArrayBecomeOneWay)				"hum hum"
		(73 primitiveHInstVarAt)						"handle version state"
		(74 primitiveHInstVarAtPut)						"handle version state"
		(75 primitiveHIdentityHash)						"handle version identity"
		(76 primitiveStoreStackp)						"not need handle version"		
		(77 primitiveSomeInstance)						"not need handle version"
		(78 primitiveNextInstance)						"not need handle version"
		(79 primitiveNewMethod)						"??????"

		"Control Primitives (80-89)"
		(80 primitiveFail)								"not need handle version"
		(81 primitiveFail)								"not need handle version"
		(82 primitiveFail)								"not need handle version"
		(83 primitiveHPerform)							"shadow handle"
		(84 primitiveHPerformWithArgs)				"shadow handle"
		(85 primitiveSignal)								"not need handle version"
		(86 primitiveWait)								"not need handle version"
		(87 primitiveResume)							"not need handle version"
		(88 primitiveSuspend)							"not need handle version"
		(89 primitiveFlushCache)						"not need handle version"

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)						"not need handle version"
		(91 primitiveTestDisplayDepth)					"not need handle version"
		(92 primitiveSetDisplayMode)					"not need handle version"
		(93 primitiveInputSemaphore)					"not need handle version"
		(94 primitiveGetNextEvent)						"not need handle version"
		(95 primitiveInputWord)						
		(96 primitiveFail)								"not need handle version"
		(97 primitiveSnapshot)							"not need handle version"
		(98 primitiveStoreImageSegment)				"not need handle version"
		(99 primitiveLoadImageSegment)				"not need handle version"
		(100 primitivePerformInSuperclass)				"shadow handle"
		(101 primitiveBeCursor)						"not need handle version"
		(102 primitiveBeDisplay)						"not need handle version"
		(103 primitiveScanCharacters)					
		(104 primitiveFail)	"primitiveDrawLoop"		"not need handle version"
		(105 primitiveStringReplace)			
		(106 primitiveScreenSize)				"not need handle version"
		(107 primitiveMouseButtons)			"not need handle version"
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)			

		"System Primitives (110-119)"
		(110 primitiveHIdentical)		"handle version"
		(111 primitiveHClass)			"handle version"
		(112 primitiveBytesLeft)		"not need handle version"
		(113 primitiveQuit)				"not need handle version"
		(114 primitiveExitToDebugger)	"not need handle version"
		(115 primitiveHChangeClass)	"handle version"
		(116 primitiveFlushCacheByMethod)	"not need handle version"
		(117 primitiveExternalCall)				"not need handle version"
		(118 primitiveDoPrimitiveWithArgs) 	"not need handle version"
		(119 primitiveFlushCacheBySelector)	"not need handle version"
			"Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.
			Both are supported for backward compatibility."

		"Miscellaneous Primitives (120-127)"
		(120 primitiveCalloutToFFI)				"not need handle version"
		(121 primitiveImageName)				"not need handle version"
		(122 primitiveNoop)					"not need handle version"
		(123 primitiveFail)						"not need handle version"
		(124 primitiveLowSpaceSemaphore)	"not need handle version"
		(125 primitiveSignalAtBytesLeft)		"not need handle version"

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)	"not need handle version"
		(127 primitiveShowDisplayRect)		"not need handle version"
		(128 primitiveArrayBecome)			"not need handle version"
		(129 primitiveSpecialObjectsOop)		"not need handle version"
		(130 primitiveFullGC)					"not need handle version"
		(131 primitiveIncrementalGC)			"not need handle version"
		(132 primitiveHObjectPointsTo)		"hum hum"
		(133 primitiveSetInterruptKey)			"not need handle version"
		(134 primitiveInterruptSemaphore)		"not need handle version"
		(135 primitiveMillisecondClock)			"not need handle version"
		(136 primitiveSignalAtMilliseconds)		"not need handle version"
		(137 primitiveSecondsClock)			"not need handle version"
		(138 primitiveSomeObject)				" hum hum"
		(139 primitiveNextObject)				" hum hum"
		(140 primitiveBeep)					"not need handle version"
		(141 primitiveClipboardText)			"not need handle version"
		(142 primitiveVMPath)					"not need handle version"
		(143 primitiveShortAt)					"hum hum"
		(144 primitiveShortAtPut)				"hum hum"
		(145 primitiveConstantFill)				"hum hum"
		"NOTE: When removing the obsolete indexed primitives,
		the following two should go become #primitiveIntegerAt / atPut"
		(146 primitiveFail)						"not need handle version"
		(147 primitiveFail)						"not need handle version"
		(148 primitiveClone)					"not need handle version"
		(149 primitiveGetAttribute)				"not need handle version"

		"File Primitives (150-169) - NO LONGER INDEXED"
		(150 159 primitiveFail)					"not need handle version"
		(160 primitiveAdoptInstance)			"hum hum"
		(161 primitiveSetIdentityHash)
		(162 164 primitiveFail)					"not need handle version"
		(165 primitiveIntegerAt)				"hum hum"
		(166 primitiveIntegerAtPut)				"hum hum"
		(167 primitiveYield)						"hum hum"
		(168 primitiveCopyObject)				"not need handle version"
		(169 primitiveFail)						"not need handle version"

		"Sound Primitives (170-199) - NO LONGER INDEXED"
		(170 174 primitiveFail)

		"CogMemoryManager primitives"
		(175 primitiveBehaviorHash)			"not need handle version"	
		(176 primitiveMaxIdentityHash)			"not need handle version"
		(177 184 primitiveFail)					"not need handle version"

		"CriticalSection primitives"
		(185 primitiveExitCriticalSection)		"not need handle version"
		(186 primitiveEnterCriticalSection) 		"not need handle version"
		(187 primitiveTestAndSetOwnershipOfCriticalSection) "not need handle version"

		"Perform method directly"
		(188 primitiveExecuteMethodArgsArray) 		"shadow handle"
		(189 primitiveExecuteMethod)					"shadow handle"

		"Sound Primitives (continued) - NO LONGER INDEXED"
		(190 194 primitiveFail)					 "not need handle version"

		"Unwind primitives"
		(195 primitiveFindNextUnwindContext)	"not need handle version"
		(196 primitiveTerminateTo)				 "not need handle version"
		(197 primitiveFindHandlerContext)		 "not need handle version"
		(198 primitiveMarkUnwindMethod)		 "not need handle version"
		(199 primitiveMarkHandlerMethod)		 "not need handle version"

		"new closure primitives (were Networking primitives)"
		(200 primitiveClosureCopyWithCopiedValues)	 			"not need handle version"
		(201 primitiveClosureValue)  								"not need handle version"
		(202 primitiveClosureValue)  								"not need handle version"
		(203 primitiveClosureValue) 								"not need handle version"
		(204 primitiveClosureValue) 								"not need handle version"
		(205 primitiveClosureValue)								"not need handle version"
		(206 primitiveClosureValueWithArgs) 	 					"not need handle version"

		(207 209 primitiveFail)	"reserved for Cog primitives"

		(210 primitiveContextAt)								"hum hum"
		(211 primitiveContextAtPut)							"hum hum"
		(212 primitiveContextSize)								"hum hum"
		(213 primitiveContextXray)								"hum hum"
		(214 primitiveVoidVMState)								"not need handle version"
		(215 217 primitiveFail)	"reserved for Cog primitives"	"not need handle version"
		(218 primitiveDoNamedPrimitiveWithArgs)				"hum hum"
		(219 primitiveFail)										"not need handle version"
		(220 primitiveFail)										"not need handle version"

		(221 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch"	"not need handle version"
		(222 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch:" "not need handle version"

		(223 229 primitiveFail)	"not need handle version"

		(230 primitiveRelinquishProcessor)												"not need handle version"
		(231 primitiveForceDisplayUpdate)												"not need handle version"
		(232 primitiveFormPrint)														"not need handle version"
		(233 primitiveSetFullScreen)													"not need handle version"
		(234 primitiveFail) "primBitmapdecompressfromByteArrayat"					"not need handle version"
		(235 primitiveFail) "primStringcomparewithcollated"							"not need handle version"
		(236 primitiveFail) "primSampledSoundconvert8bitSignedFromto16Bit"			"not need handle version"
		(237 primitiveFail) "primBitmapcompresstoByteArray"							"not need handle version"
		(238 239 primitiveFail) "serial port primitives"									"not need handle version"
		(240 primitiveUTCMicrosecondClock)											"not need handle version"
		(241 primitiveLocalMicrosecondClock)											"not need handle version"
		(242 primitiveSignalAtUTCMicroseconds)										"not need handle version"
		(243 primitiveUpdateTimezone) "primStringtranslatefromtotable"				"not need handle version"
		(244 primitiveFail) "primStringfindFirstInStringinSetstartingAt"					"not need handle version"
		(245 primitiveFail) "primStringindexOfAsciiinStringstartingAt"					"not need handle version"
		(246 primitiveFail) "primStringfindSubstringinstartingAtmatchTable"				"not need handle version"
		(247 primitiveSnapshotEmbedded)												"not need handle version"
		(248 primitiveFail) "primitiveInvokeObjectAsMethod"							"not need handle version"
		(249 primitiveArrayBecomeOneWayCopyHash)									"hum hum"

		"VM Implementor Primitives (250-255)"
		(250 primitiveClearVMProfile)													"not need handle version"
		(251 primitiveControlVMProfiling)												"not need handle version"
		(252 primitiveVMProfileSamplesInto)											"not need handle version"
		(253 primitiveFail )																"not need handle version"
		(254 primitiveVMParameter)													"not need handle version"
		(255 primitiveFail) 																"not need handle version"

		"Quick Push Const Methods"
		(256 nil) "primitivePushSelf"													"handle version"
		(257 nil) "primitivePushTrue"													"not need handle version"
		(258 nil) "primitivePushFalse"													"not need handle version"
		(259 nil) "primitivePushNil"														"not need handle version"
		(260 nil) "primitivePushMinusOne"												"not need handle version"
		(261 nil) "primitivePushZero"													"not need handle version"
		(262 nil) "primitivePushOne"													"not need handle version"
		(263 nil) "primitivePushTwo"													"not need handle version"

		"Quick Push Inst Var Methods"
		(264 519 nil) "primitiveLoadInstVar"											 "Handle"

		(520 primitiveFail)
		"MIDI Primitives (521-539) - NO LONGER INDEXED"
		(521 529 primitiveFail)						 "not need handle version"
		(530 539 primitiveFail)  					 "not need handle version"

		"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
		"Pen Tablet Primitives - NO LONGER INDEXED"
		(540 549 primitiveFail)						 "not need handle version"

		"Sound Codec Primitives - NO LONGER INDEXED"
		(550 569 primitiveFail)						 "not need handle version"

		"External primitive support primitives"
		(570 primitiveFlushExternalPrimitives)		 "not need handle version"
		(571 primitiveUnloadModule)				 "not need handle version"
		(572 primitiveListBuiltinModule)				 "not need handle version"
		(573 primitiveListExternalModule)			 "not need handle version"
		(574 primitiveFail) 							 "not need handle version"
		"Unassigned Primitives"
		(575 primitiveFail)							 "not need handle version")! !

!HSCStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
requiredMethodNames
	^super requiredMethodNames addAll: self hPrimitiveTable; yourself! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode identity' stamp: 'jb 10/25/2011 18:41'!
bytecodePrimClass
	| rcvr |
	rcvr := self internalStackTop.
	(self internalIsHandle: rcvr)
		ifTrue:[self internalStackTopPut: (self handleInlineClassLookupOf: rcvr)]
		ifFalse:[self internalStackTopPut: (objectMemory fetchClassOf: rcvr).].
	self fetchNextBytecode.
! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode identity' stamp: 'jb 10/25/2011 17:15'!
bytecodePrimEquivalent

	| rcvr arg |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self internalIsHandle: arg)
		ifTrue:[arg :=  (self handleInlineReceiverOf: arg).].
	(self internalIsHandle: rcvr)
		ifTrue:[rcvr :=  (self handleInlineReceiverOf: rcvr).].
	self booleanCheat: rcvr = arg.! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/11/2011 17:39'!
commonHAt: stringy
	| index rcvr atIx result rcvr1 |
	self initPrimCall.
	rcvr1 := self stackValue: 1.
	(self handleInlineUseState: rcvr1) 
	ifTrue: [
		rcvr := self handleInlineCloneOf: rcvr1.]
	ifFalse: [
		rcvr := self handleInlineReceiverOf: rcvr1.].
	
	index := self stackTop.
	index := objectMemory integerValueOf: index.

	self initPrimCall.
	result := self stObject: rcvr at: index.
	self successful ifTrue:
		[stringy ifTrue: [result := self characterForAscii: (objectMemory integerValueOf: result)]].
		
	self pop: argumentCount + 1.
	(self handleInlineUsePropagation: rcvr1) 
		ifTrue: [ self pushHandle: rcvr1 propagateValue: result.] 
		ifFalse:[ self push: result].
		
! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/7/2011 18:00'!
commonHAtPut: stringy
	| value index rcvr atIx |
	value := self stackTop.
	self initPrimCall.
	rcvr := self stackValue: 2.
	(self handleInlineUseState: rcvr) 
	ifTrue: [
		rcvr := (self handleInlineCloneOf: rcvr).]
	ifFalse: [
		rcvr := self handleInlineReceiverOf: rcvr.].
	index := self stackValue: 1.
	(objectMemory isIntegerObject: index) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	index := objectMemory integerValueOf: index.

	self initPrimCall.
	stringy
		ifTrue: [self stObject: rcvr at: index put: (self asciiOfCharacter: value)]
		ifFalse: [self stObject: rcvr at: index put: value].
	self successful ifTrue:
		[^ self pop: argumentCount+1 thenPush: value]! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 10/7/2011 18:40'!
extendedStoreBytecode
	| descriptor variableType variableIndex association rcvr |
	<inline: true>
	descriptor := self fetchByte.
	self fetchNextBytecode.
	rcvr :=  self receiver.
	(self internalIsHandle: rcvr) ifTrue:[ 
		(self handleInlineUseState: rcvr) 
			ifTrue: [
				rcvr := (self handleInlineCloneOf: rcvr).]
			ifFalse: [
				rcvr := self handleInlineReceiverOf: rcvr.]].
	
	variableType := descriptor >> 6 bitAnd: 3.
	variableIndex := descriptor bitAnd: 63.
	variableType = 0 ifTrue:
		[^objectMemory storePointer: variableIndex ofObject: rcvr withValue: self internalStackTop].
	variableType = 1 ifTrue:
		[^self temporary: variableIndex in: localFP put: self internalStackTop].
	variableType = 3 ifTrue:
		[association := self literal: variableIndex.
		 ^objectMemory storePointer: ValueIndex ofObject: association withValue: self internalStackTop].
	self error: 'illegal store'.
	^nil! !

!HSCStackInterpreterPrimitives methodsFor: 'support hprimitive table' stamp: 'jb 10/7/2011 17:11'!
hFunctionPointerFor: primIdx inClass: theClass
	"Find an actual function pointer for this primitiveIndex.  This is an
	opportunity to specialise the prim for the relevant class (format for
	example).  Default for now is simply the entry in the base primitiveTable."

	<returnTypeC: 'void (*hFunctionPointerForinClass(sqInt primIdx,sqInt theClass))(void)'>
	^primIdx > MaxPrimitiveIndex ifTrue: [0] ifFalse: [hPrimitiveTable at: primIdx]! !

!HSCStackInterpreterPrimitives methodsFor: 'support behavior' stamp: 'jb 1/4/2012 16:18'!
hInternalQuickPrimitiveResponse
	"Called under the assumption that primFunctionPtr has been preloaded"
	<inline:true>
	| localPrimIndex rcvr |
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HSCStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 1/4/2012 16:01'!
hPushReceiverVariable: fieldIndex on: receiver
	<inline:true>
	
	(self handleInlineUsePropagation: receiver)
	ifTrue: [
		self pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: receiver]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: receiver].
! !

!HSCStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 10/7/2011 17:11'!
initializeHandle: handleInstance withReceiver: value andShadowClass: handle
		<inline:true>
		objectMemory storePointer: 0 ofObject: handleInstance withValue: value. 
		objectMemory storePointer: 1 ofObject: handleInstance withValue: handle.
		objectMemory storePointer: 3 ofObject: handleInstance withValue: (objectMemory integerObjectOf:6).
	! !

!HSCStackInterpreterPrimitives methodsFor: 'support behavior' stamp: 'jb 2/1/2012 18:59'!
internalExecuteNewMethod
	| succeeded primitiveIndex rcvr |
	<inline: true>
	rcvr := self internalStackValue: argumentCount.
	(self internalIsHandle: rcvr) 
	ifTrue: [
		primitiveIndex := self primitiveIndexOf: newMethod.
		primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
		primitiveFunctionPointer ~~ 0 ifTrue: [
			self isPrimitiveFunctionPointerAnIndex ifTrue:[
				^self hInternalQuickPrimitiveResponse].
			self externalizeIPandSP.
			succeeded := self slowPrimitiveResponse.
			self internalizeIPandSP.
			succeeded ifTrue:
				[self browserPluginReturnIfNeeded.
				^nil].
		]]

	ifFalse: [
		primitiveFunctionPointer ~~ 0 ifTrue:
			[self isPrimitiveFunctionPointerAnIndex ifTrue:
				[^self internalQuickPrimitiveResponse].
			self externalizeIPandSP.
			 succeeded := self slowPrimitiveResponse.
			 self internalizeIPandSP.
			 succeeded ifTrue:
				[self browserPluginReturnIfNeeded.
				^nil]]].
		"if not primitive, or primitive failed, activate the method"
		^self internalActivateNewMethod.
	
	

! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 10/18/2011 16:59'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	"<sharedCodeNamed: 'normalSend' inCase: 131>"
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend
					.
	
! !

!HSCStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 10/7/2011 17:11'!
primitiveHAdoptInstance
	"Primitive. Change the class of the argument to make it an instance of the receiver
	 given that the format of the receiver matches the format of the argument's class.
	 Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a
	 compact class and the argument isn't, or when the argument's class is compact and
	 the receiver isn't, or when the format of the receiver is different from the format of
	 the argument's class, or when the arguments class is fixed and the receiver's size
	 differs from the size that an instance of the argument's class should have."
	^self primitiveFail! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 1/4/2012 15:24'!
primitiveHAt
	self commonHAt: false.! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/7/2011 17:11'!
primitiveHAtPut

	self commonHAtPut: false.! !

!HSCStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 10/7/2011 17:11'!
primitiveHChangeClass
	"Primitive. Change the class of the receiver into the class of the argument given that the format of the receiver matches the format of the argument's class. Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a compact class and the argument isn't, or when the argument's class is compact and the receiver isn't, or when the format of the receiver is different from the format of the argument's class, or when the arguments class is fixed and the receiver's size differs from the size that an instance of the argument's class should have."
	^self primitiveFail
	! !

!HSCStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 2/1/2012 18:20'!
primitiveHClass
	| instance |
	
	<inline: true>
	instance := self stackTop.
	self pop: argumentCount+1 thenPush: (self handleInlineClassLookupOf: instance).

	! !

!HSCStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 10/7/2011 17:11'!
primitiveHExecuteMethod
	"receiver, args, then method are on top of stack. Execute method against receiver and args.
	 Set primitiveFunctionPointer because no cache lookup has been done for the method, and
	 hence primitiveFunctionPointer is stale."
	| methodArgument primitiveIndex |
	methodArgument := self stackTop.
	(objectMemory isOopCompiledMethod: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argumentCount - 1 = (self argumentCountOf: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	newMethod := self popStack.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argumentCount - 1.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HSCStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 10/7/2011 17:11'!
primitiveHExecuteMethodArgsArray
	"receiver, argsArray, then method are on top of stack.  Execute method against
	 receiver and args.  Allow for up to two extra arguments (e.g. for mirror primitives).
	 Set primitiveFunctionPointer because no cache lookup has been done for the
	 method, and hence primitiveFunctionPointer is stale."
	| methodArgument argCnt argumentArray primitiveIndex |
	methodArgument := self stackTop.
	argumentArray := self stackValue: 1.
	((objectMemory isOopCompiledMethod: methodArgument)
	 and: [objectMemory isArray: argumentArray]) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argCnt := self argumentCountOf: methodArgument.
	argCnt = (objectMemory fetchWordLengthOf: argumentArray) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	argumentCount > 2 ifTrue: "CompiledMethod class>>receiver:withArguments:executeMethod:
								SqueakObjectPrimitives class >> receiver:withArguments:apply:
								VMMirror>>ifFail:object:with:executeMethod: et al"
		[argumentCount > 4 ifTrue:
			[^self primitiveFailFor: PrimErrUnsupported].
		self stackValue: argumentCount put: (self stackValue: 2)]. "replace actual receiver with desired receiver"
	"and push the actual arguments"
	self pop: argumentCount.
	0 to: argCnt - 1 do:
		[:i|
		self push: (objectMemory fetchPointer: i ofObject: argumentArray)].
	newMethod := methodArgument.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argCnt.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HSCStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/25/2011 18:18'!
primitiveHIdentical
	"is the receiver/first argument the same object as the (last) argument?.
	 pop argumentCount because this can be used as a mirror primitive."
	| thisObject otherObject |
	
	otherObject := self stackValue: 1.
	thisObject := self stackTop.
	self print: 'handle Identity ##############################';cr.
	otherObject :=  self handleInlineReceiverOf: otherObject.
	(self internalIsHandle: thisObject) ifTrue: [thisObject :=  (self handleInlineReceiverOf: thisObject)]. 
	self pop: argumentCount + 1 thenPushBool: thisObject = otherObject.! !

!HSCStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/7/2011 17:11'!
primitiveHIdentityHash
	| thisReceiver |
	thisReceiver := self stackTop.
	thisReceiver := self handleInlineReceiverOf: thisReceiver.
	(objectMemory isIntegerObject: thisReceiver)
		ifTrue: [self primitiveFail]
		ifFalse: [self pop:1 thenPushInteger: (objectMemory hashBitsOf: thisReceiver)]! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/10/2011 14:45'!
primitiveHInstVarAt
	| index rcvr hdr fmt totalLength fixedFields value rcvr1 |
	index := self stackIntegerValue: 0.
	rcvr1 := self stackValue: 1.
	(self handleInlineUseState: rcvr1) 
	ifTrue: [
		rcvr := self handleInlineCloneOf: rcvr1.]
	ifFalse: [
		rcvr := self handleInlineReceiverOf: rcvr1.].
		
	value := objectMemory fetchPointer: (index - 1) ofObject: rcvr.

	self pop: argumentCount + 1.
	(self handleInlineUsePropagation: rcvr1) 
		ifTrue: [ self pushHandle: rcvr1 propagateValue: value.] 
		ifFalse:[ self push: value].
		
	! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/7/2011 18:01'!
primitiveHInstVarAtPut
	| newValue index rcvr hdr fmt totalLength fixedFields |
	newValue := self stackTop.
	index := self stackIntegerValue: 1.
	rcvr := self stackValue: 2.
	
	(self handleInlineUseState: rcvr) 
	ifTrue: [
		rcvr := (self handleInlineCloneOf: rcvr).]
	ifFalse: [
		rcvr := self handleInlineReceiverOf: rcvr.].
	
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	hdr := objectMemory baseHeader: rcvr.
	fmt := objectMemory formatOfHeader: hdr.
	totalLength := objectMemory lengthOf: rcvr baseHeader: hdr format: fmt.
	fixedFields := objectMemory fixedFieldsOf: rcvr format: fmt length: totalLength.
	(index >= 1 and: [index <= fixedFields]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	(fmt = 3
	 and: [objectMemory isContextHeader: hdr])
		ifTrue: [self externalInstVar: index - 1 ofContext: rcvr put: newValue]
		ifFalse: [self subscript: rcvr with: index storing: newValue format: fmt].
	self pop: argumentCount + 1 thenPush: newValue! !

!HSCStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 11/9/2011 15:17'!
primitiveHNew
	"Allocate a new fixed-size instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free. May cause a GC"
	|  handle hClass spaceOkay value handleInstance |
	
	self print: 'primitiveHNew';cr.
	handle := self popStack.
	hClass := self  handleInlineReceiverOf: handle.
	spaceOkay := self sufficientSpaceToInstantiate: hClass indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [value := objectMemory instantiateClass: hClass indexableSize: 0].
	spaceOkay := self sufficientSpaceToInstantiate: (self classHandleInline) indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [handleInstance :=  objectMemory instantiateClass: (self classHandleInline) indexableSize: 0.].
	self initializeHandle: handleInstance withReceiver: value andShadowClass: handle.
	self push: handleInstance.! !

!HSCStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 11/9/2011 15:20'!
primitiveHNewWithArg
	"Allocate a new indexable instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free."
	
	| size handle tClass spaceOkay tObject handleInstance |
	self print: 'primitiveHNewWithArg';cr.
	size := self positive32BitValueOf: self stackTop.
	handle := self stackValue: 1.
	self pop:2.
	tClass := self  handleInlineReceiverOf: handle.
	spaceOkay := self sufficientSpaceToInstantiate: tClass indexableSize: size.
	self success: spaceOkay.
	self successful ifTrue: [tObject := objectMemory instantiateClass: tClass indexableSize: size].
	spaceOkay := self sufficientSpaceToInstantiate: (self classHandleInline) indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [handleInstance :=  objectMemory instantiateClass: (self classHandleInline) indexableSize: 0.].
	self initializeHandle: handleInstance withReceiver: tObject andShadowClass: handle.
	self push: handleInstance.

! !

!HSCStackInterpreterPrimitives methodsFor: 'prim fixed field' stamp: 'jb 10/7/2011 18:01'!
primitiveHObjectAt
"Defined for CompiledMethods only"
	| thisReceiver index |
	index  := self stackIntegerValue: 0.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 1.
	
		(self handleInlineUseState: thisReceiver) 
	ifTrue: [
		thisReceiver := (self handleInlineCloneOf: thisReceiver).]
	ifFalse: [
		thisReceiver := self handleInlineReceiverOf: thisReceiver.].
	
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	self pop: 2 thenPush: (objectMemory fetchPointer: index - 1 ofObject: thisReceiver)! !

!HSCStackInterpreterPrimitives methodsFor: 'prim fixed field' stamp: 'jb 10/7/2011 18:01'!
primitiveHObjectAtPut
"Defined for CompiledMethods only"
	| thisReceiver index newValue |
	newValue := self stackValue: 0.
	index := self stackIntegerValue: 1.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 2.
	(self handleInlineUseState: thisReceiver) 
	ifTrue: [
		thisReceiver := (self handleInlineCloneOf: thisReceiver).]
	ifFalse: [
		thisReceiver := self handleInlineReceiverOf: thisReceiver.].
	
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	objectMemory storePointer: index - 1 ofObject: thisReceiver withValue: newValue.
	self pop: 3 thenPush: newValue! !

!HSCStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 10/7/2011 17:11'!
primitiveHObjectPointsTo
	"This primitive is assumed to be fast (see e.g. MethodDictionary>>includesKey:) so make it so.
	 N.B.  Written to use literalHeaderOf: so that in Cog subclasses cogged methods (whose headers
	 point to the machine code method) are still correctly scanned, for the header as well as literals."
	| rcvr thang header fmt lastField methodHeader |
	thang := self stackTop.
	rcvr := self stackValue: 1.
	(objectMemory isIntegerObject: rcvr) ifTrue:
		[^self pop: 2 thenPushBool: false].

	"Inlined version of lastPointerOf: for speed in determining if rcvr is a context."
	header := objectMemory baseHeader: rcvr.
	fmt := objectMemory formatOfHeader: header.
	fmt <= 4
		ifTrue:
			[(fmt = 3
			  and: [objectMemory isContextHeader: header]) 
				ifTrue:
	 				[(self isMarriedOrWidowedContext: rcvr) ifTrue:
						[self externalWriteBackHeadFramePointers.
						 (self isStillMarriedContext: rcvr) ifTrue:
							[^self pop: 2
									thenPushBool: (self marriedContext: rcvr
														pointsTo: thang
														stackDeltaForCurrentFrame: 2)]].
					"contexts end at the stack pointer"
					lastField := CtxtTempFrameStart + (self fetchStackPointerOf: rcvr) * BytesPerWord]
				ifFalse:
					[lastField := (objectMemory sizeBitsOfSafe: rcvr) - BaseHeaderSize]]
		ifFalse:
			[fmt < 12 "no pointers" ifTrue:
				[^self pop: 2 thenPushBool: false].
			"CompiledMethod: contains both pointers and bytes:"
			methodHeader := self headerOf: rcvr.
			methodHeader = thang ifTrue: [^self pop: 2 thenPushBool: true].
			lastField := ((self literalCountOfHeader: methodHeader) + 1) * BytesPerWord].

	BaseHeaderSize to: lastField by: BytesPerWord do:
		[:i |
		(self longAt: rcvr + i) = thang ifTrue:
			[^self pop: 2 thenPushBool: true]].
	self pop: 2 thenPushBool: false! !

!HSCStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 10/7/2011 17:11'!
primitiveHPerform
	<returnTypeC: #void>
	| performSelector newReceiver lookupClass performMethod |
	performSelector := messageSelector.
	performMethod := newMethod.
	messageSelector := self stackValue: argumentCount - 1.
	newReceiver := self stackValue: argumentCount.

	"NOTE: the following lookup may fail and be converted to #doesNotUnderstand:,
	 so we must adjust argumentCount and slide args now, so that will work."

	"Slide arguments down over selector"
	argumentCount := argumentCount - 1.
	argumentCount to: 1 by: -1 do:
		[:i|
		stackPages
			longAt: stackPointer + (i * BytesPerWord)
			put: (stackPages longAt: stackPointer + ((i - 1) * BytesPerWord))].
	self pop: 1.
	lookupClass := objectMemory fetchClassOf: newReceiver.
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: newReceiver.
	self findNewMethodInClass: lookupClass.

	"Only test CompiledMethods for argument count - other objects will have to take their chances"
	((objectMemory isOopCompiledMethod: newMethod)
	  and: [(self argumentCountOf: newMethod) = argumentCount]) ifFalse:
		["Slide the args back up (sigh) and re-insert the selector."
		self unPop: 1.
		1 to: argumentCount by: 1 do:
			[:i |
			stackPages longAt: stackPointer + ((i - 1) * BytesPerWord)
				put: (stackPages longAt: stackPointer + (i * BytesPerWord))].
		stackPages longAt: stackPointer + (argumentCount * BytesPerWord) put: messageSelector.
		argumentCount := argumentCount + 1.
		newMethod := performMethod.
		messageSelector := performSelector.
		^self primitiveFail].

	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HSCStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 10/7/2011 17:11'!
primitiveHPerformInSuperclass
	| lookupClass rcvr currentClass |
	lookupClass := self stackTop.
	rcvr := self stackValue: 3.
	currentClass := objectMemory fetchClassOf: rcvr.
	[currentClass ~= lookupClass] whileTrue:
		[currentClass := self superclassOf: currentClass.
		 currentClass = objectMemory nilObject ifTrue: [^self primitiveFailFor: PrimErrBadArgument]].

	self primitiveObject: rcvr "a.k.a. self stackValue: 3"
		perform: (self stackValue: 2)
		withArguments: (self stackValue: 1)
		lookedUpIn: lookupClass "a.k.a. self stackTop"! !

!HSCStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 10/7/2011 17:11'!
primitiveHPerformWithArgs

	| lookupClass rcvr |
	rcvr := self stackValue: 2.
	lookupClass := objectMemory fetchClassOf: rcvr.

	self primitiveObject: rcvr "a.k.a. self stackValue: 2"
		perform: (self stackValue: 1)
		withArguments: self stackTop
		lookedUpIn: lookupClass! !

!HSCStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/7/2011 17:11'!
primitiveHSize
	| rcvr hdr fmt fixedFields totalLength |
	rcvr := self stackTop.
	rcvr := self handleInlineReceiverOf: rcvr.
	((objectMemory isIntegerObject: rcvr) "Integers are not indexable"
	 or: [hdr := objectMemory baseHeader: rcvr.
		(fmt := objectMemory formatOfHeader: hdr) < 2]) "This is not an indexable object"
		ifTrue:
			[^self primitiveFailFor: PrimErrBadReceiver].
	(fmt = 3 and: [objectMemory isContextHeader: hdr]) ifTrue:
		[^self primitiveContextSize].
	totalLength := objectMemory lengthOf: rcvr baseHeader: hdr format: fmt.
	fixedFields := objectMemory fixedFieldsOf: rcvr format: fmt length: totalLength.
	self pop: argumentCount + 1 thenPush: (objectMemory integerObjectOf: totalLength - fixedFields)! !

!HSCStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/26/2011 13:17'!
primitiveIdentical
"is the receiver the same object as the argument?
In case of handle we should check for all object other object to"
	| thisObject otherObject | 
	otherObject := self popStack.
	thisObject := self stackValue:1.
	
	(self internalIsHandle: otherObject)
		ifTrue:[otherObject :=  (self handleInlineReceiverOf: otherObject).].
	(self internalIsHandle: thisObject)
		ifTrue:[thisObject :=  (self handleInlineReceiverOf: thisObject).].
	self pushBool: thisObject = otherObject! !

!HSCStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/25/2011 18:25'!
primitiveSameObject
	<export:true>
	"is the receiver/first argument the same object as the (last) argument?.
	 pop argumentCount because this can be used as a mirror primitive."
	| thisObject otherObject |
	otherObject := self stackValue: 1.
	thisObject := self stackTop.
	self pop: argumentCount + 1 thenPushBool: thisObject = otherObject! !

!HSCStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 10/11/2011 15:52'!
pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle
| value |
<inline: true>
(self handleUseState: aHandle) 
	ifTrue: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleCloneOf: aHandle).]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleReceiverOf: aHandle).].
	localIP := localIP -1.
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	self fetchNextBytecode
! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode self wrapping' stamp: 'jb 10/7/2011 17:11'!
pushReceiverBytecode

	| rcvr |
	self fetchNextBytecode.
	rcvr := self receiver.
	((self internalIsHandle: rcvr) and: [(self handleInlineUseSelfWrapping: rcvr) not] )ifTrue:  [
		 self internalPush: (self handleInlineReceiverOf: rcvr).]
	ifFalse:[self internalPush: rcvr.].
	! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 1/4/2012 16:00'!
pushReceiverVariable: fieldIndex

	| rcvr value |
	rcvr := self receiver.
	(self internalIsHandle: rcvr) ifTrue:[ 
		self hPushReceiverVariable: fieldIndex on: rcvr]
	ifFalse: [
		value := (objectMemory fetchPointer: fieldIndex ofObject: rcvr ).
		self internalPush: value]! !

!HSCStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 10/7/2011 18:01'!
pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  |
<inline:true>
(self handleInlineUseState: aHandle) 
	ifTrue: [
				self  internalPush: (objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineCloneOf: aHandle))]
	ifFalse: [
				self  internalPush: (objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle))].
		
! !

!HSCStackInterpreterPrimitives methodsFor: 'support propagation' stamp: 'jb 10/7/2011 18:01'!
quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
<inline: true>
(self handleInlineUseState: aHandle) 
	ifTrue: [value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineCloneOf: aHandle).]
	ifFalse: [value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle).].
	"localIP := localIP -1."
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	"self fetchNextBytecode"
! !

!HSCStackInterpreterPrimitives methodsFor: 'support propagation' stamp: 'jb 10/7/2011 17:11'!
quickPushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
<inline: true>
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].

	! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 10/7/2011 17:11'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend.
					.
	
! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 10/7/2011 17:11'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].	
	 self commonSend.
					.
	
! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 10/7/2011 17:11'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].	
	self commonSend.
					.
	
! !

!HSCStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 10/7/2011 18:40'!
storeAndPopReceiverVariableBytecode
	"Note: This code uses 
	storePointerUnchecked:ofObject:withValue: and does the 
	store check explicitely in order to help the translator 
	produce better code."
	| rcvr top |
	rcvr := self receiver.
	top := self internalStackTop.
	(self internalIsHandle: rcvr) ifTrue:[ 
		(self handleInlineUseState: rcvr) 
			ifTrue: [
				rcvr := (self handleInlineCloneOf: rcvr).]
			ifFalse: [
				rcvr := self handleInlineReceiverOf: rcvr.]].
	(self oop: rcvr isLessThan: objectMemory youngStart) ifTrue:
		[objectMemory possibleRootStoreInto: rcvr value: top].
	objectMemory storePointerUnchecked: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top.
	self fetchNextBytecode.
	self internalPop: 1! !

HSCStackInterpreterPrimitives subclass: #HSCStackInterpreterPrimitivesStateManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-SmartCloneInterpreter'!

HSCStackInterpreterPrimitivesStateManagement subclass: #HSCStackInterpreterPrimitivesBytecodeHack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-SmartCloneInterpreterExperiment'!

!HSCStackInterpreterPrimitivesBytecodeHack class methodsFor: 'as yet unclassified' stamp: 'jb 1/18/2012 12:14'!
initialize
	"self initialize"
	super initialize.
	self initializeSecondBytecodeTable.! !

!HSCStackInterpreterPrimitivesBytecodeHack class methodsFor: 'as yet unclassified' stamp: 'jb 1/19/2012 17:06'!
initializeSecondBytecodeTable
	
	SecondBytecodeTable := Array new: 256.
	self table: SecondBytecodeTable from:
	{
		#(  0  15 unknownBytecode).
		#( 16  31 pushHTemporaryVariableBytecode).
		#( 32  63 unknownBytecode).
		#( 64  95 unknownBytecode).
		#( 96 103 unknownBytecode).
		#(104 111 unknownBytecode).
		#(112 unknownBytecode).
		#(113 unknownBytecode).
		#(114 unknownBytecode).
		#(115 unknownBytecode).
		#(116 unknownBytecode).
		#(117 unknownBytecode).
		#(118 unknownBytecode).
		#(119 unknownBytecode).
		#(120 unknownBytecode).
		#(121 unknownBytecode).
		#(122 unknownBytecode).
		#(123 unknownBytecode).
		#(124 returnHTopFromMethod).
		#(125 unknownBytecode).

		"Newspeak bytecodes"
		#( 126 unknownBytecode).
		#( 127 unknownBytecode).

		#(128 unknownBytecode).
		#(129 unknownBytecode).
		#(130 unknownBytecode).
		#(131 unknownBytecode).
		#(132 unknownBytecode).
		#(133 unknownBytecode).
		#(134 unknownBytecode).
		#(135 unknownBytecode).
		#(136 unknownBytecode).

		#(137 unknownBytecode).
		"Closure & Newspeak bytecodes"
		#(138 unknownBytecode).
		#(139 unknownBytecode ).
		#(140 unknownBytecode).
		#(141 unknownBytecode).
		#(142 unknownBytecode).
		#(143 unknownBytecode).

		#(144 151 unknownBytecode).
		#(152 159 unknownBytecode).
		#(160 167 unknownBytecode).
		#(168 171 unknownBytecode).
		#(172 175 unknownBytecode).

		"176-191 were sendArithmeticSelectorBytecode"
		#(176 unknownBytecode).
		#(177 unknownBytecode).
		#(178 unknownBytecode).
		#(179 unknownBytecode).
		#(180 unknownBytecode).
		#(181 unknownBytecode).
		#(182 unknownBytecode).
		#(183 unknownBytecode).
		#(184 unknownBytecode).
		#(185 unknownBytecode).
		#(186 unknownBytecode).
		#(187 unknownBytecode).
		#(188 unknownBytecode).
		#(189 unknownBytecode).
		#(190 unknownBytecode).
		#(191 unknownBytecode).	

		"192-207 were sendCommonSelectorBytecode"
		#(192 unknownBytecode).
		#(193 unknownBytecode).
		#(194 unknownBytecode).
		#(195 unknownBytecode).
		#(196 unknownBytecode).
		#(197 unknownBytecode).
		#(198 unknownBytecode).
		#(199 unknownBytecode).
		#(200 unknownBytecode).
		#(201 unknownBytecode).
		#(202 unknownBytecode).
		#(203 unknownBytecode).
		#(204 unknownBytecode).
		#(205 unknownBytecode).
		#(206 unknownBytecode).
		#(207 unknownBytecode).

		#(208 223 unknownBytecode).
		#(224 239 unknownBytecode).
		#(240 255 unknownBytecode).
	}! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'try' stamp: 'jb 1/19/2012 17:28'!
baseHFrameReturn
	| contextToReturnTo isAContext theFP theSP thePage frameAbove |
	<var: #theFP type: #'char *'>
	<var: #theSP type: #'char *'>
	<var: #thePage type: #'StackPage *'>
	<var: #frameAbove type: #'char *'>
	contextToReturnTo := self frameCallerContext: localFP.
	isAContext := self isContext: contextToReturnTo.
	(isAContext
	 and: [self isStillMarriedContext: contextToReturnTo])
		ifTrue:
			[theFP := self frameOfMarriedContext: contextToReturnTo.
			 thePage := stackPages stackPageFor: theFP.
			 theFP = thePage headFP
				ifTrue:
					[theSP := thePage headSP.
					 stackPages freeStackPageNoAssert: stackPage "for a short time invariant is violated; assert follows"]
				ifFalse:
					["Returning to some interior frame, presumably because of a sender assignment.
					  Move the frames above to another page (they may be in use, e.g. via coroutining).
					  Make the interior frame the top frame."
					 frameAbove := self findFrameAbove: theFP inPage: thePage.
					 "Reuse the page we're exiting, which avoids allocating a new page and
					  manipulating the page list to mark the page we're entering as least recently
					  used (to avoid it being deallocated when allocating a new page)."
					 self moveFramesIn: thePage through: frameAbove toPage: stackPage.
					 theFP := thePage headFP.
					 theSP := thePage headSP]]
		ifFalse:
			[(isAContext
			  and: [objectMemory isIntegerObject: (objectMemory fetchPointer: InstructionPointerIndex ofObject: contextToReturnTo)]) ifFalse:
				[^self internalCannotReturn: localReturnValue].
			 thePage := self makeBaseFrameFor: contextToReturnTo.
			 theFP := thePage headFP.
			 theSP := thePage headSP.
			 stackPages freeStackPageNoAssert: stackPage "for a short time invariant is violated; assert follows"].
	self setStackPageAndLimit: thePage.
	self assert: (stackPages stackPageFor: theFP) = stackPage.
	localSP := theSP.
	localFP := theFP.
	self setMethod: (self frameMethod: localFP).
	localIP := self pointerForOop: self internalStackTop.
	self internalStackTopPut: localReturnValue.
	self assert: (self checkIsStillMarriedContext: contextToReturnTo currentFP: localFP).
	^self fetchNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:47'!
bytecodeHPrimAdd
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [result := (objectMemory integerValueOf: rcvr) + (objectMemory integerValueOf: arg).
				(objectMemory isIntegerValue: result) ifTrue:
					[self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
					^ self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatAdd: rcvr toArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^ self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 0.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:47'!
bytecodeHPrimAt
	"BytecodePrimAt will only succeed if the receiver is in the atCache.
	Otherwise it will fail so that the more general primitiveAt will put it in the
	cache after validating that message lookup results in a primitive response."
	| index rcvr result atIx |
	index := self internalStackTop.
	rcvr := self internalStackValue: 1.
	((objectMemory isIntegerObject: rcvr) not
	 and: [objectMemory isIntegerObject: index]) ifTrue:
		[atIx := rcvr bitAnd: AtCacheMask.  "Index into atCache = 4N, for N = 0 ... 7"
		(atCache at: atIx+AtCacheOop) = rcvr ifTrue:
			[result := self commonVariable: rcvr at: (objectMemory integerValueOf: index) cacheIndex: atIx.
			 self successful ifTrue:
				[self fetchHNextBytecode.
				^self internalPop: 2 thenPush: result].
			 self initPrimCall]].

	messageSelector := self specialSelector: 16.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:13'!
bytecodeHPrimAtEnd
	messageSelector := self specialSelector: 21.
	argumentCount := 0.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:47'!
bytecodeHPrimAtPut
	"BytecodePrimAtPut will only succeed if the receiver is in the atCache.
	Otherwise it will fail so that the more general primitiveAtPut will put it in the
	cache after validating that message lookup results in a primitive response."
	| index rcvr atIx value |
	value := self internalStackTop.
	index := self internalStackValue: 1.
	rcvr := self internalStackValue: 2.
	((objectMemory isIntegerObject: rcvr) not
	 and: [objectMemory isIntegerObject: index]) ifTrue:
		[atIx := (rcvr bitAnd: AtCacheMask) + AtPutBase.  "Index into atPutCache"
		 (atCache at: atIx+AtCacheOop) = rcvr ifTrue:
			[self commonVariable: rcvr at: (objectMemory integerValueOf: index) put: value cacheIndex: atIx.
			 self successful ifTrue:
				[self fetchHNextBytecode.
				 ^self internalPop: 3 thenPush: value].
			 self initPrimCall]].

	messageSelector := self specialSelector: 17.
	argumentCount := 2.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimBitAnd

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitAnd.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 14.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimBitOr

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitOr.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 15.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimBitShift

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitShift.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 12.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:13'!
bytecodeHPrimBlockCopy

	messageSelector := self specialSelector: 24.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimClass
	| rcvr |
	rcvr := self internalStackTop.
	self internalStackTopPut: (objectMemory fetchClassOf: rcvr).
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimDiv
	| quotient |
	self initPrimCall.
	quotient := self doPrimitiveDiv: (self internalStackValue: 1) by: (self internalStackValue: 0).
	self successful ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: quotient).
		^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 13.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:50'!
bytecodeHPrimDivide
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [rcvr := objectMemory integerValueOf: rcvr.
			arg := objectMemory integerValueOf: arg.
			(arg ~= 0 and: [rcvr \\ arg = 0])
				ifTrue: [result := rcvr // arg.
					"generates C / operation"
					(objectMemory isIntegerValue: result)
						ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
							^ self fetchHNextBytecode"success"]]]
		ifFalse: [self initPrimCall.
			self externalizeIPandSP.
			self primitiveFloatDivide: rcvr byArg: arg.
			self internalizeIPandSP.
			self successful ifTrue: [^ self fetchHNextBytecode"success"]].

	messageSelector := self specialSelector: 9.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:14'!
bytecodeHPrimDo

	messageSelector := self specialSelector: 27.
	argumentCount := 1.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:09'!
bytecodeHPrimEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue: [^self booleanCheat: rcvr = arg].

	self initPrimCall.
	aBool := self primitiveFloatEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 6.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:13'!
bytecodeHPrimEquivalent

	| rcvr arg |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	self booleanCheat: rcvr = arg.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:09'!
bytecodeHPrimGreaterOrEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr >= arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) >= (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatGreaterOrEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 5.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:08'!
bytecodeHPrimGreaterThan
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr > arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) > (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatGreater: rcvr thanArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 3.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:09'!
bytecodeHPrimLessOrEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr <= arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) <= (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatLessOrEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 4.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:08'!
bytecodeHPrimLessThan
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr < arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) < (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatLess: rcvr thanArg: arg.
	self successful ifTrue: [^ self booleanCheat: aBool].

	messageSelector := self specialSelector: 2.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimMakePoint

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveMakePoint.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 11.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimMod
	| mod |
	self initPrimCall.
	mod := self doPrimitiveMod: (self internalStackValue: 1) by: (self internalStackValue: 0).
	self successful ifTrue:
		[self internalPop: 2 thenPush: (objectMemory integerObjectOf: mod).
		^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 10.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:50'!
bytecodeHPrimMultiply
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [rcvr := objectMemory integerValueOf: rcvr.
				arg := objectMemory integerValueOf: arg.
				result := rcvr * arg.
				((arg = 0 or: [(result // arg) = rcvr]) and: [objectMemory isIntegerValue: result])
					ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
							^ self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatMultiply: rcvr byArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^ self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 8.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:14'!
bytecodeHPrimNew

	messageSelector := self specialSelector: 28.
	argumentCount := 0.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:15'!
bytecodeHPrimNewWithArg

	messageSelector := self specialSelector: 29.
	argumentCount := 1.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:12'!
bytecodeHPrimNext
	messageSelector := self specialSelector: 19.
	argumentCount := 0.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:13'!
bytecodeHPrimNextPut
	messageSelector := self specialSelector: 20.
	argumentCount := 1.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 15:10'!
bytecodeHPrimNotEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue: [^self booleanCheat: rcvr ~= arg].

	self initPrimCall.
	aBool := self primitiveFloatEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool not].

	messageSelector := self specialSelector: 7.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimPointX

	| rcvr |
	self initPrimCall.
	rcvr := self internalStackTop.
	self assertClassOf: rcvr is: (objectMemory splObj: ClassPoint).
	self successful ifTrue:
		[self internalStackTopPut: (objectMemory fetchPointer: XIndex ofObject: rcvr).
		^self fetchHNextBytecode "success"].
	primFailCode := 0.

	messageSelector := self specialSelector: 30.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimPointY

	| rcvr |
	self initPrimCall.
	rcvr := self internalStackTop.
	self assertClassOf: rcvr is: (objectMemory splObj: ClassPoint).
	self successful ifTrue:
		[self internalStackTopPut: (objectMemory fetchPointer: YIndex ofObject: rcvr).
		^self fetchHNextBytecode "success"].
	primFailCode := 0.

	messageSelector := self specialSelector: 31.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:50'!
bytecodeHPrimSize
	| rcvr sz isString isArray |
	self initPrimCall.
	rcvr := self internalStackTop.

	"Shortcut the mega-lookup for ByteString and Array, the two big consumers of cycles
	 here. Both of these have compact class indices and neither has any added fields."
      isString := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassString)
					compactClassIndex: ClassByteStringCompactIndex.
	isString ifTrue:
		[sz := objectMemory lengthOf: rcvr.
		 self internalStackTopPut: (objectMemory integerObjectOf: sz).
		^self fetchHNextBytecode].

      isArray := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassArray)
					compactClassIndex: ClassArrayCompactIndex.
	isArray ifTrue:
		[sz := objectMemory lengthOf: rcvr.
		 self internalStackTopPut: (objectMemory integerObjectOf: sz).
		^self fetchHNextBytecode].

	messageSelector := self specialSelector: 18.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:50'!
bytecodeHPrimSubtract
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [result := (objectMemory integerValueOf: rcvr) - (objectMemory integerValueOf: arg).
				(objectMemory isIntegerValue: result) ifTrue:
					[self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
					^self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatSubtract: rcvr fromArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 1.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimValue
	| rcvr isBlock |
	rcvr := self internalStackTop.
	argumentCount := 0.
	isBlock := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassBlockClosure)
					compactClassIndex: ClassBlockClosureCompactIndex.
	isBlock ifTrue:
		[self externalizeIPandSP.
		self initPrimCall.
		self primitiveClosureValue.
		self internalizeIPandSP.
		self successful ifTrue:
			[^self fetchHNextBytecode].
		primFailCode := 0].
	messageSelector := self specialSelector: 25.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
bytecodeHPrimValueWithArg
	| rcvr isBlock |
	rcvr := self internalStackValue: 1.
	argumentCount := 1.
	isBlock := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassBlockClosure)
					compactClassIndex: ClassBlockClosureCompactIndex.
	isBlock ifTrue:
		[self externalizeIPandSP.
		self initPrimCall.
		self primitiveClosureValue.
		self internalizeIPandSP.
		self successful ifTrue:
			[^self fetchHNextBytecode].
		primFailCode := 0].
	messageSelector := self specialSelector: 26.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:29'!
commonHCallerReturn
	"Return to the previous context/frame (sender for method activations, caller for block activations)."
	| callersFPOrNull |
	<var: #callersFPOrNull type: #'char *'>"returnTopFromBlock"
	
	callersFPOrNull := self frameCallerFP: localFP.
	callersFPOrNull == 0 "baseFrame" ifTrue:
		[self assert: localFP = stackPage baseFP.
		 "^self baseHFrameReturn"
		^nil].

	secondInstructionPointer := self frameCallerSavedIP: localFP.
	localSP := localFP + (self frameStackedReceiverOffset: localFP).
	localFP := callersFPOrNull.
	self internalStackTopPut: localReturnValue.
	self fetchNextBytecode.
	^self setMethod: (self frameMethod: localFP)! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:19'!
commonHReturn
	"Note: Assumed to be inlined into the dispatch loop."

	| closure home unwindContextOrNilOrZero frameToReturnTo contextToReturnTo theFP callerFP newPage |
	<var: #frameToReturnTo type: #'char *'>
	<var: #theFP type: #'char *'>
	<var: #callerFP type: #'char *'>
	<var: #newPage type: #'StackPage *'>
	<var: #thePage type: #'StackPage *'>
	
	
	counterLoop := counterLoop - 1.
	"If this is a method simply return to the  sender/caller."
	(self frameIsBlockActivation: localFP) ifFalse:
		[^self commonHCallerReturn].

	"Since this is a block activation the closure is on the stack above any args and the frame."
	closure := self pushedReceiverOrClosureOfFrame: localFP.

	home := nil.
	"Walk the closure's lexical chain to find the context or frame to return from (home)."
	[closure ~~ objectMemory nilObject] whileTrue:
		[home := objectMemory fetchPointer: ClosureOuterContextIndex ofObject: closure.
		 closure := objectMemory fetchPointer: ClosureIndex ofObject: home].
	"home is to be returned from provided there is no unwind-protect activation between
	 this frame and home's sender.  Search for an unwind.  findUnwindThroughContext:
	 will answer either the context for an unwind-protect activation or nilObj if the sender
	 cannot be found or 0 if no unwind is found but the sender is.  We must update the
	 current page's headFrame pointers to enable the search to identify widowed contexts
	 correctly."
	self writeBackHeadFramePointers.
	unwindContextOrNilOrZero := self internalFindUnwindThroughContext: home.
	unwindContextOrNilOrZero = objectMemory nilObject ifTrue:
		["error: can't find home on chain; cannot return"
		 ^self internalCannotReturn: localReturnValue].
	unwindContextOrNilOrZero ~~ 0 ifTrue:
		[^self internalAboutToReturn: localReturnValue through: unwindContextOrNilOrZero].

	"Now we know home is on the sender chain.
	 We could be returning to either a context or a frame.  Find out which."
	contextToReturnTo := nil.
	(self isMarriedOrWidowedContext: home)
		ifTrue:
			[self assert: (self checkIsStillMarriedContext: home currentFP: localFP).
			 theFP := self frameOfMarriedContext: home.
			 (self isBaseFrame: theFP)
				ifTrue:
					[contextToReturnTo := self frameCallerContext: theFP]
				ifFalse:
					[frameToReturnTo := self frameCallerFP: theFP]]
		ifFalse:
			[contextToReturnTo := objectMemory fetchPointer: SenderIndex ofObject: home.
			 ((self isContext: contextToReturnTo)
			  and: [self isMarriedOrWidowedContext: contextToReturnTo]) ifTrue:
				[self assert: (self checkIsStillMarriedContext: contextToReturnTo currentFP: localFP).
			 	 frameToReturnTo := self frameOfMarriedContext: contextToReturnTo.
				 contextToReturnTo := nil]].

	"If returning to a context we must make a frame for it unless it is dead."
	contextToReturnTo ~= nil ifTrue:
		[frameToReturnTo := self establishFrameForContextToReturnTo: contextToReturnTo.
		 frameToReturnTo == 0 ifTrue:
			["error: home's sender is dead; cannot return"
			 ^self internalCannotReturn: localReturnValue]].

	"Now we have a frame to return to.  If it is on a different page we must free intervening pages and
	 nil out intervening contexts.  We must free intervening stack pages because if we leave the pages
	 to be divorced then their contexts will be divorced with intact senders and instruction pointers.  This
	 code is similar to primitiveTerminateTo.  We must move any frames on itervening pages above the
	 frame linked to because these may be in use, e.g. via co-routining (see baseFrameReturn)."
	self assert: stackPages pageListIsWellFormed.
	newPage := stackPages stackPageFor: frameToReturnTo.
	newPage ~~ stackPage ifTrue:
		[| currentCtx thePage nextCntx |
		 currentCtx := self frameCallerContext: stackPage baseFP.
		 self assert: (self isContext: currentCtx).
		 stackPages freeStackPage: stackPage.
		 [self assert: (self isContext: currentCtx).
		  (self isMarriedOrWidowedContext: currentCtx)
		   and: [(stackPages stackPageFor: (theFP := self frameOfMarriedContext: currentCtx)) = newPage]] whileFalse:
			[(self isMarriedOrWidowedContext: currentCtx)
				ifTrue:
					[thePage := stackPages stackPageFor: theFP.
					 theFP ~= thePage headFP ifTrue:
						["Since we've just deallocated a page we know that newStackPage won't deallocate an existing one."
						 self moveFramesIn: thePage through: (self findFrameAbove: theFP inPage: thePage) toPage: self newStackPage].
					 currentCtx := self frameCallerContext: thePage baseFP.
					 self freeStackPage: thePage]
				ifFalse:
					[nextCntx := objectMemory fetchPointer: SenderIndex ofObject: currentCtx.
					 self markContextAsDead: currentCtx.
					 currentCtx := nextCntx]].
		 self setStackPageAndLimit: newPage.
		 localSP := stackPage headSP.
		 localFP := stackPage headFP].

	"Two cases.  Returning to the top frame on a new page or an interior frame on the current page.
	 The top frame has its instruction pointer on top of stack. An interior frame has its instruction pointer
	 in the caller frame. We need to peel back any frames on the page until we get to the correct frame."

	localFP = frameToReturnTo
		ifTrue: "pop the saved IP, push the return value and continue."
			[localIP := self pointerForOop: self internalStackTop]
		ifFalse:
			[[callerFP := localFP.
			  localFP := self frameCallerFP: localFP.
			  localFP ~~ frameToReturnTo] whileTrue.
			localIP := self frameCallerSavedIP: callerFP.
			localSP := (self frameCallerSP: callerFP) - BytesPerWord].
	self internalStackTopPut: localReturnValue.
	self setMethod: (self frameMethod: localFP).
	^self fetchNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
doubleHExtendedDoAnythingBytecode
	"Replaces the Blue Book double-extended send [132], in which the first byte was wasted on 8 bits of argument count. 
	Here we use 3 bits for the operation sub-type (opType),  and the remaining 5 bits for argument count where needed. 
	The last byte give access to 256 instVars or literals. 
	See also secondExtendedSendBytecode"
	| byte2 byte3 opType top |
	byte2 := self fetchByte.
	byte3 := self fetchByte.
	opType := byte2 >> 5.
	opType = 0 ifTrue:
		[messageSelector := self literal: byte3.
		 argumentCount := byte2 bitAnd: 31.
		 ^self normalSend].
	opType = 1 ifTrue:
		[messageSelector := self literal: byte3.
		 argumentCount := byte2 bitAnd: 31.
		 ^self superclassSend].
	self fetchHNextBytecode.
	opType = 2 ifTrue: [^self pushMaybeContextReceiverVariable: byte3].
	opType = 3 ifTrue: [^self pushLiteralConstant: byte3].
	opType = 4 ifTrue: [^self pushLiteralVariable: byte3].
	top := self internalStackTop.
	opType = 7 ifTrue:
		[^objectMemory storePointer: ValueIndex ofObject: (self literal: byte3) withValue: top].
	"opType = 5 is store; opType = 6 = storePop"
	opType = 6 ifTrue:
		[self internalPop: 1].
	^self storeMaybeContextReceiverVariable: byte3 withValue: top! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
duplicateHTopBytecode

	self fetchHNextBytecode.
	self internalPush: self internalStackTop.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
extendedHPushBytecode

	| descriptor variableType variableIndex |
	descriptor := self fetchByte.
	self fetchHNextBytecode.
	variableType := (descriptor >> 6) bitAnd: 16r3.
	variableIndex := descriptor bitAnd: 16r3F.
	variableType=0 ifTrue: [^self pushReceiverVariable: variableIndex].
	variableType=1 ifTrue: [^self pushTemporaryVariable: variableIndex].
	variableType=2 ifTrue: [^self pushLiteralConstant: variableIndex].
	variableType=3 ifTrue: [^self pushLiteralVariable: variableIndex].
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:32'!
extendedHStoreAndPopBytecode

	self extendedHStoreBytecode.
	self internalPop: 1.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:48'!
extendedHStoreBytecode
	| descriptor variableType variableIndex association |
	<inline: true>
	descriptor := self fetchByte.
	self fetchHNextBytecode.
	variableType := descriptor >> 6 bitAnd: 3.
	variableIndex := descriptor bitAnd: 63.
	variableType = 0 ifTrue:
		[^objectMemory storePointer: variableIndex ofObject: self receiver withValue: self internalStackTop].
	variableType = 1 ifTrue:
		[^self temporary: variableIndex in: localFP put: self internalStackTop].
	variableType = 3 ifTrue:
		[association := self literal: variableIndex.
		 ^objectMemory storePointer: ValueIndex ofObject: association withValue: self internalStackTop].
	self error: 'illegal store'.
	^nil! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:30'!
extendedPushBytecode

	| descriptor variableType variableIndex |
	descriptor := self fetchByte.
	self fetchNextBytecode.
	variableType := (descriptor >> 6) bitAnd: 16r3.
	variableIndex := descriptor bitAnd: 16r3F.
	variableType=0 ifTrue: [^self pushReceiverVariable: variableIndex].
	variableType=1 ifTrue: [^self pushTemporaryVariable: variableIndex].
	variableType=2 ifTrue: [^self pushLiteralConstant: variableIndex].
	variableType=3 ifTrue: [^self pushLiteralVariable: variableIndex].
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:25'!
fetchByte
	^objectMemory byteAtPointer: secondInstructionPointer preIncrement.
	! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:25'!
fetchHByte
	^objectMemory byteAtPointer: secondInstructionPointer preIncrement.
	! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/19/2012 19:12'!
fetchHNextBytecode
	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."
	secondInstructionPointer := secondInstructionPointer +1 .
	specialBytecode := objectMemory byteAtPointer: secondInstructionPointer 
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:42'!
fetchNextBytecode
	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."

	specialBytecode := objectMemory byteAtPointer: secondInstructionPointer preIncrement
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/18/2012 17:35'!
hCommonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSend' inCase: 131>
	self internalFindNewMethod.
	self internalExecuteNewMethod.
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:27'!
hJump: offset
	localIP := localIP + offset + 1.
	currentBytecode := objectMemory byteAtPointer: localIP! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/18/2012 17:28'!
hJumplfFalseBy: offset 
	| boolean |
	boolean := self internalStackTop.
	boolean = objectMemory falseObject
		ifTrue: [self jump: offset]
		ifFalse:
			[boolean = objectMemory trueObject ifFalse:
				[^self internalMustBeBoolean].
			self fetchNextBytecode].
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/18/2012 17:37'!
internalActivateNewMethodForSpecialBytecode
	| methodHeader numTemps rcvr errorCode |
	<inline: true>

	methodHeader := self headerOf: newMethod.
	numTemps := self tempCountOfMethodHeader: methodHeader.

	rcvr := self internalStackValue: argumentCount. "could new rcvr be set at point of send?"

	self internalPush: localIP.
	self internalPush: localFP.
	localFP := localSP.
	self internalPush: newMethod.
	self setMethod: newMethod.
	self internalPush: (self
						encodeFrameFieldHasContext: false
						isBlock: false
						numArgs: (self argumentCountOfMethodHeader: methodHeader)).
	self internalPush: objectMemory nilObject. "FxThisContext field"
	self internalPush: rcvr.

	"Initialize temps..."
	argumentCount + 1 to: numTemps do:
		[:i | self internalPush: objectMemory nilObject].

	"-1 to account for pre-increment in fetchNextBytecode"
	localIP := self pointerForOop: (self initialPCForHeader: methodHeader method: newMethod) - 1.

	"Pass primitive error code to last temp if method receives it (indicated
	 by an initial long store temp bytecode).  Protect against obsolete values
	 in primFailCode by checking that newMethod actually has a primitive?"
	primFailCode ~= 0 ifTrue:
		[((self methodHeaderHasPrimitive: methodHeader)
		   and: [(objectMemory byteAtPointer: localIP + 1) = 129 "long store temp"]) ifTrue:
			[errorCode := self getErrorObjectFromPrimFailCode.
			 self internalStackTopPut: errorCode "nil if primFailCode == 1, or primFailCode"].
		primFailCode := 0].

	self assert: (self frameNumArgs: localFP) == argumentCount.
	self assert: (self frameIsBlockActivation: localFP) not.
	self assert: (self frameHasContext: localFP) not.

	"Now check for stack overflow or an event (interrupt, must scavenge, etc)."
	localSP < stackLimit ifTrue:
		[self externalizeIPandSP.
		 self handleStackOverflowOrEventAllowContextSwitch: (self canContextSwitchIfActivating: methodHeader).
		 self internalizeIPandSP]! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 16:09'!
internalHExecuteNewMethod
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~~ 0 ifTrue:
		[self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		" self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded."
			^nil].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethodForSpecialBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:45'!
longHJumpIfFalse

	self jumplfFalseBy: ((specialBytecode bitAnd: 3) * 256) + self fetchByte.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:45'!
longHJumpIfTrue

	self jumplfTrueBy: ((specialBytecode bitAnd: 3) * 256) + self fetchByte.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
longHUnconditionalJump
	| offset |
	offset := (((specialBytecode bitAnd: 7) - 4) * 256) + self fetchByte.
	localIP := localIP + offset.
	(offset < 0 "backward jump means we're in a loop; check for possible interrupts"
	 and: [localSP < stackLimit]) ifTrue:
		[self externalizeIPandSP.
		 self checkForEventsMayContextSwitch: true.
		 self browserPluginReturnIfNeeded.
		 self internalizeIPandSP].
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
popHStackBytecode

	self fetchHNextBytecode.
	self internalPop: 1.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHActiveContextBytecode
	| ourContext |
	ourContext := self ensureFrameIsMarried: localFP SP: localSP.
	self fetchHNextBytecode.
	self internalPush: ourContext! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHClosureCopyCopiedValuesBytecode
	"The compiler has pushed the values to be copied, if any.  Find numArgs and numCopied in the byte following.
	 Create a Closure with space for the copiedValues and pop numCopied values off the stack into the closure.
	 Set numArgs as specified, and set startpc to the pc following the block size and jump over that code."
	| newClosure numArgsNumCopied numArgs numCopied blockSize context |
	numArgsNumCopied := self fetchByte.
	numArgs := numArgsNumCopied bitAnd: 16rF.
	numCopied := numArgsNumCopied bitShift: -4.
	"Split blockSize := (self fetchByte * 256) + self fetchByte. into two because evaluation order in C is undefined."
	blockSize := self fetchByte << 8.
	blockSize := blockSize + self fetchByte.
	"No need to record the pushed copied values in the outerContext."
	context := self ensureFrameIsMarried: localFP SP: localSP + (numCopied * BytesPerWord).
	newClosure := self
					closureIn: context
					numArgs: numArgs
					instructionPointer: (self oopForPointer: localIP) + 2 - (method+BaseHeaderSize)
					numCopiedValues: numCopied.
	numCopied > 0 ifTrue:
		[0 to: numCopied - 1 do:
			[:i|
			"Assume: have just allocated a new BlockClosure; it must be young.
			 Thus, can use unchecked stores."
			 objectMemory storePointerUnchecked: i + ClosureFirstCopiedValueIndex
				ofObject: newClosure
				withValue: (self internalStackValue: numCopied - i - 1)].
		 self internalPop: numCopied].
	localIP := localIP + blockSize.
	self fetchHNextBytecode.
	self internalPush: newClosure! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantFalseBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory falseObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantMinusOneBytecode

	self fetchHNextBytecode.
	self internalPush: ConstMinusOne.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantNilBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory nilObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantOneBytecode

	self fetchHNextBytecode.
	self internalPush: ConstOne.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantTrueBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory trueObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantTwoBytecode

	self fetchHNextBytecode.
	self internalPush: ConstTwo.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHConstantZeroBytecode

	self fetchHNextBytecode.
	self internalPush: ConstZero.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHLiteralConstantBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to currentBytecode below will be constant"
	self pushLiteralConstant: (specialBytecode bitAnd: 16r1F)! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHLiteralVariableBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to currentBytecode below will be constant"
	self pushLiteralVariable: (specialBytecode bitAnd: 16r1F)! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHNewArrayBytecode
	| size popValues array |
	size := self fetchByte.
	popValues := size > 127.
	size := size bitAnd: 127.
	self fetchHNextBytecode.
	self externalizeIPandSP.
	array := objectMemory eeInstantiateClass: (objectMemory splObj: ClassArray) indexableSize: size.
	self internalizeIPandSP.
	popValues
		ifTrue:
			[0 to: size - 1 do:
				[:i|
				"Assume: have just allocated a new Array; it must be young. Thus, can use unchecked stores."
				objectMemory storePointerUnchecked: i ofObject: array withValue: (self internalStackValue: size - i - 1)].
			 self internalPop: size]
		ifFalse:
			[0 to: size - 1 do:
				[:i|
				objectMemory storePointerUnchecked: i ofObject: array withValue: objectMemory nilObject]].
	self internalPush: array! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHReceiverBytecode

	self fetchHNextBytecode.
	self internalPush: self receiver.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHReceiverVariableBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to specialBytecode below will be constant"
	self pushReceiverVariable: (specialBytecode bitAnd: 16rF)! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
pushHRemoteTempLongBytecode
	| remoteTempIndex tempVectorIndex |
	remoteTempIndex := self fetchByte.
	tempVectorIndex := self fetchByte.
	self fetchHNextBytecode.
	self pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 18:42'!
pushHTemporaryVariable: temporaryIndex

	self push: (self temporary: temporaryIndex in: framePointer).! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/19/2012 19:04'!
pushHTemporaryVariableBytecode

	self print: '1';cr.
	self fetchHNextBytecode.
	self pushHTemporaryVariable: (specialBytecode bitAnd: 16rF)! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:27'!
returnHFalse
	localReturnValue := objectMemory falseObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:27'!
returnHNil
	localReturnValue := objectMemory nilObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:27'!
returnHReceiver
	localReturnValue := self receiver.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:29'!
returnHTopFromBlock
	"Return to the caller of the current block activation."
	localReturnValue := self internalStackTop.
	self commonCallerReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/19/2012 19:04'!
returnHTopFromMethod
	self print: 'd';cr.
	counterLoop := counterLoop -1.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:27'!
returnHTrue
	localReturnValue := objectMemory trueObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 12:33'!
secondHExtendedSendBytecode
	"This replaces the Blue Book double-extended super-send [134],
	which is subsumed by the new double-extended do-anything [132].
	It offers a 2-byte send of 0-3 args for up to 63 literals, for which 
	the Blue Book opcode set requires a 3-byte instruction."

	| descriptor |
	descriptor := self fetchByte.
	messageSelector := self literal: (descriptor bitAnd: 16r3F).
	argumentCount := descriptor >> 6.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:46'!
sendHLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self commonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:46'!
sendHLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self commonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:33'!
sendHLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self hCommonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'try' stamp: 'jb 1/19/2012 19:06'!
sendTest: class
	<inline:false>
	| returnValue ms ac lk sl nm fp ip sp lfp lip lsp pfc m  needToContinue methodHeader  numTemps numArgs rcvr |
	
	ms := messageSelector.
	ac := argumentCount.
	lk := lkupClass.
	sl := stackLimit.
	fp := framePointer.
	ip := instructionPointer.
	sp := stackPointer.
	"lfp := localFP."
	"lip := localIP."
	"lsp := localSP."
	
	messageSelector := self handlePropagateSelector.
	argumentCount := 1.
	lkupClass := class.
	self lookupMethodInClass: (self fetchClassOf: (self fetchClassOf: class)).
	
	"here Is the dra ... euh receiver "
	self push: (self fetchClassOf: class).
	"here is the argument"
	self push: (self arrayVersionOf: class).
	"Here become the message Send But "
	
	methodHeader := self headerOf: newMethod.
	numTemps := self temporaryCountOfMethodHeader: methodHeader.
	numArgs := self argumentCountOfMethodHeader: methodHeader.

	self push: instructionPointer.
	self push: framePointer.
	framePointer := stackPointer.
	self push: newMethod.
	self setMethod: newMethod.
	self push: (self encodeFrameFieldHasContext: false isBlock: false numArgs: numArgs).
	self push: objectMemory nilObject. "FxThisContext field"
	self push: (self fetchClassOf: class).

	"clear remaining temps to nil"
	numArgs+1 to: numTemps do:
		[:i | self push: objectMemory nilObject].
	
	self printOop: (self findSelectorOfMethod: newMethod forReceiver: class).
	specialBytecode := objectMemory byteAt:  (self pointerForOop: (self initialPCForHeader: methodHeader method: newMethod)).
	counterLoop := 1.
	[counterLoop = 0] whileFalse: [self dispatchOn: specialBytecode in: SecondBytecodeTable].
	self print:'suis-je bon ? : ';cr.
	self printOop: (self stackTop);cr.
	

	
	"returnValue := self pop: 1."
	
	messageSelector := ms.
	argumentCount := ac.
	lkupClass := lk.
	stackLimit := sl.
	framePointer := fp.
	instructionPointer := ip.
	stackPointer := sp.
"	localFP :=lfp.
	localIP :=lip.
	localSP := lsp."
	^nil
	! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:33'!
shortHConditionalJump

	self hJumplfFalseBy: (specialBytecode bitAnd: 7) + 1.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:28'!
shortHUnconditionalJump
	<expandCases>
	self hJump: (specialBytecode bitAnd: 7) + 1.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:26'!
singleHExtendedSendBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchHByte.
	messageSelector := self literal: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:25'!
singleHExtendedSuperBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchHByte.
	messageSelector := self literal: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self superclassSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:49'!
storeHAndPopReceiverVariableBytecode
	"Note: This code uses 
	storePointerUnchecked:ofObject:withValue: and does the 
	store check explicitely in order to help the translator 
	produce better code."
	| rcvr top |
	rcvr := self receiver.
	top := self internalStackTop.
	(self oop: rcvr isLessThan: objectMemory youngStart) ifTrue:
		[objectMemory possibleRootStoreInto: rcvr value: top].
	objectMemory storePointerUnchecked: (specialBytecode bitAnd: 7) ofObject: rcvr withValue: top.
	self fetchHNextBytecode.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:23'!
storeHAndPopRemoteTempLongBytecode
	self storeHRemoteTempLongBytecode.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 16:50'!
storeHAndPopTemporaryVariableBytecode
	<expandCases>
	"this bytecode will be expanded so that refs to specialBytecode below will be constant"
	self fetchHNextBytecode.
	self temporary: (specialBytecode bitAnd: 7) in: localFP put: self internalStackTop.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode support' stamp: 'jb 1/18/2012 17:23'!
storeHRemoteTemp: index inVectorAt: tempVectorIndex
	| tempVector |
	tempVector := self temporary: tempVectorIndex in: localFP.
	objectMemory storePointer: index ofObject: tempVector withValue: self internalStackTop.! !

!HSCStackInterpreterPrimitivesBytecodeHack methodsFor: 'bytecode' stamp: 'jb 1/18/2012 17:26'!
storeHRemoteTempLongBytecode
	| remoteTempIndex tempVectorIndex |
	remoteTempIndex := self fetchHByte.
	tempVectorIndex := self fetchHByte.
	self fetchHNextBytecode.
	self storeRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

HSCStackInterpreterPrimitivesStateManagement subclass: #HSCStackInterpreterPrimitivesBytecodeHack2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-SmartCloneInterpreterExperiment'!

!HSCStackInterpreterPrimitivesBytecodeHack2 class methodsFor: 'as yet unclassified' stamp: 'jb 1/19/2012 17:04'!
initialize
	"self initialize"
	super initialize.
	self initializeSecondBytecodeTable.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 class methodsFor: 'as yet unclassified' stamp: 'jb 1/19/2012 17:04'!
initializeSecondBytecodeTable
	
	SecondBytecodeTable := Array new: 256.
	self table: SecondBytecodeTable from:
	{
		#(  0  15 unknownBytecode).
		#( 16  31 pushHTemporaryVariableBytecode).
		#( 32  63 unknownBytecode).
		#( 64  95 unknownBytecode).
		#( 96 103 unknownBytecode).
		#(104 111 unknownBytecode).
		#(112 unknownBytecode).
		#(113 unknownBytecode).
		#(114 unknownBytecode).
		#(115 unknownBytecode).
		#(116 unknownBytecode).
		#(117 unknownBytecode).
		#(118 unknownBytecode).
		#(119 unknownBytecode).
		#(120 unknownBytecode).
		#(121 unknownBytecode).
		#(122 unknownBytecode).
		#(123 unknownBytecode).
		#(124 returnHTopFromMethod).
		#(125 unknownBytecode).

		"Newspeak bytecodes"
		#( 126 unknownBytecode).
		#( 127 unknownBytecode).

		#(128 unknownBytecode).
		#(129 unknownBytecode).
		#(130 unknownBytecode).
		#(131 unknownBytecode).
		#(132 unknownBytecode).
		#(133 unknownBytecode).
		#(134 unknownBytecode).
		#(135 unknownBytecode).
		#(136 unknownBytecode).

		#(137 unknownBytecode).
		"Closure & Newspeak bytecodes"
		#(138 unknownBytecode).
		#(139 unknownBytecode ).
		#(140 unknownBytecode).
		#(141 unknownBytecode).
		#(142 unknownBytecode).
		#(143 unknownBytecode).

		#(144 151 unknownBytecode).
		#(152 159 unknownBytecode).
		#(160 167 unknownBytecode).
		#(168 171 unknownBytecode).
		#(172 175 unknownBytecode).

		"176-191 were sendArithmeticSelectorBytecode"
		#(176 unknownBytecode).
		#(177 unknownBytecode).
		#(178 unknownBytecode).
		#(179 unknownBytecode).
		#(180 unknownBytecode).
		#(181 unknownBytecode).
		#(182 unknownBytecode).
		#(183 unknownBytecode).
		#(184 unknownBytecode).
		#(185 unknownBytecode).
		#(186 unknownBytecode).
		#(187 unknownBytecode).
		#(188 unknownBytecode).
		#(189 unknownBytecode).
		#(190 unknownBytecode).
		#(191 unknownBytecode).	

		"192-207 were sendCommonSelectorBytecode"
		#(192 unknownBytecode).
		#(193 unknownBytecode).
		#(194 unknownBytecode).
		#(195 unknownBytecode).
		#(196 unknownBytecode).
		#(197 unknownBytecode).
		#(198 unknownBytecode).
		#(199 unknownBytecode).
		#(200 unknownBytecode).
		#(201 unknownBytecode).
		#(202 unknownBytecode).
		#(203 unknownBytecode).
		#(204 unknownBytecode).
		#(205 unknownBytecode).
		#(206 unknownBytecode).
		#(207 unknownBytecode).

		#(208 223 unknownBytecode).
		#(224 239 unknownBytecode).
		#(240 255 unknownBytecode).
	}! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimAdd
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [result := (objectMemory integerValueOf: rcvr) + (objectMemory integerValueOf: arg).
				(objectMemory isIntegerValue: result) ifTrue:
					[self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
					^ self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatAdd: rcvr toArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^ self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 0.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimAt
	"BytecodePrimAt will only succeed if the receiver is in the atCache.
	Otherwise it will fail so that the more general primitiveAt will put it in the
	cache after validating that message lookup results in a primitive response."
	| index rcvr result atIx |
	index := self internalStackTop.
	rcvr := self internalStackValue: 1.
	((objectMemory isIntegerObject: rcvr) not
	 and: [objectMemory isIntegerObject: index]) ifTrue:
		[atIx := rcvr bitAnd: AtCacheMask.  "Index into atCache = 4N, for N = 0 ... 7"
		(atCache at: atIx+AtCacheOop) = rcvr ifTrue:
			[result := self commonVariable: rcvr at: (objectMemory integerValueOf: index) cacheIndex: atIx.
			 self successful ifTrue:
				[self fetchHNextBytecode.
				^self internalPop: 2 thenPush: result].
			 self initPrimCall]].

	messageSelector := self specialSelector: 16.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimAtEnd
	messageSelector := self specialSelector: 21.
	argumentCount := 0.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimAtPut
	"BytecodePrimAtPut will only succeed if the receiver is in the atCache.
	Otherwise it will fail so that the more general primitiveAtPut will put it in the
	cache after validating that message lookup results in a primitive response."
	| index rcvr atIx value |
	value := self internalStackTop.
	index := self internalStackValue: 1.
	rcvr := self internalStackValue: 2.
	((objectMemory isIntegerObject: rcvr) not
	 and: [objectMemory isIntegerObject: index]) ifTrue:
		[atIx := (rcvr bitAnd: AtCacheMask) + AtPutBase.  "Index into atPutCache"
		 (atCache at: atIx+AtCacheOop) = rcvr ifTrue:
			[self commonVariable: rcvr at: (objectMemory integerValueOf: index) put: value cacheIndex: atIx.
			 self successful ifTrue:
				[self fetchHNextBytecode.
				 ^self internalPop: 3 thenPush: value].
			 self initPrimCall]].

	messageSelector := self specialSelector: 17.
	argumentCount := 2.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimBitAnd

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitAnd.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 14.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimBitOr

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitOr.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 15.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimBitShift

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveBitShift.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 12.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimBlockCopy

	messageSelector := self specialSelector: 24.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimClass
	| rcvr |
	rcvr := self internalStackTop.
	self internalStackTopPut: (objectMemory fetchClassOf: rcvr).
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimDiv
	| quotient |
	self initPrimCall.
	quotient := self doPrimitiveDiv: (self internalStackValue: 1) by: (self internalStackValue: 0).
	self successful ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: quotient).
		^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 13.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimDivide
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [rcvr := objectMemory integerValueOf: rcvr.
			arg := objectMemory integerValueOf: arg.
			(arg ~= 0 and: [rcvr \\ arg = 0])
				ifTrue: [result := rcvr // arg.
					"generates C / operation"
					(objectMemory isIntegerValue: result)
						ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
							^ self fetchHNextBytecode"success"]]]
		ifFalse: [self initPrimCall.
			self externalizeIPandSP.
			self primitiveFloatDivide: rcvr byArg: arg.
			self internalizeIPandSP.
			self successful ifTrue: [^ self fetchHNextBytecode"success"]].

	messageSelector := self specialSelector: 9.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimDo

	messageSelector := self specialSelector: 27.
	argumentCount := 1.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue: [^self booleanCheat: rcvr = arg].

	self initPrimCall.
	aBool := self primitiveFloatEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 6.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimEquivalent

	| rcvr arg |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	self booleanCheat: rcvr = arg.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimGreaterOrEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr >= arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) >= (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatGreaterOrEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 5.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimGreaterThan
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr > arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) > (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatGreater: rcvr thanArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 3.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimLessOrEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr <= arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) <= (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatLessOrEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool].

	messageSelector := self specialSelector: 4.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimLessThan
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue:
		["The C code can avoid detagging since tagged integers are still signed.
		 But this means the simulator must override to do detagging."
		^self cCode: [self booleanCheat: rcvr < arg]
			inSmalltalk: [self booleanCheat: (objectMemory integerValueOf: rcvr) < (objectMemory integerValueOf: arg)]].

	self initPrimCall.
	aBool := self primitiveFloatLess: rcvr thanArg: arg.
	self successful ifTrue: [^ self booleanCheat: aBool].

	messageSelector := self specialSelector: 2.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimMakePoint

	self initPrimCall.
	self externalizeIPandSP.
	self primitiveMakePoint.
	self internalizeIPandSP.
	self successful ifTrue: [^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 11.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimMod
	| mod |
	self initPrimCall.
	mod := self doPrimitiveMod: (self internalStackValue: 1) by: (self internalStackValue: 0).
	self successful ifTrue:
		[self internalPop: 2 thenPush: (objectMemory integerObjectOf: mod).
		^ self fetchHNextBytecode "success"].

	messageSelector := self specialSelector: 10.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimMultiply
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [rcvr := objectMemory integerValueOf: rcvr.
				arg := objectMemory integerValueOf: arg.
				result := rcvr * arg.
				((arg = 0 or: [(result // arg) = rcvr]) and: [objectMemory isIntegerValue: result])
					ifTrue: [self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
							^ self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatMultiply: rcvr byArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^ self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 8.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimNew

	messageSelector := self specialSelector: 28.
	argumentCount := 0.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimNewWithArg

	messageSelector := self specialSelector: 29.
	argumentCount := 1.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimNext
	messageSelector := self specialSelector: 19.
	argumentCount := 0.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimNextPut
	messageSelector := self specialSelector: 20.
	argumentCount := 1.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimNotEqual
	| rcvr arg aBool |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg) ifTrue: [^self booleanCheat: rcvr ~= arg].

	self initPrimCall.
	aBool := self primitiveFloatEqual: rcvr toArg: arg.
	self successful ifTrue: [^self booleanCheat: aBool not].

	messageSelector := self specialSelector: 7.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimPointX

	| rcvr |
	self initPrimCall.
	rcvr := self internalStackTop.
	self assertClassOf: rcvr is: (objectMemory splObj: ClassPoint).
	self successful ifTrue:
		[self internalStackTopPut: (objectMemory fetchPointer: XIndex ofObject: rcvr).
		^self fetchHNextBytecode "success"].
	primFailCode := 0.

	messageSelector := self specialSelector: 30.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimPointY

	| rcvr |
	self initPrimCall.
	rcvr := self internalStackTop.
	self assertClassOf: rcvr is: (objectMemory splObj: ClassPoint).
	self successful ifTrue:
		[self internalStackTopPut: (objectMemory fetchPointer: YIndex ofObject: rcvr).
		^self fetchHNextBytecode "success"].
	primFailCode := 0.

	messageSelector := self specialSelector: 31.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimSize
	| rcvr sz isString isArray |
	self initPrimCall.
	rcvr := self internalStackTop.

	"Shortcut the mega-lookup for ByteString and Array, the two big consumers of cycles
	 here. Both of these have compact class indices and neither has any added fields."
      isString := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassString)
					compactClassIndex: ClassByteStringCompactIndex.
	isString ifTrue:
		[sz := objectMemory lengthOf: rcvr.
		 self internalStackTopPut: (objectMemory integerObjectOf: sz).
		^self fetchHNextBytecode].

      isArray := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassArray)
					compactClassIndex: ClassArrayCompactIndex.
	isArray ifTrue:
		[sz := objectMemory lengthOf: rcvr.
		 self internalStackTopPut: (objectMemory integerObjectOf: sz).
		^self fetchHNextBytecode].

	messageSelector := self specialSelector: 18.
	argumentCount := 0.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimSubtract
	| rcvr arg result |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self areIntegers: rcvr and: arg)
		ifTrue: [result := (objectMemory integerValueOf: rcvr) - (objectMemory integerValueOf: arg).
				(objectMemory isIntegerValue: result) ifTrue:
					[self internalPop: 2 thenPush: (objectMemory integerObjectOf: result).
					^self fetchHNextBytecode "success"]]
		ifFalse: [self initPrimCall.
				self externalizeIPandSP.
				self primitiveFloatSubtract: rcvr fromArg: arg.
				self internalizeIPandSP.
				self successful ifTrue: [^self fetchHNextBytecode "success"]].

	messageSelector := self specialSelector: 1.
	argumentCount := 1.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimValue
	| rcvr isBlock |
	rcvr := self internalStackTop.
	argumentCount := 0.
	isBlock := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassBlockClosure)
					compactClassIndex: ClassBlockClosureCompactIndex.
	isBlock ifTrue:
		[self externalizeIPandSP.
		self initPrimCall.
		self primitiveClosureValue.
		self internalizeIPandSP.
		self successful ifTrue:
			[^self fetchHNextBytecode].
		primFailCode := 0].
	messageSelector := self specialSelector: 25.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
bytecodeHPrimValueWithArg
	| rcvr isBlock |
	rcvr := self internalStackValue: 1.
	argumentCount := 1.
	isBlock := objectMemory
					is: rcvr
					instanceOf: (objectMemory splObj: ClassBlockClosure)
					compactClassIndex: ClassBlockClosureCompactIndex.
	isBlock ifTrue:
		[self externalizeIPandSP.
		self initPrimCall.
		self primitiveClosureValue.
		self internalizeIPandSP.
		self successful ifTrue:
			[^self fetchHNextBytecode].
		primFailCode := 0].
	messageSelector := self specialSelector: 26.
	self normalSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
commonHCallerReturn
	"Return to the previous context/frame (sender for method activations, caller for block activations)."
	| callersFPOrNull |
	<var: #callersFPOrNull type: #'char *'>
	<sharedCodeNamed: 'commonCallerReturn' inCase: 125> "returnTopFromBlock"
	
	callersFPOrNull := self frameCallerFP: localFP.
	callersFPOrNull == 0 "baseFrame" ifTrue:
		[self assert: localFP = stackPage baseFP.
		 ^self baseFrameReturn].

	secondInstructionPointer := self frameCallerSavedIP: localFP.
	localSP := localFP + (self frameStackedReceiverOffset: localFP).
	localFP := callersFPOrNull.
	self internalStackTopPut: localReturnValue.
	self fetchNextBytecode.
	^self setMethod: (self frameMethod: localFP)! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
commonHReturn
	"Note: Assumed to be inlined into the dispatch loop."

	| closure home unwindContextOrNilOrZero frameToReturnTo contextToReturnTo theFP callerFP newPage |
	<var: #frameToReturnTo type: #'char *'>
	<var: #theFP type: #'char *'>
	<var: #callerFP type: #'char *'>
	<var: #newPage type: #'StackPage *'>
	<var: #thePage type: #'StackPage *'>
	<sharedCodeNamed: 'commonReturn' inCase: 120>
	
	
	counterLoop := counterLoop - 1.
	"If this is a method simply return to the  sender/caller."
	(self frameIsBlockActivation: localFP) ifFalse:
		[^self commonHCallerReturn].

	"Since this is a block activation the closure is on the stack above any args and the frame."
	closure := self pushedReceiverOrClosureOfFrame: localFP.

	home := nil.
	"Walk the closure's lexical chain to find the context or frame to return from (home)."
	[closure ~~ objectMemory nilObject] whileTrue:
		[home := objectMemory fetchPointer: ClosureOuterContextIndex ofObject: closure.
		 closure := objectMemory fetchPointer: ClosureIndex ofObject: home].
	"home is to be returned from provided there is no unwind-protect activation between
	 this frame and home's sender.  Search for an unwind.  findUnwindThroughContext:
	 will answer either the context for an unwind-protect activation or nilObj if the sender
	 cannot be found or 0 if no unwind is found but the sender is.  We must update the
	 current page's headFrame pointers to enable the search to identify widowed contexts
	 correctly."
	self writeBackHeadFramePointers.
	unwindContextOrNilOrZero := self internalFindUnwindThroughContext: home.
	unwindContextOrNilOrZero = objectMemory nilObject ifTrue:
		["error: can't find home on chain; cannot return"
		 ^self internalCannotReturn: localReturnValue].
	unwindContextOrNilOrZero ~~ 0 ifTrue:
		[^self internalAboutToReturn: localReturnValue through: unwindContextOrNilOrZero].

	"Now we know home is on the sender chain.
	 We could be returning to either a context or a frame.  Find out which."
	contextToReturnTo := nil.
	(self isMarriedOrWidowedContext: home)
		ifTrue:
			[self assert: (self checkIsStillMarriedContext: home currentFP: localFP).
			 theFP := self frameOfMarriedContext: home.
			 (self isBaseFrame: theFP)
				ifTrue:
					[contextToReturnTo := self frameCallerContext: theFP]
				ifFalse:
					[frameToReturnTo := self frameCallerFP: theFP]]
		ifFalse:
			[contextToReturnTo := objectMemory fetchPointer: SenderIndex ofObject: home.
			 ((self isContext: contextToReturnTo)
			  and: [self isMarriedOrWidowedContext: contextToReturnTo]) ifTrue:
				[self assert: (self checkIsStillMarriedContext: contextToReturnTo currentFP: localFP).
			 	 frameToReturnTo := self frameOfMarriedContext: contextToReturnTo.
				 contextToReturnTo := nil]].

	"If returning to a context we must make a frame for it unless it is dead."
	contextToReturnTo ~= nil ifTrue:
		[frameToReturnTo := self establishFrameForContextToReturnTo: contextToReturnTo.
		 frameToReturnTo == 0 ifTrue:
			["error: home's sender is dead; cannot return"
			 ^self internalCannotReturn: localReturnValue]].

	"Now we have a frame to return to.  If it is on a different page we must free intervening pages and
	 nil out intervening contexts.  We must free intervening stack pages because if we leave the pages
	 to be divorced then their contexts will be divorced with intact senders and instruction pointers.  This
	 code is similar to primitiveTerminateTo.  We must move any frames on itervening pages above the
	 frame linked to because these may be in use, e.g. via co-routining (see baseFrameReturn)."
	self assert: stackPages pageListIsWellFormed.
	newPage := stackPages stackPageFor: frameToReturnTo.
	newPage ~~ stackPage ifTrue:
		[| currentCtx thePage nextCntx |
		 currentCtx := self frameCallerContext: stackPage baseFP.
		 self assert: (self isContext: currentCtx).
		 stackPages freeStackPage: stackPage.
		 [self assert: (self isContext: currentCtx).
		  (self isMarriedOrWidowedContext: currentCtx)
		   and: [(stackPages stackPageFor: (theFP := self frameOfMarriedContext: currentCtx)) = newPage]] whileFalse:
			[(self isMarriedOrWidowedContext: currentCtx)
				ifTrue:
					[thePage := stackPages stackPageFor: theFP.
					 theFP ~= thePage headFP ifTrue:
						["Since we've just deallocated a page we know that newStackPage won't deallocate an existing one."
						 self moveFramesIn: thePage through: (self findFrameAbove: theFP inPage: thePage) toPage: self newStackPage].
					 currentCtx := self frameCallerContext: thePage baseFP.
					 self freeStackPage: thePage]
				ifFalse:
					[nextCntx := objectMemory fetchPointer: SenderIndex ofObject: currentCtx.
					 self markContextAsDead: currentCtx.
					 currentCtx := nextCntx]].
		 self setStackPageAndLimit: newPage.
		 localSP := stackPage headSP.
		 localFP := stackPage headFP].

	"Two cases.  Returning to the top frame on a new page or an interior frame on the current page.
	 The top frame has its instruction pointer on top of stack. An interior frame has its instruction pointer
	 in the caller frame. We need to peel back any frames on the page until we get to the correct frame."

	localFP = frameToReturnTo
		ifTrue: "pop the saved IP, push the return value and continue."
			[localIP := self pointerForOop: self internalStackTop]
		ifFalse:
			[[callerFP := localFP.
			  localFP := self frameCallerFP: localFP.
			  localFP ~~ frameToReturnTo] whileTrue.
			localIP := self frameCallerSavedIP: callerFP.
			localSP := (self frameCallerSP: callerFP) - BytesPerWord].
	self internalStackTopPut: localReturnValue.
	self setMethod: (self frameMethod: localFP).
	^self fetchNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
doubleHExtendedDoAnythingBytecode
	"Replaces the Blue Book double-extended send [132], in which the first byte was wasted on 8 bits of argument count. 
	Here we use 3 bits for the operation sub-type (opType),  and the remaining 5 bits for argument count where needed. 
	The last byte give access to 256 instVars or literals. 
	See also secondExtendedSendBytecode"
	| byte2 byte3 opType top |
	byte2 := self fetchByte.
	byte3 := self fetchByte.
	opType := byte2 >> 5.
	opType = 0 ifTrue:
		[messageSelector := self literal: byte3.
		 argumentCount := byte2 bitAnd: 31.
		 ^self normalSend].
	opType = 1 ifTrue:
		[messageSelector := self literal: byte3.
		 argumentCount := byte2 bitAnd: 31.
		 ^self superclassSend].
	self fetchHNextBytecode.
	opType = 2 ifTrue: [^self pushMaybeContextReceiverVariable: byte3].
	opType = 3 ifTrue: [^self pushLiteralConstant: byte3].
	opType = 4 ifTrue: [^self pushLiteralVariable: byte3].
	top := self internalStackTop.
	opType = 7 ifTrue:
		[^objectMemory storePointer: ValueIndex ofObject: (self literal: byte3) withValue: top].
	"opType = 5 is store; opType = 6 = storePop"
	opType = 6 ifTrue:
		[self internalPop: 1].
	^self storeMaybeContextReceiverVariable: byte3 withValue: top! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
duplicateHTopBytecode

	self fetchHNextBytecode.
	self internalPush: self internalStackTop.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
extendedHPushBytecode

	| descriptor variableType variableIndex |
	descriptor := self fetchByte.
	self fetchHNextBytecode.
	variableType := (descriptor >> 6) bitAnd: 16r3.
	variableIndex := descriptor bitAnd: 16r3F.
	variableType=0 ifTrue: [^self pushReceiverVariable: variableIndex].
	variableType=1 ifTrue: [^self pushTemporaryVariable: variableIndex].
	variableType=2 ifTrue: [^self pushLiteralConstant: variableIndex].
	variableType=3 ifTrue: [^self pushLiteralVariable: variableIndex].
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
extendedHStoreAndPopBytecode

	self extendedHStoreBytecode.
	self internalPop: 1.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
extendedHStoreBytecode
	| descriptor variableType variableIndex association |
	<inline: true>
	descriptor := self fetchByte.
	self fetchHNextBytecode.
	variableType := descriptor >> 6 bitAnd: 3.
	variableIndex := descriptor bitAnd: 63.
	variableType = 0 ifTrue:
		[^objectMemory storePointer: variableIndex ofObject: self receiver withValue: self internalStackTop].
	variableType = 1 ifTrue:
		[^self temporary: variableIndex in: localFP put: self internalStackTop].
	variableType = 3 ifTrue:
		[association := self literal: variableIndex.
		 ^objectMemory storePointer: ValueIndex ofObject: association withValue: self internalStackTop].
	self error: 'illegal store'.
	^nil! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
fetchHByte
	^objectMemory byteAtPointer: secondInstructionPointer preIncrement.
	! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
fetchHNextBytecode
	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."

	specialBytecode := objectMemory byteAtPointer: secondInstructionPointer preIncrement
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
hCommonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSend' inCase: 131>
	self internalFindNewMethod.
	self internalExecuteNewMethod.
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
hJump: offset
	localIP := localIP + offset + 1.
	currentBytecode := objectMemory byteAtPointer: localIP! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
hJumplfFalseBy: offset 
	| boolean |
	boolean := self internalStackTop.
	boolean = objectMemory falseObject
		ifTrue: [self jump: offset]
		ifFalse:
			[boolean = objectMemory trueObject ifFalse:
				[^self internalMustBeBoolean].
			self fetchNextBytecode].
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
internalActivateNewMethodForSpecialBytecode
	| methodHeader numTemps rcvr errorCode |
	<inline: true>

	methodHeader := self headerOf: newMethod.
	numTemps := self tempCountOfMethodHeader: methodHeader.

	rcvr := self internalStackValue: argumentCount. "could new rcvr be set at point of send?"

	self internalPush: localIP.
	self internalPush: localFP.
	localFP := localSP.
	self internalPush: newMethod.
	self setMethod: newMethod.
	self internalPush: (self
						encodeFrameFieldHasContext: false
						isBlock: false
						numArgs: (self argumentCountOfMethodHeader: methodHeader)).
	self internalPush: objectMemory nilObject. "FxThisContext field"
	self internalPush: rcvr.

	"Initialize temps..."
	argumentCount + 1 to: numTemps do:
		[:i | self internalPush: objectMemory nilObject].

	"-1 to account for pre-increment in fetchNextBytecode"
	localIP := self pointerForOop: (self initialPCForHeader: methodHeader method: newMethod) - 1.

	"Pass primitive error code to last temp if method receives it (indicated
	 by an initial long store temp bytecode).  Protect against obsolete values
	 in primFailCode by checking that newMethod actually has a primitive?"
	primFailCode ~= 0 ifTrue:
		[((self methodHeaderHasPrimitive: methodHeader)
		   and: [(objectMemory byteAtPointer: localIP + 1) = 129 "long store temp"]) ifTrue:
			[errorCode := self getErrorObjectFromPrimFailCode.
			 self internalStackTopPut: errorCode "nil if primFailCode == 1, or primFailCode"].
		primFailCode := 0].

	self assert: (self frameNumArgs: localFP) == argumentCount.
	self assert: (self frameIsBlockActivation: localFP) not.
	self assert: (self frameHasContext: localFP) not.

	"Now check for stack overflow or an event (interrupt, must scavenge, etc)."
	localSP < stackLimit ifTrue:
		[self externalizeIPandSP.
		 self handleStackOverflowOrEventAllowContextSwitch: (self canContextSwitchIfActivating: methodHeader).
		 self internalizeIPandSP]! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode support' stamp: 'jb 1/19/2012 17:04'!
internalHExecuteNewMethod
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~~ 0 ifTrue:
		[self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		" self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded."
			^nil].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethodForSpecialBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
longHJumpIfFalse

	self jumplfFalseBy: ((specialBytecode bitAnd: 3) * 256) + self fetchByte.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
longHJumpIfTrue

	self jumplfTrueBy: ((specialBytecode bitAnd: 3) * 256) + self fetchByte.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
longHUnconditionalJump
	| offset |
	offset := (((specialBytecode bitAnd: 7) - 4) * 256) + self fetchByte.
	localIP := localIP + offset.
	(offset < 0 "backward jump means we're in a loop; check for possible interrupts"
	 and: [localSP < stackLimit]) ifTrue:
		[self externalizeIPandSP.
		 self checkForEventsMayContextSwitch: true.
		 self browserPluginReturnIfNeeded.
		 self internalizeIPandSP].
	self fetchHNextBytecode! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
popHStackBytecode

	self fetchHNextBytecode.
	self internalPop: 1.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHActiveContextBytecode
	| ourContext |
	ourContext := self ensureFrameIsMarried: localFP SP: localSP.
	self fetchHNextBytecode.
	self internalPush: ourContext! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHClosureCopyCopiedValuesBytecode
	"The compiler has pushed the values to be copied, if any.  Find numArgs and numCopied in the byte following.
	 Create a Closure with space for the copiedValues and pop numCopied values off the stack into the closure.
	 Set numArgs as specified, and set startpc to the pc following the block size and jump over that code."
	| newClosure numArgsNumCopied numArgs numCopied blockSize context |
	numArgsNumCopied := self fetchByte.
	numArgs := numArgsNumCopied bitAnd: 16rF.
	numCopied := numArgsNumCopied bitShift: -4.
	"Split blockSize := (self fetchByte * 256) + self fetchByte. into two because evaluation order in C is undefined."
	blockSize := self fetchByte << 8.
	blockSize := blockSize + self fetchByte.
	"No need to record the pushed copied values in the outerContext."
	context := self ensureFrameIsMarried: localFP SP: localSP + (numCopied * BytesPerWord).
	newClosure := self
					closureIn: context
					numArgs: numArgs
					instructionPointer: (self oopForPointer: localIP) + 2 - (method+BaseHeaderSize)
					numCopiedValues: numCopied.
	numCopied > 0 ifTrue:
		[0 to: numCopied - 1 do:
			[:i|
			"Assume: have just allocated a new BlockClosure; it must be young.
			 Thus, can use unchecked stores."
			 objectMemory storePointerUnchecked: i + ClosureFirstCopiedValueIndex
				ofObject: newClosure
				withValue: (self internalStackValue: numCopied - i - 1)].
		 self internalPop: numCopied].
	localIP := localIP + blockSize.
	self fetchHNextBytecode.
	self internalPush: newClosure! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantFalseBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory falseObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantMinusOneBytecode

	self fetchHNextBytecode.
	self internalPush: ConstMinusOne.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantNilBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory nilObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantOneBytecode

	self fetchHNextBytecode.
	self internalPush: ConstOne.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantTrueBytecode

	self fetchHNextBytecode.
	self internalPush: objectMemory trueObject.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantTwoBytecode

	self fetchHNextBytecode.
	self internalPush: ConstTwo.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHConstantZeroBytecode

	self fetchHNextBytecode.
	self internalPush: ConstZero.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHLiteralConstantBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to currentBytecode below will be constant"
	self pushLiteralConstant: (specialBytecode bitAnd: 16r1F)! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHLiteralVariableBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to currentBytecode below will be constant"
	self pushLiteralVariable: (specialBytecode bitAnd: 16r1F)! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHNewArrayBytecode
	| size popValues array |
	size := self fetchByte.
	popValues := size > 127.
	size := size bitAnd: 127.
	self fetchHNextBytecode.
	self externalizeIPandSP.
	array := objectMemory eeInstantiateClass: (objectMemory splObj: ClassArray) indexableSize: size.
	self internalizeIPandSP.
	popValues
		ifTrue:
			[0 to: size - 1 do:
				[:i|
				"Assume: have just allocated a new Array; it must be young. Thus, can use unchecked stores."
				objectMemory storePointerUnchecked: i ofObject: array withValue: (self internalStackValue: size - i - 1)].
			 self internalPop: size]
		ifFalse:
			[0 to: size - 1 do:
				[:i|
				objectMemory storePointerUnchecked: i ofObject: array withValue: objectMemory nilObject]].
	self internalPush: array! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHReceiverBytecode

	self fetchHNextBytecode.
	self internalPush: self receiver.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHReceiverVariableBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to specialBytecode below will be constant"
	self pushReceiverVariable: (specialBytecode bitAnd: 16rF)! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHRemoteTempLongBytecode
	| remoteTempIndex tempVectorIndex |
	remoteTempIndex := self fetchByte.
	tempVectorIndex := self fetchByte.
	self fetchHNextBytecode.
	self pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
pushHTemporaryVariableBytecode
	<expandCases>
	self fetchHNextBytecode.
	"this bytecode will be expanded so that refs to specialBytecode below will be constant"
	self pushTemporaryVariable: (specialBytecode bitAnd: 16rF)! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHFalse
	localReturnValue := objectMemory falseObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHNil
	localReturnValue := objectMemory nilObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHReceiver
	localReturnValue := self receiver.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHTopFromBlock
	"Return to the caller of the current block activation."
	localReturnValue := self internalStackTop.
	self commonCallerReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHTopFromMethod
	localReturnValue := self internalStackTop.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
returnHTrue
	localReturnValue := objectMemory trueObject.
	self commonReturn! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
secondHExtendedSendBytecode
	"This replaces the Blue Book double-extended super-send [134],
	which is subsumed by the new double-extended do-anything [132].
	It offers a 2-byte send of 0-3 args for up to 63 literals, for which 
	the Blue Book opcode set requires a 3-byte instruction."

	| descriptor |
	descriptor := self fetchByte.
	messageSelector := self literal: (descriptor bitAnd: 16r3F).
	argumentCount := descriptor >> 6.
	self normalSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
sendHLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self commonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
sendHLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self commonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
sendHLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (specialBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self hCommonSend! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'try' stamp: 'jb 1/19/2012 17:04'!
sendTest: class
	<inline:false>
	| returnValue ms ac lk sl nm fp ip sp lfp lip lsp pfc m  needToContinue methodHeader  |
	
	ms := messageSelector.
	ac := argumentCount.
	lk := lkupClass.
	sl := stackLimit.
	fp := framePointer.
	ip := instructionPointer.
	sp := stackPointer.
	"lfp := localFP."
	"lip := localIP."
	"lsp := localSP."
	
	messageSelector := self handlePropagateSelector.
	argumentCount := 1.
	lkupClass := class.
	
	self lookupMethodInClass: (self fetchClassOf: (self fetchClassOf: class)).
	
	self printOop: newMethod;cr.
	self printOop: messageSelector ;cr.
	methodHeader := self headerOf: newMethod.
	self printOop: (self findSelectorOfMethod: newMethod forReceiver: class).
	specialBytecode := objectMemory byteAt:  (self pointerForOop: (self initialPCForHeader: methodHeader method: newMethod)).
	counterLoop := 1.
	[counterLoop = 0] whileTrue: [self dispatchOn: specialBytecode in: SecondBytecodeTable].
	self print:'suis-je bon ? : ';cr.
	self printOop: (self internalStackTop);cr.
	
	
	"[true] whileTrue: [self dispatchOn: currentBytecode in: BytecodeTable]."
	"self fetchNextBytecode."
	"[true] whileTrue: [self dispatchOn: currentBytecode in: BytecodeTable.]."
	"localIP := localIP - 1.  
	self externalizeIPandSP."
	"self printOop:messageSelector ;cr.
	self printNum:argumentCount ;cr.
	self printOop:lkupClass ;cr.
	self printNum:stackLimit ;cr.
	self printOop:newMethod ;cr.
	self printNum: stackPointer;cr.
	self printNum: localSP;cr."
	
	
	"returnValue := self pop: 1."
	
	"messageSelector := ms.
	argumentCount := ac.
	lkupClass := lk.
	stackLimit := sl.
	framePointer := fp.
	instructionPointer := ip.
	stackPointer := sp."
"	localFP :=lfp.
	localIP :=lip.
	localSP := lsp."
	^nil
	! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
shortHConditionalJump

	self hJumplfFalseBy: (specialBytecode bitAnd: 7) + 1.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
shortHUnconditionalJump
	<expandCases>
	self hJump: (specialBytecode bitAnd: 7) + 1.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
singleHExtendedSendBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchHByte.
	messageSelector := self literal: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self normalSend.! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
singleHExtendedSuperBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchHByte.
	messageSelector := self literal: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self superclassSend.
! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
storeHAndPopReceiverVariableBytecode
	"Note: This code uses 
	storePointerUnchecked:ofObject:withValue: and does the 
	store check explicitely in order to help the translator 
	produce better code."
	| rcvr top |
	rcvr := self receiver.
	top := self internalStackTop.
	(self oop: rcvr isLessThan: objectMemory youngStart) ifTrue:
		[objectMemory possibleRootStoreInto: rcvr value: top].
	objectMemory storePointerUnchecked: (specialBytecode bitAnd: 7) ofObject: rcvr withValue: top.
	self fetchHNextBytecode.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
storeHAndPopRemoteTempLongBytecode
	self storeHRemoteTempLongBytecode.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
storeHAndPopTemporaryVariableBytecode
	<expandCases>
	"this bytecode will be expanded so that refs to specialBytecode below will be constant"
	self fetchHNextBytecode.
	self temporary: (specialBytecode bitAnd: 7) in: localFP put: self internalStackTop.
	self internalPop: 1! !

!HSCStackInterpreterPrimitivesBytecodeHack2 methodsFor: 'bytecode' stamp: 'jb 1/19/2012 17:04'!
storeHRemoteTempLongBytecode
	| remoteTempIndex tempVectorIndex |
	remoteTempIndex := self fetchHByte.
	tempVectorIndex := self fetchHByte.
	self fetchHNextBytecode.
	self storeRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'primitive support' stamp: 'jb 11/7/2011 16:32'!
arrayVersionOf: oop
	
	| value |
	value := objectMemory instantiateClass: (objectMemory splObj: ClassArray) indexableSize: 1.
	objectMemory stObject: value at: 1 put: oop.
	^value! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'support state' stamp: 'arnaudJeanBaptiste 4/7/2012 10:31'!
checkHandleArray: array
	| hdr fmt totalLength fixedFields indexedFields |
		hdr := objectMemory baseHeader: array.
		fmt := objectMemory formatOfHeader: hdr.
		totalLength := objectMemory lengthOf: array baseHeader: hdr format: fmt.
		fixedFields := objectMemory fixedFieldsOf: array format: fmt length: totalLength.
		indexedFields := totalLength - fixedFields.
		1 to: indexedFields do:[:i | | h hOfH |
			h := (objectMemory stObject: array at: i).
			((self internalIsHandle: h) or: [objectMemory nilObject]) ifFalse: [^false]].
		^true! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'support state' stamp: 'arnaudJeanBaptiste 4/7/2012 10:38'!
installAllHandle: array
	| hdr fmt totalLength fixedFields indexedFields |
		hdr := objectMemory baseHeader: array.
		fmt := objectMemory formatOfHeader: hdr.
		totalLength := objectMemory lengthOf: array baseHeader: hdr format: fmt.
		fixedFields := objectMemory fixedFieldsOf: array format: fmt length: totalLength.
		indexedFields := totalLength - fixedFields.
		1 to: indexedFields do:[:i | | h hOfH |
			((objectMemory stObject: array at: i) = objectMemory nilObject) ifFalse:[ 
				h := (objectMemory stObject: array at: i).
				self installHandle: h]].
		^true! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'support state' stamp: 'arnaudJeanBaptiste 4/11/2012 17:33'!
installHandle: handle
| hdr fmt totalLength fixedFields indexedFields hClone targetObject |
	hClone := objectMemory fetchPointer: HandleCloneIndex ofObject: handle.
	targetObject := objectMemory fetchPointer: HandleReceiverIndex ofObject: handle.
	(self handleUseState: handle) ifTrue: [ 
			"copy current state"
			hdr := objectMemory baseHeader: targetObject.
			fmt := objectMemory formatOfHeader: hdr.
			totalLength := objectMemory lengthOf: targetObject baseHeader: hdr format: fmt.
			fixedFields := objectMemory fixedFieldsOf: targetObject format: fmt length: totalLength.
			indexedFields := totalLength - fixedFields.
			
			1 to: fixedFields do:
				[:i| | value | 
				value := objectMemory fetchPointer: (i-1) ofObject: hClone.
				objectMemory storePointer:  (i-1) ofObject: targetObject withValue: value].
			1 to: indexedFields do:
				[:i| 
				objectMemory stObject: targetObject at: i put: (objectMemory stObject: hClone at: i)].
			].
	"become forward"
	self become: (self arrayVersionOf: handle) with: (self arrayVersionOf: targetObject) twoWay: false copyHash: true.

	^targetObject! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'behavior support' stamp: 'jb 2/1/2012 18:47'!
lookupMethodInClass: class
	| currentClass dictionary found |
	<inline: false>
	self assert: class ~~ objectMemory nilObject.
	currentClass := class.
	[currentClass ~= objectMemory nilObject]
		whileTrue:
		[dictionary := objectMemory fetchPointer: MethodDictionaryIndex ofObject: currentClass.
		dictionary = objectMemory nilObject ifTrue: [
			"MethodDict pointer is nil (hopefully due a swapped out stub)
				-- raise exception #cannotInterpret:."
			self createActualMessageTo: class.
			messageSelector := objectMemory splObj: SelectorCannotInterpret.
			self sendBreak: messageSelector + BaseHeaderSize
				point: (objectMemory lengthOf: messageSelector)
				receiver: nil.
			^self lookupMethodInClass: (self superclassOf: currentClass)].
		found := self lookupMethodInDictionary: dictionary.
		found ifTrue: [
			^currentClass].
		currentClass := self superclassOf: currentClass].

	"Could not find #doesNotUnderstand: -- unrecoverable error."
	messageSelector = (objectMemory splObj: SelectorDoesNotUnderstand) ifTrue:
		[self error: 'Recursive not understood error encountered'].

	"Cound not find a normal message -- raise exception #doesNotUnderstand:"
	self createActualMessageTo: class.
	messageSelector := objectMemory splObj: SelectorDoesNotUnderstand.
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: nil.
	^self lookupMethodInClass: class! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'bytecode behavior ' stamp: 'jb 2/1/2012 19:28'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr classPointer|
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue:[
		lkupClass :=   (self handleInlineClassLookupOf: rcvr).].
	self commonSend.! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'support state' stamp: 'arnaudJeanBaptiste 4/6/2012 17:04'!
primitiveInstall
	<export:true>
	 
	| handle  |
	handle := self stackTop.
	self pop:1.
	(self internalIsHandle: handle) ifTrue: [
		self installHandle: handle.
		self push: handle.]
	ifFalse: [
		self push: objectMemory falseObject.
		self primitiveFail.].! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'support state' stamp: 'arnaudJeanBaptiste 4/6/2012 17:46'!
primitiveInstallAll
	<export:true>
	 
	| array  |
	array := self stackTop.
	self pop:1.
	(self checkHandleArray: array) ifTrue: [
		self installAllHandle: array.
		self push: array.]
	ifFalse: [
		self push: objectMemory falseObject.
		self primitiveFail.].! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'identity prim' stamp: 'jb 2/1/2012 16:20'!
primitiveIsHandle
	<export:true>
	
	| oop |
	oop := self stackTop.
	(self internalIsHandle: oop) 
		ifTrue:  [ self pop:1 thenPush: objectMemory trueObject ]
		ifFalse: [ self pop:1 thenPush: objectMemory falseObject]
	! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'bytecode behavior ' stamp: 'jb 2/1/2012 19:28'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue:[
		lkupClass :=   (self handleInlineClassLookupOf: rcvr).].
	self commonSend.! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'bytecode behavior ' stamp: 'jb 2/1/2012 19:28'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue:[
		lkupClass :=   (self handleInlineClassLookupOf: rcvr).].
	self commonSend.! !

!HSCStackInterpreterPrimitivesStateManagement methodsFor: 'bytecode behavior ' stamp: 'jb 2/1/2012 19:28'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue:[
		lkupClass :=   (self handleInlineClassLookupOf: rcvr).].
	self commonSend.! !

!HSCStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
initialize
	"self initialize"
	super initialize.
	self initializeHandleIndices .! !

!HSCStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 18:35'!
initializeHandleIndices
	"self initializeHandleIndices"
	HandleReceiverIndex := 0.
	HandleClassLookupIndex := 1.
	HandleCloneIndex := 2.
	HandleConfigurationIndex := 3.
	
	"initialize specialObject Array"
	ClassHandle := 56.
	"propagationMethod."
	HandlePropagationSelectorIndex := 57
	
	"bit in the header"! !

!HSCStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
initializePrimitiveTable
	"self initializePrimitiveTable"
	super initializePrimitiveTable.
	self assert: (PrimitiveTable at: 550) = #primitiveFail.
	PrimitiveTable at: (550) put: #primitiveAsHandle! !

!HSCStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 2/1/2012 16:01'!
objectMemoryClass
	^HNewObjectMemory! !

!HSCStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 17:11'!
prepareToBeAddedToCodeGenerator: aCCodeGenerator
	"Override to avoid repeating Cogit's preparations and remove the methods we override."
	self selectors do:
		[:sel|
		 (self includesSelector: sel) ifTrue:
			[aCCodeGenerator removeMethodForSelector: sel]]! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 10/7/2011 17:11'!
classHandle

	<inline: false>
	^objectMemory splObj: ClassHandle! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/7/2011 17:11'!
classHandleInline
	<inline: true>
	^objectMemory splObj: ClassHandle! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 2/1/2012 16:41'!
handleClassLookupOf: oop 
	<inline: false>
	| classPointer |
	(self handleUseBehavior: oop) 
		ifTrue: [
			classPointer := objectMemory fetchPointer: HandleClassLookupIndex ofObject: oop.
			(self internalIsHandle: classPointer) 
				ifTrue: [classPointer := self handleCloneOf: classPointer]]
		ifFalse: [
			classPointer := self fetchClassOf: (self handleInlineReceiverOf: oop)].
	^classPointer! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 10/7/2011 17:16'!
handleCloneOf: oop
	<inline: false>
		^objectMemory fetchPointer: HandleCloneIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 10/7/2011 17:11'!
handleConfigurationOf: oop
	<inline: false>
		^objectMemory fetchPointer: HandleConfigurationIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 2/1/2012 16:41'!
handleInlineClassLookupOf: oop 
	<inline: true>
	| classPointer |
	(self handleInlineUseBehavior: oop) 
		ifTrue: [
			classPointer := objectMemory fetchPointer: HandleClassLookupIndex ofObject: oop.
			(self internalIsHandle: classPointer) ifTrue: [
				classPointer := self handleInlineCloneOf: classPointer]]
		ifFalse: [
			classPointer := objectMemory fetchClassOf: (self handleInlineReceiverOf: oop)].
	^classPointer! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/7/2011 17:16'!
handleInlineCloneOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleCloneIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlineConfigurationOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleConfigurationIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlinePropagateSelector
	<inline: true>
	^objectMemory splObj: HandlePropagationSelectorIndex.! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 2/1/2012 16:04'!
handleInlineReceiverOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleReceiverIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlineUseBehavior: oop
	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1)bitAnd: 2.

! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlineUsePropagation: oop

	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 8.

! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlineUseSelfWrapping: oop 
	
	<inline:true>
	^ (self handleInlineConfigurationOf: oop)
		>> 1 bitAnd: 4! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
handleInlineUseState: oop
	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 1.

! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 10/7/2011 17:11'!
handlePropagateSelector
	<inline: false>
	^objectMemory splObj: HandlePropagationSelectorIndex.! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 2/1/2012 16:01'!
handleReceiverOf: oop
	<inline: false>
	^objectMemory fetchPointer: HandleReceiverIndex ofObject: oop
! !

!HSCStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 10/7/2011 17:11'!
handleUseBehavior: oop

	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1)bitAnd: 2.

! !

!HSCStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 10/7/2011 17:11'!
handleUsePropagation: oop

	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 8.

! !

!HSCStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 10/7/2011 17:11'!
handleUseSelfWrapping: oop 
	
	<inline:false>
	^ (self handleInlineConfigurationOf: oop)
		>> 1 bitAnd: 4! !

!HSCStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 10/7/2011 17:11'!
handleUseState: oop
	
	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 1.

! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 1/4/2012 15:46'!
internalIsHandle: oop
	<inline: true>
	(objectMemory isNonIntegerObject: oop) 
		ifTrue: [
			 ((objectMemory handleBitValueOf: oop) ~~ 0) ifTrue: [
				^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HSCStackInterpreterRoot methodsFor: 'support' stamp: 'jb 10/7/2011 17:11'!
internalStackPageAt: offset put: value
	stackPages longAtPointer: localSP + (offset * BytesPerWord) put: value.! !

!HSCStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 2/1/2012 16:02'!
isAHandle: oop
	
	<inline:false>
	<export: false>
	(objectMemory isNonIntegerObject: oop) 
		ifTrue: [((objectMemory handleBitValueOf: oop) ~~ 0) 
				ifTrue: [^true] 
				ifFalse: [^false]]
		ifFalse: [^ false].! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
isActiveMetaHandle: oop
	| receiverOfHandle |
	
	<inline:true>
	receiverOfHandle := (self handleInlineReceiverOf: oop).
	^(self internalIsHandle: receiverOfHandle).! !

!HSCStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 10/7/2011 17:11'!
isHandle: oop

	<inline: true>
	^(oop = self classHandle)! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
isInstanceOfHandle: oop
	<inline: true>
	^self isSubHandle: (objectMemory fetchClassOf: oop).! !

!HSCStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 10/7/2011 17:11'!
isSubHandle: aClass

	|cc|
	<inline: true>
	cc := aClass.
	[cc = objectMemory nilObject.] whileFalse:[(self isHandle: cc) ifTrue:[^true] .
			cc := self superclassOf:  cc].
	^false! !

!HSCStackInterpreterRoot methodsFor: 'handle primitive' stamp: 'jb 10/7/2011 17:11'!
primitiveAsHandle
	| rcvr |
	<inline: true>
	<export: true>
	rcvr := self stackTop.
	(self isInstanceOfHandle: rcvr) ifTrue: [
		(self isActiveMetaHandle: rcvr)
			ifTrue: [^self primitiveFail.]
			ifFalse:[
				objectMemory setHandleBit: rcvr]].! !

!HSCStackInterpreterRoot methodsFor: 'handle propagation support' stamp: 'jb 1/30/2012 23:50'!
pushHandle: aHandle propagateValue: aObject
	
|   handleClass handleMetaClass |
      <inline: false>
	<export: true>

		"initialize Part"
		handleClass := objectMemory fetchClassOf: aHandle.
		handleMetaClass := objectMemory fetchClassOf: handleClass.
		self push:  handleClass.
		self push: aObject.
		messageSelector :=self handlePropagateSelector.
		argumentCount := 1.
		"Sending message Part"
		"From here  "
		self lookupMethodInClass: handleMetaClass.
		lkupClass := handleMetaClass.
		self activateNewMethod.
	! !

StackInterpreterPrimitives subclass: #HStackInterpreterFCR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-FCR'!

!HStackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:46'!
initializePrimitiveTable
	"self initializePrimitiveTable"
	super initializePrimitiveTable.
	self assert: (PrimitiveTable at: 550) = #primitiveFail.
	PrimitiveTable at: (550) put: #primitiveAsHandle.
	PrimitiveTable at: (551) put: #primitiveCheckHandleForObject.
	PrimitiveTable at: (552) put: #primitiveCheck.
	! !

!HStackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:30'!
objectMemoryClass
	^HNewObjectMemoryFCR! !

!HStackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:30'!
prepareToBeAddedToCodeGenerator: aCCodeGenerator
	"Override to avoid repeating Cogit's preparations and remove the methods we override."
	self selectors do:
		[:sel|
		 (self includesSelector: sel) ifTrue:
			[aCCodeGenerator removeMethodForSelector: sel]]! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:58'!
createHandleOn: oop to: classObject

	| aClass spaceOkay handle |
	aClass := self classHandle.
	spaceOkay := self sufficientSpaceToInstantiate: aClass indexableSize: 0.
	handle := (objectMemory instantiateClass: aClass indexableSize: 0).
	self initializeEmptyHandle: handle with: oop to: classObject.
	^handle
	! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:55'!
initializeEmptyHandle: handle with: oop to: classObject
	| nilValue |
	(self isInstanceOfHandle: handle) ifTrue: [
		nilValue := objectMemory nilObject.
		objectMemory storePointer: 0 ofObject: handle withValue: oop. 
		objectMemory storePointer: 1 ofObject: handle withValue: classObject.
		objectMemory storePointer: 2 ofObject: handle withValue: classObject.
		objectMemory storePointer: 3 ofObject: handle withValue: (objectMemory integerObjectOf:4).]
	! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:40'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	self commonSend! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 8/11/2011 15:40'!
primitiveAsHandle
	| rcvr |
	self inline: true.
	self export: true.
	
	rcvr := self stackTop.
	self internalPop:1.
	self replaceClassPointerByHandlePointer: rcvr.
	
	^self internalPush: (objectMemory handleInlineClassLookupOf: (objectMemory classHeader: (rcvr))).! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:52'!
primitiveCheck

	| rcvr |
	self inline: true.
	self export: true.
	rcvr :=  self stackTop.
	self pop:1.
	^self push: (objectMemory handleClassLookupOf: (objectMemory classHeader: (rcvr))).! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:26'!
primitiveCheckHandleForObject

	| rcvr |
	self inline: true.
	self export: true.
	rcvr :=  self stackTop.
	self pop:1.
	^self push: ((objectMemory classHeader: rcvr) bitAnd: AllButTypeMask).! !

!HStackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/7/2011 17:31'!
replaceClassPointerByHandlePointer: oop
	| class handle |
	class := objectMemory fetchClassOf: oop.
	handle := self createHandleOn: oop to: class.
	self baseHeader: (oop - BaseHeaderSize) put: handle.
	objectMemory setHandleBit: oop.
	^true! !

StackInterpreterPrimitives subclass: #HStackInterpreterRoot
	instanceVariableNames: ''
	classVariableNames: 'ClassHandle HandleClassLookupIndex HandleConfigurationIndex HandleIndexedFieldIndex HandlePropagationSelectorIndex HandleReceiverIndex HandleStateIndex'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

HStackInterpreterRoot subclass: #HStackInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

!HStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
declareCVarsIn: aCCodeGenerator
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator var: #hPrimitiveTable
		declareC: 'void (*hPrimitiveTable[MaxPrimitiveIndex + 2 /* ', (MaxPrimitiveIndex +2) printString, ' */])(void) = ', self hPrimitiveTableString.
	! !

!HStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
hPrimitiveTable

	^ HPrimitiveTable! !

!HStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
hPrimitiveTableString
	"StackInterpreter initializePrimitiveTable primitiveTableString"
	^String streamContents:
		[:s | 
		s nextPut: ${.
		self hPrimitiveTable withIndexDo:
			[:primSpec :index |
			s
				crtab;
				nextPutAll: '/* ';
				print: index - 1;
				nextPutAll: ' */ ';
				nextPutAll: (primSpec isString
								ifTrue: [primSpec == #primitiveFail
											ifTrue: ['(void (*)(void))0']
											ifFalse: [primSpec]]
								ifFalse: ['(void (*)(void))', primSpec printString]);
				nextPut: $,].
			s cr; nextPutAll: ' 0 }']! !

!HStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
initializeHandlePrimitiveTables 

	HPrimitiveTable := Array new: MaxPrimitiveIndex + 1.
	self table: HPrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called")
		(1 primitiveAdd)				"not need handle version"
		(2 primitiveSubtract)			"not need handle version"
		(3 primitiveLessThan)			"not need handle version"
		(4 primitiveGreaterThan)		"not need handle version"
		(5 primitiveLessOrEqual)		"not need handle version"
		(6 primitiveGreaterOrEqual)		"not need handle version"
		(7 primitiveEqual)				"not need handle version"
		(8 primitiveNotEqual)			"not need handle version"
		(9 primitiveMultiply)				"not need handle version"
		(10 primitiveDivide)				"not need handle version"
		(11 primitiveMod)				"not need handle version"
		(12 primitiveDiv)				"not need handle version"
		(13 primitiveQuo)				"not need handle version"
		(14 primitiveBitAnd)			"not need handle version"
		(15 primitiveBitOr)				"not need handle version"
		(16 primitiveBitXor)				"not need handle version"
		(17 primitiveBitShift)			"not need handle version"
		(18 primitiveMakePoint)			"not need handle version"
		(19 primitiveFail)				"not need handle version"

		"LargeInteger Primitives (20-37)"
		(20 primitiveFail)								"not need handle version"
		(21 primitiveAddLargeIntegers)					"not need handle version"
		(22 primitiveSubtractLargeIntegers)			"not need handle version"
		(23 primitiveLessThanLargeIntegers)			"not need handle version"
		(24 primitiveGreaterThanLargeIntegers)		"not need handle version"
		(25 primitiveLessOrEqualLargeIntegers)		"not need handle version"
		(26 primitiveGreaterOrEqualLargeIntegers)		"not need handle version"
		(27 primitiveEqualLargeIntegers)				"not need handle version"
		(28 primitiveNotEqualLargeIntegers)			"not need handle version"
		(29 primitiveMultiplyLargeIntegers)				"not need handle version"
		(30 primitiveDivideLargeIntegers)				"not need handle version"
		(31 primitiveModLargeIntegers)				"not need handle version"
		(32 primitiveDivLargeIntegers)					"not need handle version"
		(33 primitiveQuoLargeIntegers)				"not need handle version"
		(34 primitiveBitAndLargeIntegers)				"not need handle version"
		(35 primitiveBitOrLargeIntegers)				"not need handle version"
		(36 primitiveBitXorLargeIntegers)				"not need handle version"
		(37 primitiveBitShiftLargeIntegers)				"not need handle version"

		"Float Primitives (38-59)"
		(38 primitiveFloatAt)							"not need handle version"
		(39 primitiveFloatAtPut)							"not need handle version"
		(40 primitiveAsFloat)							"not need handle version"
		(41 primitiveFloatAdd)							"not need handle version"
		(42 primitiveFloatSubtract)						"not need handle version"
		(43 primitiveFloatLessThan)					"not need handle version"
		(44 primitiveFloatGreaterThan)					"not need handle version"
		(45 primitiveFloatLessOrEqual)					"not need handle version"
		(46 primitiveFloatGreaterOrEqual)				"not need handle version"
		(47 primitiveFloatEqual)							"not need handle version"
		(48 primitiveFloatNotEqual)						"not need handle version"
		(49 primitiveFloatMultiply)						"not need handle version"
		(50 primitiveFloatDivide)						"not need handle version"
		(51 primitiveTruncated)							"not need handle version"
		(52 primitiveFractionalPart)						"not need handle version"
		(53 primitiveExponent)							"not need handle version"
		(54 primitiveTimesTwoPower)					"not need handle version"
		(55 primitiveSquareRoot)						"not need handle version"
		(56 primitiveSine)								"not need handle version"
		(57 primitiveArctan)							"not need handle version"
		(58 primitiveLogN)								"not need handle version"
		(59 primitiveExp)								"not need handle version"

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveAt)									"fixed field handle"
		(61 primitiveAtPut)								"fixed field handle"
		(62 primitiveSize)								"fixed field handle"				
		(63 primitiveStringAt)							"fixed field handle"
		(64 primitiveStringAtPut)						"fixed field handle"
		"The stream primitives no longer pay their way; normal Smalltalk code is faster."
		(65 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(66 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(67 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"

		"StorageManagement Primitives (68-79)"
		(68 primitiveObjectAt)							"fixed field handle"
		(69 primitiveObjectAtPut)						"fixed field handle"
		(70 primitiveNew)								"class handle"
		(71 primitiveNewWithArg)						"class handle"
		(72 primitiveArrayBecomeOneWay)				"hum hum"
		(73 primitiveHInstVarAt)						"handle version state"
		(74 primitiveHInstVarAtPut)						"handle version state"
		(75 primitiveHIdentityHash)						"handle version identity"
		(76 primitiveStoreStackp)						"not need handle version"		
		(77 primitiveSomeInstance)						"not need handle version"
		(78 primitiveNextInstance)						"not need handle version"
		(79 primitiveNewMethod)						"??????"

		"Control Primitives (80-89)"
		(80 primitiveFail)								"not need handle version"
		(81 primitiveFail)								"not need handle version"
		(82 primitiveFail)								"not need handle version"
		(83 primitiveHPerform)							"shadow handle"
		(84 primitiveHPerformWithArgs)				"shadow handle"
		(85 primitiveSignal)								"not need handle version"
		(86 primitiveWait)								"not need handle version"
		(87 primitiveResume)							"not need handle version"
		(88 primitiveSuspend)							"not need handle version"
		(89 primitiveFlushCache)						"not need handle version"

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)						"not need handle version"
		(91 primitiveTestDisplayDepth)					"not need handle version"
		(92 primitiveSetDisplayMode)					"not need handle version"
		(93 primitiveInputSemaphore)					"not need handle version"
		(94 primitiveGetNextEvent)						"not need handle version"
		(95 primitiveInputWord)						
		(96 primitiveFail)								"not need handle version"
		(97 primitiveSnapshot)							"not need handle version"
		(98 primitiveStoreImageSegment)				"not need handle version"
		(99 primitiveLoadImageSegment)				"not need handle version"
		(100 primitivePerformInSuperclass)				"shadow handle"
		(101 primitiveBeCursor)						"not need handle version"
		(102 primitiveBeDisplay)						"not need handle version"
		(103 primitiveScanCharacters)					
		(104 primitiveFail)	"primitiveDrawLoop"		"not need handle version"
		(105 primitiveStringReplace)			
		(106 primitiveScreenSize)				"not need handle version"
		(107 primitiveMouseButtons)			"not need handle version"
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)			

		"System Primitives (110-119)"
		(110 primitiveHIdentical)		"handle version"
		(111 primitiveHClass)			"handle version"
		(112 primitiveBytesLeft)		"not need handle version"
		(113 primitiveQuit)				"not need handle version"
		(114 primitiveExitToDebugger)	"not need handle version"
		(115 primitiveHChangeClass)	"handle version"
		(116 primitiveFlushCacheByMethod)	"not need handle version"
		(117 primitiveExternalCall)				"not need handle version"
		(118 primitiveDoPrimitiveWithArgs) 	"not need handle version"
		(119 primitiveFlushCacheBySelector)	"not need handle version"
			"Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.
			Both are supported for backward compatibility."

		"Miscellaneous Primitives (120-127)"
		(120 primitiveCalloutToFFI)				"not need handle version"
		(121 primitiveImageName)				"not need handle version"
		(122 primitiveNoop)					"not need handle version"
		(123 primitiveFail)						"not need handle version"
		(124 primitiveLowSpaceSemaphore)	"not need handle version"
		(125 primitiveSignalAtBytesLeft)		"not need handle version"

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)	"not need handle version"
		(127 primitiveShowDisplayRect)		"not need handle version"
		(128 primitiveArrayBecome)			"not need handle version"
		(129 primitiveSpecialObjectsOop)		"not need handle version"
		(130 primitiveFullGC)					"not need handle version"
		(131 primitiveIncrementalGC)			"not need handle version"
		(132 primitiveHObjectPointsTo)		"hum hum"
		(133 primitiveSetInterruptKey)			"not need handle version"
		(134 primitiveInterruptSemaphore)		"not need handle version"
		(135 primitiveMillisecondClock)			"not need handle version"
		(136 primitiveSignalAtMilliseconds)		"not need handle version"
		(137 primitiveSecondsClock)			"not need handle version"
		(138 primitiveSomeObject)				" hum hum"
		(139 primitiveNextObject)				" hum hum"
		(140 primitiveBeep)					"not need handle version"
		(141 primitiveClipboardText)			"not need handle version"
		(142 primitiveVMPath)					"not need handle version"
		(143 primitiveShortAt)					"hum hum"
		(144 primitiveShortAtPut)				"hum hum"
		(145 primitiveConstantFill)				"hum hum"
		"NOTE: When removing the obsolete indexed primitives,
		the following two should go become #primitiveIntegerAt / atPut"
		(146 primitiveFail)						"not need handle version"
		(147 primitiveFail)						"not need handle version"
		(148 primitiveClone)					"not need handle version"
		(149 primitiveGetAttribute)				"not need handle version"

		"File Primitives (150-169) - NO LONGER INDEXED"
		(150 159 primitiveFail)					"not need handle version"
		(160 primitiveAdoptInstance)			"hum hum"
		(161 primitiveSetIdentityHash)
		(162 164 primitiveFail)					"not need handle version"
		(165 primitiveIntegerAt)				"hum hum"
		(166 primitiveIntegerAtPut)				"hum hum"
		(167 primitiveYield)						"hum hum"
		(168 primitiveCopyObject)				"not need handle version"
		(169 primitiveFail)						"not need handle version"

		"Sound Primitives (170-199) - NO LONGER INDEXED"
		(170 174 primitiveFail)

		"CogMemoryManager primitives"
		(175 primitiveBehaviorHash)			"not need handle version"	
		(176 primitiveMaxIdentityHash)			"not need handle version"
		(177 184 primitiveFail)					"not need handle version"

		"CriticalSection primitives"
		(185 primitiveExitCriticalSection)		"not need handle version"
		(186 primitiveEnterCriticalSection) 		"not need handle version"
		(187 primitiveTestAndSetOwnershipOfCriticalSection) "not need handle version"

		"Perform method directly"
		(188 primitiveExecuteMethodArgsArray) 		"shadow handle"
		(189 primitiveExecuteMethod)					"shadow handle"

		"Sound Primitives (continued) - NO LONGER INDEXED"
		(190 194 primitiveFail)					 "not need handle version"

		"Unwind primitives"
		(195 primitiveFindNextUnwindContext)	"not need handle version"
		(196 primitiveTerminateTo)				 "not need handle version"
		(197 primitiveFindHandlerContext)		 "not need handle version"
		(198 primitiveMarkUnwindMethod)		 "not need handle version"
		(199 primitiveMarkHandlerMethod)		 "not need handle version"

		"new closure primitives (were Networking primitives)"
		(200 primitiveClosureCopyWithCopiedValues)	 			"not need handle version"
		(201 primitiveClosureValue)  								"not need handle version"
		(202 primitiveClosureValue)  								"not need handle version"
		(203 primitiveClosureValue) 								"not need handle version"
		(204 primitiveClosureValue) 								"not need handle version"
		(205 primitiveClosureValue)								"not need handle version"
		(206 primitiveClosureValueWithArgs) 	 					"not need handle version"

		(207 209 primitiveFail)	"reserved for Cog primitives"

		(210 primitiveContextAt)								"hum hum"
		(211 primitiveContextAtPut)							"hum hum"
		(212 primitiveContextSize)								"hum hum"
		(213 primitiveContextXray)								"hum hum"
		(214 primitiveVoidVMState)								"not need handle version"
		(215 217 primitiveFail)	"reserved for Cog primitives"	"not need handle version"
		(218 primitiveDoNamedPrimitiveWithArgs)				"hum hum"
		(219 primitiveFail)										"not need handle version"
		(220 primitiveFail)										"not need handle version"

		(221 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch"	"not need handle version"
		(222 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch:" "not need handle version"

		(223 229 primitiveFail)	"not need handle version"

		(230 primitiveRelinquishProcessor)												"not need handle version"
		(231 primitiveForceDisplayUpdate)												"not need handle version"
		(232 primitiveFormPrint)														"not need handle version"
		(233 primitiveSetFullScreen)													"not need handle version"
		(234 primitiveFail) "primBitmapdecompressfromByteArrayat"					"not need handle version"
		(235 primitiveFail) "primStringcomparewithcollated"							"not need handle version"
		(236 primitiveFail) "primSampledSoundconvert8bitSignedFromto16Bit"			"not need handle version"
		(237 primitiveFail) "primBitmapcompresstoByteArray"							"not need handle version"
		(238 239 primitiveFail) "serial port primitives"									"not need handle version"
		(240 primitiveUTCMicrosecondClock)											"not need handle version"
		(241 primitiveLocalMicrosecondClock)											"not need handle version"
		(242 primitiveSignalAtUTCMicroseconds)										"not need handle version"
		(243 primitiveUpdateTimezone) "primStringtranslatefromtotable"				"not need handle version"
		(244 primitiveFail) "primStringfindFirstInStringinSetstartingAt"					"not need handle version"
		(245 primitiveFail) "primStringindexOfAsciiinStringstartingAt"					"not need handle version"
		(246 primitiveFail) "primStringfindSubstringinstartingAtmatchTable"				"not need handle version"
		(247 primitiveSnapshotEmbedded)												"not need handle version"
		(248 primitiveFail) "primitiveInvokeObjectAsMethod"							"not need handle version"
		(249 primitiveArrayBecomeOneWayCopyHash)									"hum hum"

		"VM Implementor Primitives (250-255)"
		(250 primitiveClearVMProfile)													"not need handle version"
		(251 primitiveControlVMProfiling)												"not need handle version"
		(252 primitiveVMProfileSamplesInto)											"not need handle version"
		(253 primitiveFail )																"not need handle version"
		(254 primitiveVMParameter)													"not need handle version"
		(255 primitiveFail) 																"not need handle version"

		"Quick Push Const Methods"
		(256 primitiveHPushSelf) "primitivePushSelf"													"handle version"
		(257 nil) "primitivePushTrue"													"not need handle version"
		(258 nil) "primitivePushFalse"													"not need handle version"
		(259 nil) "primitivePushNil"														"not need handle version"
		(260 nil) "primitivePushMinusOne"												"not need handle version"
		(261 nil) "primitivePushZero"													"not need handle version"
		(262 nil) "primitivePushOne"													"not need handle version"
		(263 nil) "primitivePushTwo"													"not need handle version"

		"Quick Push Inst Var Methods"
		(264 519 nil) "primitiveLoadInstVar"											 "Handle"

		(520 primitiveFail)
		"MIDI Primitives (521-539) - NO LONGER INDEXED"
		(521 529 primitiveFail)						 "not need handle version"
		(530 539 primitiveFail)  					 "not need handle version"

		"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
		"Pen Tablet Primitives - NO LONGER INDEXED"
		(540 549 primitiveFail)						 "not need handle version"

		"Sound Codec Primitives - NO LONGER INDEXED"
		(550 569 primitiveFail)						 "not need handle version"

		"External primitive support primitives"
		(570 primitiveFlushExternalPrimitives)		 "not need handle version"
		(571 primitiveUnloadModule)				 "not need handle version"
		(572 primitiveListBuiltinModule)				 "not need handle version"
		(573 primitiveListExternalModule)			 "not need handle version"
		(574 primitiveFail) 							 "not need handle version"

		"Unassigned Primitives"
		(575 primitiveFail)							 "not need handle version")! !

!HStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
requiredMethodNames
	^super requiredMethodNames addAll: self hPrimitiveTable; yourself! !

!HStackInterpreter methodsFor: 'handle primitives' stamp: 'jb 5/11/2011 16:27'!
bytecodePrimClass
	| rcvr |
	rcvr := self internalStackTop.
	(self internalIsHandle: rcvr)
		ifTrue:[rcvr :=  (self handleReceiverOf: rcvr).].
	self internalPop: 1 thenPush: (self fetchClassOf: rcvr).
	self fetchNextBytecode.
! !

!HStackInterpreter methodsFor: 'handle identity' stamp: 'jb 5/10/2011 15:16'!
bytecodePrimEquivalent

	| rcvr arg |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self internalIsHandle: arg)
		ifTrue:[arg :=  (self handleReceiverOf: arg).].
	(self internalIsHandle: rcvr)
		ifTrue:[rcvr :=  (self handleReceiverOf: rcvr).].
	self booleanCheat: rcvr = arg.! !

!HStackInterpreter methodsFor: 'handle self wrapping' stamp: 'jb 9/27/2011 14:23'!
commonReturn
	"Note: Assumed to be inlined into the dispatch loop."

	| closure home unwindContextOrNilOrZero frameToReturnTo contextToReturnTo theFP callerFP newPage |
	<var: #frameToReturnTo type: #'char *'>
	<var: #theFP type: #'char *'>
	<var: #callerFP type: #'char *'>
	<var: #newPage type: #'StackPage *'>
	<var: #thePage type: #'StackPage *'>
	<sharedCodeNamed: 'commonReturn' inCase: 120>
	
	"If this is a method simply return to the  sender/caller."
	(self frameIsBlockActivation: localFP) ifFalse:
		[^self commonCallerReturn].

	"Since this is a block activation the closure is on the stack above any args and the frame."
	closure := self pushedReceiverOrClosureOfFrame: localFP.

	home := nil.
	"Walk the closure's lexical chain to find the context or frame to return from (home)."
	[closure ~~ objectMemory nilObject] whileTrue:
		[home := objectMemory fetchPointer: ClosureOuterContextIndex ofObject: closure.
		 closure := objectMemory fetchPointer: ClosureIndex ofObject: home].
	"home is to be returned from provided there is no unwind-protect activation between
	 this frame and home's sender.  Search for an unwind.  findUnwindThroughContext:
	 will answer either the context for an unwind-protect activation or nilObj if the sender
	 cannot be found or 0 if no unwind is found but the sender is.  We must update the
	 current page's headFrame pointers to enable the search to identify widowed contexts
	 correctly."
	self writeBackHeadFramePointers.
	unwindContextOrNilOrZero := self internalFindUnwindThroughContext: home.
	unwindContextOrNilOrZero = objectMemory nilObject ifTrue:
		["error: can't find home on chain; cannot return"
		 ^self internalCannotReturn: localReturnValue].
	unwindContextOrNilOrZero ~~ 0 ifTrue:
		[^self internalAboutToReturn: localReturnValue through: unwindContextOrNilOrZero].

	"Now we know home is on the sender chain.
	 We could be returning to either a context or a frame.  Find out which."
	contextToReturnTo := nil.
	(self isMarriedOrWidowedContext: home)
		ifTrue:
			[self assert: (self checkIsStillMarriedContext: home currentFP: localFP).
			 theFP := self frameOfMarriedContext: home.
			 (self isBaseFrame: theFP)
				ifTrue:
					[contextToReturnTo := self frameCallerContext: theFP]
				ifFalse:
					[frameToReturnTo := self frameCallerFP: theFP]]
		ifFalse:
			[contextToReturnTo := objectMemory fetchPointer: SenderIndex ofObject: home.
			 ((self isContext: contextToReturnTo)
			  and: [self isMarriedOrWidowedContext: contextToReturnTo]) ifTrue:
				[self assert: (self checkIsStillMarriedContext: contextToReturnTo currentFP: localFP).
			 	 frameToReturnTo := self frameOfMarriedContext: contextToReturnTo.
				 contextToReturnTo := nil]].

	"If returning to a context we must make a frame for it unless it is dead."
	contextToReturnTo ~= nil ifTrue:
		[frameToReturnTo := self establishFrameForContextToReturnTo: contextToReturnTo.
		 frameToReturnTo == 0 ifTrue:
			["error: home's sender is dead; cannot return"
			 ^self internalCannotReturn: localReturnValue]].

	"Now we have a frame to return to.  If it is on a different page we must free intervening pages and
	 nil out intervening contexts.  We must free intervening stack pages because if we leave the pages
	 to be divorced then their contexts will be divorced with intact senders and instruction pointers.  This
	 code is similar to primitiveTerminateTo.  We must move any frames on itervening pages above the
	 frame linked to because these may be in use, e.g. via co-routining (see baseFrameReturn)."
	self assert: stackPages pageListIsWellFormed.
	newPage := stackPages stackPageFor: frameToReturnTo.
	newPage ~~ stackPage ifTrue:
		[| currentCtx thePage nextCntx |
		 currentCtx := self frameCallerContext: stackPage baseFP.
		 self assert: (self isContext: currentCtx).
		 stackPages freeStackPage: stackPage.
		 [self assert: (self isContext: currentCtx).
		  (self isMarriedOrWidowedContext: currentCtx)
		   and: [(stackPages stackPageFor: (theFP := self frameOfMarriedContext: currentCtx)) = newPage]] whileFalse:
			[(self isMarriedOrWidowedContext: currentCtx)
				ifTrue:
					[thePage := stackPages stackPageFor: theFP.
					 theFP ~= thePage headFP ifTrue:
						["Since we've just deallocated a page we know that newStackPage won't deallocate an existing one."
						 self moveFramesIn: thePage through: (self findFrameAbove: theFP inPage: thePage) toPage: self newStackPage].
					 currentCtx := self frameCallerContext: thePage baseFP.
					 self freeStackPage: thePage]
				ifFalse:
					[nextCntx := objectMemory fetchPointer: SenderIndex ofObject: currentCtx.
					 self markContextAsDead: currentCtx.
					 currentCtx := nextCntx]].
		 self setStackPageAndLimit: newPage.
		 localSP := stackPage headSP.
		 localFP := stackPage headFP].

	"Two cases.  Returning to the top frame on a new page or an interior frame on the current page.
	 The top frame has its instruction pointer on top of stack. An interior frame has its instruction pointer
	 in the caller frame. We need to peel back any frames on the page until we get to the correct frame."

	localFP = frameToReturnTo
		ifTrue: "pop the saved IP, push the return value and continue."
			[localIP := self pointerForOop: self internalStackTop]
		ifFalse:
			[[callerFP := localFP.
			  localFP := self frameCallerFP: localFP.
			  localFP ~~ frameToReturnTo] whileTrue.
			localIP := self frameCallerSavedIP: callerFP.
			localSP := (self frameCallerSP: callerFP) - BytesPerWord].
	self internalStackTopPut: localReturnValue.
	self setMethod: (self frameMethod: localFP).
	^self fetchNextBytecode! !

!HStackInterpreter methodsFor: 'handle state' stamp: 'jb 5/11/2011 11:35'!
extendedStoreBytecode
	| descriptor variableType variableIndex association top rcvr |
	<inline: true>
	descriptor := self fetchByte.
	self fetchNextBytecode.
	variableType := descriptor >> 6 bitAnd: 3.
	variableIndex := descriptor bitAnd: 63.
      top := self internalStackTop.
	rcvr := self receiver.
	variableType = 0 ifTrue:[(self internalIsHandle: top) 
					ifTrue: [top := self handleReceiverOf: top].
				(self internalIsHandle: rcvr)  	 
					ifTrue: [^ self storeReceiverVariableInHandle: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top.]
					ifFalse: [^objectMemory storePointer: variableIndex ofObject: rcvr withValue: top]].
	variableType = 1 ifTrue:
		[^self temporary: variableIndex in: localFP put: top].
	variableType = 3 ifTrue:
		[association := self literal: variableIndex.
		 ^objectMemory storePointer: ValueIndex ofObject: association withValue: top].
	self error: 'illegal store'.
	^nil
! !

!HStackInterpreter methodsFor: 'handle primitives' stamp: 'jb 6/6/2011 14:28'!
internalExecuteNewMethod
	| succeeded rcvr |
	<inline: true>
	primitiveFunctionPointer ~~ 0 ifTrue:[
		rcvr := self internalStackValue: argumentCount.	
		(self internalIsHandle: rcvr) ifTrue: [
			self isPrimitiveFunctionPointerAnIndex 
				ifTrue:[^self internalQuickPrimitiveResponseForHandle].
		 
			(self isManagedPrimitive) 
				ifTrue: [^self sendPrimitiveOnHandle]
				ifFalse:[ self internalStackPageAt: argumentCount put: (self handleReceiverOf: rcvr).]].
	
		self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		self externalizeIPandSP.	
		succeeded := self slowPrimitiveResponse.
		self internalizeIPandSP.
		succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!HStackInterpreter methodsFor: 'handle primitives' stamp: 'jb 6/6/2011 14:16'!
internalQuickPrimitiveResponseForHandle
	"Called under the assumption that primFunctionPtr has been preloaded"
	
	| localPrimIndex rcvr |
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HStackInterpreter methodsFor: 'handle primitives' stamp: 'jb 6/6/2011 14:10'!
isManagedPrimitive
	^false! !

!HStackInterpreter methodsFor: 'handle behavior ' stamp: 'jb 8/11/2011 15:05'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
				
			self commonSend.
					
					.
	
! !

!HStackInterpreter methodsFor: 'handle identity' stamp: 'jb 5/9/2011 15:42'!
primitiveEquivalent
"is the receiver the same object as the argument?"
	| thisObject otherObject |
	otherObject := self popStack.
	thisObject := self popStack.
	(self internalIsHandle: otherObject)
		ifTrue:[otherObject :=  (self handleReceiverOf: otherObject).].
	self pushBool: thisObject = otherObject! !

!HStackInterpreter methodsFor: 'handle propagation support' stamp: 'jb 8/11/2011 14:34'!
pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
self inline: true.
(self handleUseState: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleReceiverOf: aHandle).].
	localIP := localIP -1.
	self externalizeIPandSP.
	self handle: aHandle propagateValue: value.
	self internalizeIPandSP.
	self fetchNextBytecode
! !

!HStackInterpreter methodsFor: 'handle self wrapping' stamp: 'jb 5/12/2011 16:28'!
pushReceiverBytecode

	| rcvr |
	self fetchNextBytecode.
	rcvr := self receiver.
	((self internalIsHandle: rcvr) and: [(self handleUseSelfWrapping: rcvr) not] )ifTrue:  [
		 self internalPush: (self handleReceiverOf: rcvr).]
	ifFalse:[self internalPush: rcvr.].
	! !

!HStackInterpreter methodsFor: 'handle state' stamp: 'jb 5/11/2011 13:02'!
pushReceiverVariable: fieldIndex

	| rcvr |
	rcvr := self receiver.
	(self internalIsHandle: rcvr) ifTrue: [
		self pushReceiverVariableInHandle: fieldIndex ofObject: rcvr.]
	ifFalse: [
		self internalPush: (objectMemory fetchPointer: fieldIndex ofObject: rcvr)].! !

!HStackInterpreter methodsFor: 'handle state/propagation support' stamp: 'jb 8/11/2011 15:01'!
pushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |

self inline: true.
(self handleUsePropagation: aHandle)
	ifTrue: [
		self pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].
! !

!HStackInterpreter methodsFor: 'handle state/propagation support' stamp: 'jb 8/11/2011 14:34'!
pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  |
self inline: true.
(self handleUseState: aHandle) 
	ifTrue: [
				stateArray := (self handleInlineStateOf: aHandle).
				self internalPush: (self stObject: stateArray at: (fieldIndex + 1)).]
	ifFalse: [
				self  internalPush: (objectMemory fetchPointer: fieldIndex ofObject: (self handleReceiverOf: aHandle))].
		
! !

!HStackInterpreter methodsFor: 'handle propagation support' stamp: 'jb 8/11/2011 14:34'!
quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
self inline: true.
(self handleUseState: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleReceiverOf: aHandle).].
	"localIP := localIP -1."
	self externalizeIPandSP.
	self handle: aHandle propagateValue: value.
	self internalizeIPandSP.
	"self fetchNextBytecode"
! !

!HStackInterpreter methodsFor: 'handle propagation support' stamp: 'jb 8/11/2011 15:02'!
quickPushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
self inline: true.
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].

	! !

!HStackInterpreter methodsFor: 'handle behavior ' stamp: 'jb 5/10/2011 17:36'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend! !

!HStackInterpreter methodsFor: 'handle behavior ' stamp: 'jb 5/10/2011 17:36'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend! !

!HStackInterpreter methodsFor: 'handle behavior ' stamp: 'jb 5/10/2011 17:36'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend! !

!HStackInterpreter methodsFor: 'handle primitives' stamp: 'jb 9/22/2011 11:44'!
sendPrimitiveOnHandle
	
	<inline: true>
	| succeeded primitiveIndex |
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
	self externalizeIPandSP.	
	succeeded := self slowPrimitiveResponse.
	self internalizeIPandSP.
	succeeded ifTrue:
		[self browserPluginReturnIfNeeded.
			^nil].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!HStackInterpreter methodsFor: 'handle state' stamp: 'jb 5/11/2011 11:24'!
storeAndPopReceiverVariableBytecode
	"Note: This code uses 
	storePointerUnchecked:ofObject:withValue: and does the 
	store check explicitely in order to help the translator 
	produce better code."
	| rcvr top |
	rcvr := self receiver.
	top := self internalStackTop.
	
	(self internalIsHandle: rcvr) 
	ifTrue:[
		self storeReceiverVariableInHandle: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top] 
	ifFalse: [
		(self oop: rcvr isLessThan: objectMemory youngStart) ifTrue:
		[objectMemory possibleRootStoreInto: rcvr value: top].
		objectMemory storePointerUnchecked: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top.].

	self fetchNextBytecode.
	self internalPop: 1
	

	
! !

!HStackInterpreter methodsFor: 'handle state/propagation support' stamp: 'jb 8/11/2011 14:34'!
storeReceiverVariableInHandle: fieldIndex ofObject: aHandle withValue: theValue

| stateArray |
(self handleUseState: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		self stObject: stateArray at: (fieldIndex + 1) put: theValue.]
	ifFalse: [
		objectMemory storePointer: fieldIndex ofObject: (self handleReceiverOf: aHandle) withValue: theValue.].

! !

HStackInterpreterRoot subclass: #HStackInterpreterPrimitives
	instanceVariableNames: 'hPrimitiveTable'
	classVariableNames: 'HPrimitiveTable'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

HStackInterpreterPrimitives subclass: #HStackInterpreterPStep2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

!HStackInterpreterPStep2 class methodsFor: 'as yet unclassified' stamp: 'jb 9/29/2011 12:05'!
declareCVarsIn: aCCodeGenerator
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator var: #hPrimitiveTable
		declareC: 'void (*hPrimitiveTable[MaxPrimitiveIndex + 2 /* ', (MaxPrimitiveIndex +2) printString, ' */])(void) = ', self hPrimitiveTableString.
	! !

!HStackInterpreterPStep2 class methodsFor: 'as yet unclassified' stamp: 'jb 9/29/2011 12:05'!
hPrimitiveTable

	^ HPrimitiveTable! !

!HStackInterpreterPStep2 class methodsFor: 'as yet unclassified' stamp: 'jb 9/29/2011 12:05'!
hPrimitiveTableString
	"StackInterpreter initializePrimitiveTable primitiveTableString"
	^String streamContents:
		[:s | 
		s nextPut: ${.
		self hPrimitiveTable withIndexDo:
			[:primSpec :index |
			s
				crtab;
				nextPutAll: '/* ';
				print: index - 1;
				nextPutAll: ' */ ';
				nextPutAll: (primSpec isString
								ifTrue: [primSpec == #primitiveFail
											ifTrue: ['(void (*)(void))0']
											ifFalse: [primSpec]]
								ifFalse: ['(void (*)(void))', primSpec printString]);
				nextPut: $,].
			s cr; nextPutAll: ' 0 }']! !

!HStackInterpreterPStep2 class methodsFor: 'as yet unclassified' stamp: 'jb 9/29/2011 12:05'!
initializeHandlePrimitiveTables 
	"self initializeHandlePrimitiveTables"
	HPrimitiveTable := Array new: MaxPrimitiveIndex + 1.
	self table: HPrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called")
		(1 primitiveAdd)				"not need handle version"
		(2 primitiveSubtract)			"not need handle version"
		(3 primitiveLessThan)			"not need handle version"
		(4 primitiveGreaterThan)		"not need handle version"
		(5 primitiveLessOrEqual)		"not need handle version"
		(6 primitiveGreaterOrEqual)		"not need handle version"
		(7 primitiveEqual)				"not need handle version"
		(8 primitiveNotEqual)			"not need handle version"
		(9 primitiveMultiply)				"not need handle version"
		(10 primitiveDivide)				"not need handle version"
		(11 primitiveMod)				"not need handle version"
		(12 primitiveDiv)				"not need handle version"
		(13 primitiveQuo)				"not need handle version"
		(14 primitiveBitAnd)			"not need handle version"
		(15 primitiveBitOr)				"not need handle version"
		(16 primitiveBitXor)				"not need handle version"
		(17 primitiveBitShift)			"not need handle version"
		(18 primitiveMakePoint)			"not need handle version"
		(19 0) "somtime we need to do bad thing"
		
		"LargeInteger Primitives (20-37)"
		(20 0)								"not need handle version"
		(21 primitiveAddLargeIntegers)					"not need handle version"
		(22 primitiveSubtractLargeIntegers)			"not need handle version"
		(23 primitiveLessThanLargeIntegers)			"not need handle version"
		(24 primitiveGreaterThanLargeIntegers)		"not need handle version"
		(25 primitiveLessOrEqualLargeIntegers)		"not need handle version"
		(26 primitiveGreaterOrEqualLargeIntegers)		"not need handle version"
		(27 primitiveEqualLargeIntegers)				"not need handle version"
		(28 primitiveNotEqualLargeIntegers)			"not need handle version"
		(29 primitiveMultiplyLargeIntegers)				"not need handle version"
		(30 primitiveDivideLargeIntegers)				"not need handle version"
		(31 primitiveModLargeIntegers)				"not need handle version"
		(32 primitiveDivLargeIntegers)					"not need handle version"
		(33 primitiveQuoLargeIntegers)				"not need handle version"
		(34 primitiveBitAndLargeIntegers)				"not need handle version"
		(35 primitiveBitOrLargeIntegers)				"not need handle version"
		(36 primitiveBitXorLargeIntegers)				"not need handle version"
		(37 primitiveBitShiftLargeIntegers)				"not need handle version"

		"Float Primitives (38-59)"
		(38 primitiveFloatAt)							"not need handle version"
		(39 primitiveFloatAtPut)							"not need handle version"
		(40 primitiveAsFloat)							"not need handle version"
		(41 primitiveFloatAdd)							"not need handle version"
		(42 primitiveFloatSubtract)						"not need handle version"
		(43 primitiveFloatLessThan)					"not need handle version"
		(44 primitiveFloatGreaterThan)					"not need handle version"
		(45 primitiveFloatLessOrEqual)					"not need handle version"
		(46 primitiveFloatGreaterOrEqual)				"not need handle version"
		(47 primitiveFloatEqual)							"not need handle version"
		(48 primitiveFloatNotEqual)						"not need handle version"
		(49 primitiveFloatMultiply)						"not need handle version"
		(50 primitiveFloatDivide)						"not need handle version"
		(51 primitiveTruncated)							"not need handle version"
		(52 primitiveFractionalPart)						"not need handle version"
		(53 primitiveExponent)							"not need handle version"
		(54 primitiveTimesTwoPower)					"not need handle version"
		(55 primitiveSquareRoot)						"not need handle version"
		(56 primitiveSine)								"not need handle version"
		(57 primitiveArctan)							"not need handle version"
		(58 primitiveLogN)								"not need handle version"
		(59 primitiveExp)								"not need handle version"

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveHAt)									"state handle"
		(61 primitiveHAtPut)								"state handle"
		(62 primitiveSize)								"fixed field handle"				
		(63 primitiveStringAt)							"fixed field handle"
		(64 primitiveStringAtPut)						"fixed field handle"
		"The stream primitives no longer pay their way; normal Smalltalk code is faster."
		(65 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(66 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(67 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"

		"StorageManagement Primitives (68-79)"
		(68 primitiveObjectAt)							"fixed field handle"
		(69 primitiveObjectAtPut)						"fixed field handle"
		(70 primitiveHNew)								"class handle"
		(71 primitiveHNewWithArg)						"class handle"
		(72 primitiveArrayBecomeOneWay)				"hum hum"
		(73 primitiveHInstVarAt)						"handle version state"
		(74 primitiveHInstVarAtPut)						"handle version state"
		(75 primitiveHIdentityHash)						"handle version identity"
		(76 primitiveStoreStackp)						"not need handle version"		
		(77 primitiveSomeInstance)						"not need handle version"
		(78 primitiveNextInstance)						"not need handle version"
		(79 primitiveNewMethod)						"??????"

		"Control Primitives (80-89)"
		(80 primitiveFail)								"not need handle version"
		(81 primitiveFail)								"not need handle version"
		(82 primitiveFail)								"not need handle version"
		(83 primitiveHPerform)							"shadow handle"
		(84 primitiveHPerformWithArgs)				"shadow handle"
		(85 primitiveSignal)								"not need handle version"
		(86 primitiveWait)								"not need handle version"
		(87 primitiveResume)							"not need handle version"
		(88 primitiveSuspend)							"not need handle version"
		(89 primitiveFlushCache)						"not need handle version"

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)						"not need handle version"
		(91 primitiveTestDisplayDepth)					"not need handle version"
		(92 primitiveSetDisplayMode)					"not need handle version"
		(93 primitiveInputSemaphore)					"not need handle version"
		(94 primitiveGetNextEvent)						"not need handle version"
		(95 primitiveInputWord)						
		(96 primitiveFail)								"not need handle version"
		(97 primitiveSnapshot)							"not need handle version"
		(98 primitiveStoreImageSegment)				"not need handle version"
		(99 primitiveLoadImageSegment)				"not need handle version"
		(100 primitivePerformInSuperclass)				"shadow handle"
		(101 primitiveBeCursor)						"not need handle version"
		(102 primitiveBeDisplay)						"not need handle version"
		(103 primitiveScanCharacters)					
		(104 primitiveFail)	"primitiveDrawLoop"		"not need handle version"
		(105 primitiveStringReplace)			
		(106 primitiveScreenSize)				"not need handle version"
		(107 primitiveMouseButtons)			"not need handle version"
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)			

		"System Primitives (110-119)"
		(110 primitiveHIdentical)		"handle version"
		(111 primitiveHClass)			"handle version"
		(112 primitiveBytesLeft)		"not need handle version"
		(113 primitiveQuit)				"not need handle version"
		(114 primitiveExitToDebugger)	"not need handle version"
		(115 primitiveHChangeClass)	"handle version"
		(116 primitiveFlushCacheByMethod)	"not need handle version"
		(117 primitiveExternalCall)				"not need handle version"
		(118 primitiveDoPrimitiveWithArgs) 	"not need handle version"
		(119 primitiveFlushCacheBySelector)	"not need handle version"
			"Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.
			Both are supported for backward compatibility."

		"Miscellaneous Primitives (120-127)"
		(120 primitiveCalloutToFFI)				"not need handle version"
		(121 primitiveImageName)				"not need handle version"
		(122 primitiveNoop)					"not need handle version"
		(123 primitiveFail)						"not need handle version"
		(124 primitiveLowSpaceSemaphore)	"not need handle version"
		(125 primitiveSignalAtBytesLeft)		"not need handle version"

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)	"not need handle version"
		(127 primitiveShowDisplayRect)		"not need handle version"
		(128 primitiveArrayBecome)			"not need handle version"
		(129 primitiveSpecialObjectsOop)		"not need handle version"
		(130 primitiveFullGC)					"not need handle version"
		(131 primitiveIncrementalGC)			"not need handle version"
		(132 primitiveHObjectPointsTo)		"hum hum"
		(133 primitiveSetInterruptKey)			"not need handle version"
		(134 primitiveInterruptSemaphore)		"not need handle version"
		(135 primitiveMillisecondClock)			"not need handle version"
		(136 primitiveSignalAtMilliseconds)		"not need handle version"
		(137 primitiveSecondsClock)			"not need handle version"
		(138 primitiveSomeObject)				" hum hum"
		(139 primitiveNextObject)				" hum hum"
		(140 primitiveBeep)					"not need handle version"
		(141 primitiveClipboardText)			"not need handle version"
		(142 primitiveVMPath)					"not need handle version"
		(143 primitiveShortAt)					"hum hum"
		(144 primitiveShortAtPut)				"hum hum"
		(145 primitiveConstantFill)				"hum hum"
		"NOTE: When removing the obsolete indexed primitives,
		the following two should go become #primitiveIntegerAt / atPut"
		(146 primitiveFail)						"not need handle version"
		(147 primitiveFail)						"not need handle version"
		(148 primitiveClone)					"not need handle version"
		(149 primitiveGetAttribute)				"not need handle version"

		"File Primitives (150-169) - NO LONGER INDEXED"
		(150 159 primitiveFail)					"not need handle version"
		(160 primitiveAdoptInstance)			"hum hum"
		(161 primitiveSetIdentityHash)
		(162 164 primitiveFail)					"not need handle version"
		(165 primitiveIntegerAt)				"hum hum"
		(166 primitiveIntegerAtPut)				"hum hum"
		(167 primitiveYield)						"hum hum"
		(168 primitiveCopyObject)				"not need handle version"
		(169 primitiveFail)						"not need handle version"

		"Sound Primitives (170-199) - NO LONGER INDEXED"
		(170 174 primitiveFail)

		"CogMemoryManager primitives"
		(175 primitiveBehaviorHash)			"not need handle version"	
		(176 primitiveMaxIdentityHash)			"not need handle version"
		(177 184 primitiveFail)					"not need handle version"

		"CriticalSection primitives"
		(185 primitiveExitCriticalSection)		"not need handle version"
		(186 primitiveEnterCriticalSection) 		"not need handle version"
		(187 primitiveTestAndSetOwnershipOfCriticalSection) "not need handle version"

		"Perform method directly"
		(188 primitiveExecuteMethodArgsArray) 		"shadow handle"
		(189 primitiveExecuteMethod)					"shadow handle"

		"Sound Primitives (continued) - NO LONGER INDEXED"
		(190 194 primitiveFail)					 "not need handle version"

		"Unwind primitives"
		(195 primitiveFindNextUnwindContext)	"not need handle version"
		(196 primitiveTerminateTo)				 "not need handle version"
		(197 primitiveFindHandlerContext)		 "not need handle version"
		(198 primitiveMarkUnwindMethod)		 "not need handle version"
		(199 primitiveMarkHandlerMethod)		 "not need handle version"

		"new closure primitives (were Networking primitives)"
		(200 primitiveClosureCopyWithCopiedValues)	 			"not need handle version"
		(201 primitiveClosureValue)  								"not need handle version"
		(202 primitiveClosureValue)  								"not need handle version"
		(203 primitiveClosureValue) 								"not need handle version"
		(204 primitiveClosureValue) 								"not need handle version"
		(205 primitiveClosureValue)								"not need handle version"
		(206 primitiveClosureValueWithArgs) 	 					"not need handle version"

		(207 209 primitiveFail)	"reserved for Cog primitives"

		(210 primitiveHContextAt)								"hum hum"
		(211 primitiveHContextAtPut)							"hum hum"
		(212 primitiveHContextSize)								"hum hum"
		(213 primitiveHContextXray)								"hum hum"
		(214 primitiveVoidVMState)								"not need handle version"
		(215 217 primitiveFail)	"reserved for Cog primitives"	"not need handle version"
		(218 primitiveDoNamedPrimitiveWithArgs)				"hum hum"
		(219 primitiveFail)										"not need handle version"
		(220 primitiveFail)										"not need handle version"

		(221 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch"	"not need handle version"
		(222 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch:" "not need handle version"

		(223 229 primitiveFail)	"not need handle version"

		(230 primitiveRelinquishProcessor)												"not need handle version"
		(231 primitiveForceDisplayUpdate)												"not need handle version"
		(232 primitiveFormPrint)														"not need handle version"
		(233 primitiveSetFullScreen)													"not need handle version"
		(234 primitiveFail) "primBitmapdecompressfromByteArrayat"					"not need handle version"
		(235 primitiveFail) "primStringcomparewithcollated"							"not need handle version"
		(236 primitiveFail) "primSampledSoundconvert8bitSignedFromto16Bit"			"not need handle version"
		(237 primitiveFail) "primBitmapcompresstoByteArray"							"not need handle version"
		(238 239 primitiveFail) "serial port primitives"									"not need handle version"
		(240 primitiveUTCMicrosecondClock)											"not need handle version"
		(241 primitiveLocalMicrosecondClock)											"not need handle version"
		(242 primitiveSignalAtUTCMicroseconds)										"not need handle version"
		(243 primitiveUpdateTimezone) "primStringtranslatefromtotable"				"not need handle version"
		(244 primitiveFail) "primStringfindFirstInStringinSetstartingAt"					"not need handle version"
		(245 primitiveFail) "primStringindexOfAsciiinStringstartingAt"					"not need handle version"
		(246 primitiveFail) "primStringfindSubstringinstartingAtmatchTable"				"not need handle version"
		(247 primitiveSnapshotEmbedded)												"not need handle version"
		(248 primitiveFail) "primitiveInvokeObjectAsMethod"							"not need handle version"
		(249 primitiveArrayBecomeOneWayCopyHash)									"hum hum"

		"VM Implementor Primitives (250-255)"
		(250 primitiveClearVMProfile)													"not need handle version"
		(251 primitiveControlVMProfiling)												"not need handle version"
		(252 primitiveVMProfileSamplesInto)											"not need handle version"
		(253 primitiveFail )																"not need handle version"
		(254 primitiveVMParameter)													"not need handle version"
		(255 primitiveFail) 																"not need handle version"

		"Quick Push Const Methods"
		(256 nil) "primitivePushSelf"													"handle version"
		(257 nil) "primitivePushTrue"													"not need handle version"
		(258 nil) "primitivePushFalse"													"not need handle version"
		(259 nil) "primitivePushNil"														"not need handle version"
		(260 nil) "primitivePushMinusOne"												"not need handle version"
		(261 nil) "primitivePushZero"													"not need handle version"
		(262 nil) "primitivePushOne"													"not need handle version"
		(263 nil) "primitivePushTwo"													"not need handle version"

		"Quick Push Inst Var Methods"
		(264 519 nil) "primitiveLoadInstVar"											 "Handle"

		(520 primitiveFail)
		"MIDI Primitives (521-539) - NO LONGER INDEXED"
		(521 529 primitiveFail)						 "not need handle version"
		(530 539 primitiveFail)  					 "not need handle version"

		"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
		"Pen Tablet Primitives - NO LONGER INDEXED"
		(540 549 primitiveFail)						 "not need handle version"

		"Sound Codec Primitives - NO LONGER INDEXED"
		(550 569 primitiveFail)						 "not need handle version"

		"External primitive support primitives"
		(570 primitiveFlushExternalPrimitives)		 "not need handle version"
		(571 primitiveUnloadModule)				 "not need handle version"
		(572 primitiveListBuiltinModule)				 "not need handle version"
		(573 primitiveListExternalModule)			 "not need handle version"
		(574 primitiveFail) 							 "not need handle version"

		"Unassigned Primitives"
		(575 primitiveFail)							 "not need handle version")! !

!HStackInterpreterPStep2 class methodsFor: 'as yet unclassified' stamp: 'jb 9/29/2011 12:05'!
requiredMethodNames
	^super requiredMethodNames addAll: self hPrimitiveTable; yourself! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
divorceAllFrames
	| activeContext |
	<inline: false>
	<var: #aPage type: #'StackPage *'>
	
	self externalWriteBackHeadFramePointers.
	activeContext := self ensureFrameIsMarried: framePointer SP: stackPointer.
	0 to: numStackPages - 1 do:
		[:i| | aPage |
		aPage := stackPages stackPageAt: i.
		(stackPages isFree: aPage) ifFalse:
			[self divorceFramesIn: aPage]].
	stackPage := 0.
	^activeContext! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
divorceFramesIn: aStackPage
	| theFP calleeFP theSP theIP calleeContext theContext |
	<inline: false>
	<var: #aStackPage type: #'StackPage *'>
	<var: #theFP type: #'char *'>
	<var: #calleeFP type: #'char *'>
	<var: #theSP type: #'char *'>

	statStackPageDivorce := statStackPageDivorce + 1.

	theFP := aStackPage headFP.
	theSP := aStackPage headSP.
	theIP := stackPages longAt: theSP.
	theSP := theSP + BytesPerWord. "theSP points at hottest item on frame's stack"
	calleeContext := nil.

	[theContext := self ensureFrameIsMarried: theFP SP: theSP.
	 self updateStateOfSpouseContextForFrame: theFP WithSP: theSP.
	 objectMemory storePointerUnchecked: InstructionPointerIndex
		ofObject: theContext
		withValue: (self contextInstructionPointer: theIP frame: theFP).
	 self assert: (self frameReceiver: theFP)
				= (objectMemory fetchPointer: ReceiverIndex ofObject: theContext).
	 calleeContext ~~ nil ifTrue:
		[objectMemory storePointer: SenderIndex
			ofObject: calleeContext
			withValue: theContext].
	 calleeContext := theContext.
	 calleeFP := theFP.
	 theIP := (self frameCallerSavedIP: theFP) asInteger.
	 theFP := self frameCallerFP: theFP.
	 theFP ~= 0] whileTrue:
		["theSP points at stacked hottest item on frame's stack"
		 theSP := self frameCallerSP: calleeFP].

	objectMemory storePointer: SenderIndex
		ofObject: theContext
		withValue: (self frameCallerContext: calleeFP).

	"The page is now free; mark it so."
	aStackPage baseFP: 0! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
ensureCallerContext: theFP
	"Answerr the caller context for a frame.  If the frame has a caller
	 frame that doesn't have a context, then marry the caller frame."
	| callerFP |
	<inline: true>
	<var: #theFP type: #'char *'>
	<var: #callerFP type: #'char *'>
	<asmLabel: false>
	
	self print: 'ensureCallerContext:';cr.
	callerFP := self frameCallerFP: theFP.
	callerFP = 0 ifTrue: "base frame, context in saved ip slot (or base of stack in Cog)"
		[^self frameCallerContext: theFP].
	^self ensureFrameIsMarried: callerFP SP: (self frameCallerStackPointer: theFP)! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
findMethodWithPrimitive: primitive FromFP: startFP UpToContext: homeContext
	"See findUnwindThroughContext:.  Alas this is mutually recursive with
	 findMethodWithPrimitive:FromContext:ThroughContext: instead of iterative.
	 We're doing the simplest thing that could possibly work.  Niceties can wait."
	| theFP theFPAbove theSP theMethod senderContext |
	<var: #startFP type: #'char *'>
	<var: #theFP type: #'char *'>
	<var: #theFPAbove type: #'char *'>
	<var: #theSP type: #'char *'>
	
	theFP := startFP.
	theFPAbove := startFP.
	[((self frameHasContext: theFP)
	  and: [homeContext = (self frameContext: theFP)]) ifTrue:
		[^0].
	 (self frameIsBlockActivation: theFP) ifFalse:
	 	[theMethod := self frameMethodObject: theFP.
		 (self primitiveIndexOf: theMethod) == primitive ifTrue:
			[theFP = theFPAbove
						ifTrue: [theSP := self findSPOf: theFP on: (stackPages stackPageFor: theFP)]
						ifFalse: [theSP := self frameCallerStackPointer: theFPAbove].
			 ^self ensureFrameIsMarried: theFP SP: theSP]].
	 theFPAbove := theFP.
	 theFP := self frameCallerFP: theFP.
	 theFP ~= 0] whileTrue.
	senderContext := self frameCallerContext: theFPAbove.
	(self isContext: senderContext) ifFalse:
		[^objectMemory nilObject].
	^self
		findMethodWithPrimitive: primitive
		FromContext: senderContext
		UpToContext: homeContext! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hAddNewMethodToCache: class
	"Add the given entry to the method cache.
	The policy is as follows:
		Look for an empty entry anywhere in the reprobe chain.
		If found, install the new entry there.
		If not found, then install the new entry at the first probe position
			and delete the entries in the rest of the reprobe chain.
		This has two useful purposes:
			If there is active contention over the first slot, the second
				or third will likely be free for reentry after ejection.
			Also, flushing is good when reprobe chains are getting full."
	| probe hash primitiveIndex |
	<inline: true>
	hash := messageSelector bitXor: class.  "drop low-order zeros from addresses"
	(objectMemory isOopCompiledMethod: newMethod)
		ifTrue:
			[
			primitiveIndex := self primitiveIndexOf: newMethod.
			primitiveFunctionPointer := self hFunctionPointerFor: primitiveIndex inClass: class]
		ifFalse:
			[
			primitiveFunctionPointer := #primitiveInvokeObjectAsMethod asSymbol].

	0 to: CacheProbeMax-1 do:
		[:p | probe := (hash >> p) bitAnd: MethodCacheMask.
		(methodCache at: probe + MethodCacheSelector) = 0 ifTrue:
			["Found an empty entry -- use it"
			methodCache at: probe + MethodCacheSelector put: messageSelector.
			methodCache at: probe + MethodCacheClass put: class.
			methodCache at: probe + MethodCacheMethod put: newMethod.
			methodCache at: probe + MethodCachePrimFunction put: (self cCoerce: primitiveFunctionPointer to: #long).
			lastMethodCacheProbeWrite := probe. "this for primitiveExternalMethod"
			^ nil]].

	"OK, we failed to find an entry -- install at the first slot..."
	probe := hash bitAnd: MethodCacheMask.  "first probe"
	methodCache at: probe + MethodCacheSelector put: messageSelector.
	methodCache at: probe + MethodCacheClass put: class.
	methodCache at: probe + MethodCacheMethod put: newMethod.
	methodCache at: probe + MethodCachePrimFunction put: (self cCoerce: primitiveFunctionPointer to: #long).
	lastMethodCacheProbeWrite := probe. "this for primitiveExternalMethod"
	"...and zap the following entries"
	1 to: CacheProbeMax-1 do:
		[:p | probe := (hash >> p) bitAnd: MethodCacheMask.
		methodCache at: probe + MethodCacheSelector put: 0]! !

!HStackInterpreterPStep2 methodsFor: 'support hprimitive table' stamp: 'jb 9/29/2011 12:05'!
hFunctionPointerFor: primIdx inClass: theClass
	"Find an actual function pointer for this primitiveIndex.  This is an
	opportunity to specialise the prim for the relevant class (format for
	example).  Default for now is simply the entry in the base primitiveTable."

	<returnTypeC: 'void (*hFunctionPointerForinClass(sqInt primIdx,sqInt theClass))(void)'>
	^primIdx > MaxPrimitiveIndex ifTrue: [0] ifFalse: [hPrimitiveTable at: primIdx]! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hInternalActivateNewMethod
	| methodHeader numTemps rcvr errorCode |
	<inline: true>
	
	methodHeader := self headerOf: newMethod.
	numTemps := self tempCountOfMethodHeader: methodHeader.
	rcvr := self internalStackValue: argumentCount. 
	self internalPush: localIP.
	self internalPush: localFP.
	localFP := localSP.
	self internalPush: newMethod.
	self setMethod: newMethod.
	self internalPush: (self
						encodeFrameFieldHasContext: false
						isBlock: false
						numArgs: (self argumentCountOfMethodHeader: methodHeader)).
	self internalPush: objectMemory nilObject. 
	self internalPush: rcvr.

	argumentCount + 1 to: numTemps do:
		[:i | self internalPush: objectMemory nilObject].

	localIP := self pointerForOop: (self initialPCForHeader: methodHeader method: newMethod) - 1.

	primFailCode ~= 0 ifTrue:
		[((self methodHeaderHasPrimitive: methodHeader)
		   and: [(objectMemory byteAtPointer: localIP + 1) = 129 "long store temp"]) ifTrue:
			[errorCode := self getErrorObjectFromPrimFailCode.
			 self internalStackTopPut: errorCode "nil if primFailCode == 1, or primFailCode"].
		primFailCode := 0].

	self assert: (self frameNumArgs: localFP) == argumentCount.
	self assert: (self frameIsBlockActivation: localFP) not.
	self assert: (self frameHasContext: localFP) not.

	"Now check for stack overflow or an event (interrupt, must scavenge, etc)."
	localSP < stackLimit ifTrue:
		[self externalizeIPandSP.
		 self handleStackOverflowOrEventAllowContextSwitch: (self canContextSwitchIfActivating: methodHeader).
		 self internalizeIPandSP]! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hInternalExecuteNewMethod
	| succeeded primitiveIndex |
	<inline: true>
	
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
	primitiveFunctionPointer ~~ 0 ifTrue:
		[self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self hInternalQuickPrimitiveResponse].
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	^self hInternalActivateNewMethod

! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hInternalFindNewMethod

		| ok | 
	<inline: true>
	self externalizeIPandSP.
	(self isAHandle: lkupClass) 
		ifTrue: [ 
			self print: 'receiver class is a handle and send the message #'.
			self printStringOf: messageSelector;cr.
			self hLookupMethodInClass: lkupClass.] 
		ifFalse: [
			self print: 'receiver class is a normal class and send the message #'.
			self printStringOf: messageSelector;cr.
			self lookupMethodInClass: lkupClass.].
		
	self internalizeIPandSP.
	! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hInternalQuickPrimitiveResponse
	"Called under the assumption that primFunctionPtr has been preloaded"
	<inline:true>
	| localPrimIndex rcvr |
	self print: 'hInternalQuickPrimitiveResponse';cr.
	
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self printNum: localPrimIndex;cr.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hLookupMethodInClass: class
	| currentClass dictionary found |
	<inline: true>
	self assert: class ~~ objectMemory nilObject.
	currentClass := class.
	dictionary := self stObject: (self handleStateOf: currentClass) at: (MethodDictionaryIndex + 1).
	found := self lookupMethodInDictionary: dictionary.
	found ifTrue: [^currentClass].
	^self lookupMethodInClass: (self stObject: (self handleStateOf: currentClass) at: (SuperclassIndex + 1)).! !

!HStackInterpreterPStep2 methodsFor: 'support hprimitive table' stamp: 'jb 9/29/2011 12:05'!
hSlowPrimitiveResponse
	"Called under the assumption that primFunctionPtr has been preloaded"
	| nArgs savedFramePointer savedStackPointer |
	<inline: true>
	<asmLabel: false>
	<var: #savedFramePointer type: #'char *'>
	<var: #savedStackPointer type: #'char *'>
		[nArgs := argumentCount.
		 savedStackPointer := stackPointer.
		 savedFramePointer := framePointer].
	self initPrimCall.
	self dispatchFunctionPointer: primitiveFunctionPointer.
	(FailImbalancedPrimitives
	and: [self successful
	and: [framePointer = savedFramePointer]]) ifTrue:"Don't fail if primitive has done something radical, e.g. perform:"
		[stackPointer ~= (savedStackPointer + (nArgs * BytesPerWord)) ifTrue:
			[self flag: 'Would be nice to make this a message send of e.g. unbalancedPrimitive to the current process or context'.
			 "This is necessary but insufficient; the result may still have been written to the stack.
			   At least we'll know something is wrong."
			 stackPointer := savedStackPointer.
			 self failUnbalancedPrimitive]].
	"If we are profiling, take accurate primitive measures"
	nextProfileTick > 0 ifTrue:
		[self checkProfileTick: newMethod].
	^self successful! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
hSuperclassOf: classPointer
	<inline: true>
	^objectMemory fetchPointer: SuperclassIndex ofObject: (self handleInlineReceiverOf: classPointer).! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
handleSend
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: (self internalStackValue: argumentCount).
	self hInternalFindNewMethod.
	self hInternalExecuteNewMethod.
	self fetchNextBytecode
	! !

!HStackInterpreterPStep2 methodsFor: '2 step' stamp: 'jb 9/29/2011 12:05'!
handleStackOverflow
	"Check for stack overflow, moving frames to another stack if so."
	| newPage theFP callerFP overflowLimitAddress overflowCount |
	<var: #newPage type: #'StackPage *'>
	<var: #theFP type: #'char *'>
	<var: #callerFP type: #'char *'>
	<var: #overflowLimitAddress type: #'char *'>

	"After checkForInterrupts another event check may have been forced, setting both
	 stackLimit and stackPage stackLimit to all ones.  So here we must check against
	 the real stackLimit, not the effective stackLimit."
	self print: 'handleStackOverflow';cr.
	
	stackPointer < stackPage realStackLimit ifFalse:
		[^self].

	statStackOverflow := statStackOverflow + 1.

	"The stack has overflowed this page.  If the system is executing some recursive algorithm,
	 e.g. fibonacci, then the system could thrash overflowing the stack if the call soon returns
	 back to the current page.  To avoid thrashing, since overflow is quite slow, we can move
	 more than one frame.  The idea is to record which page has overflowed, and the first
	 time it overflows move one frame, the second time two frames, and so on.  We move no
	 more frames than would leave the page half occupied."
	theFP := framePointer.
	stackPage = overflowedPage
		ifTrue:
			[overflowLimitAddress := stackPage baseAddress - stackPages overflowLimit.
			 overflowCount := extraFramesToMoveOnOverflow := extraFramesToMoveOnOverflow + 1.
			 [(overflowCount := overflowCount - 1) >= 0
			   and: [(callerFP := self frameCallerFP: theFP) < overflowLimitAddress
			   and: [(self isBaseFrame: callerFP) not]]] whileTrue:
				[theFP := callerFP]]
		ifFalse:
			[overflowedPage := stackPage.
			 extraFramesToMoveOnOverflow := 0].

	self ensureCallerContext: theFP.
	newPage := self newStackPage.
	self moveFramesIn: stackPage through: theFP toPage: newPage.
	self setStackPageAndLimit: newPage.
	framePointer := stackPage headFP.
	stackPointer := stackPage headSP.
	self isCog
		ifFalse: "To overflow the stack this must be a new frame, but in Cog base frames are married."
			[self assert: (self frameHasContext: framePointer) not.
			 self assert: (self validInstructionPointer: instructionPointer
							inMethod: method
							framePointer: framePointer)]
		ifTrue:
			[self assert: (self validInstructionPointer: instructionPointer
							inFrame: framePointer).
			 self assert: ((self frameHasContext: framePointer) not
						or: [self isContext: (self frameContext: framePointer)])]! !

!HStackInterpreterPStep2 methodsFor: 'prim class handle' stamp: 'jb 9/29/2011 12:05'!
initializeHandle: handleInstance withReceiver: value andShadowClass: handle
		<inline:true>
		objectMemory storePointer: 0 ofObject: handleInstance withValue: value. 
		objectMemory storePointer: 1 ofObject: handleInstance withValue: handle.
		objectMemory storePointer: 3 ofObject: handleInstance withValue: (objectMemory integerObjectOf:6).
	! !

!HStackInterpreterPStep2 methodsFor: '2 step' stamp: 'jb 9/29/2011 12:05'!
instVar: offset ofContext: aContext
	"Fetch an instance avriable from a maybe married context.
	 If the context is still married compute the value of the
	 relevant inst var from the spouse frame's state."
	| spouseFP |
	<var: #spouseFP type: #'char *'>
	<var: #thePage type: #'StackPage *'>
	<var: #theFPAbove type: #'char *'>
	<inline: true>
	
	self print: 'instVar:';cr.
	self assert: offset < MethodIndex.
	self assert: (self isContext: aContext).
	(self isMarriedOrWidowedContext: aContext) ifFalse:
		[^objectMemory fetchPointer: offset ofObject: aContext].

	self writeBackHeadFramePointers.
	(self isWidowedContext: aContext) ifTrue:
		[^objectMemory fetchPointer: offset ofObject: aContext].

	spouseFP := self frameOfMarriedContext: aContext.
	offset = SenderIndex ifTrue:
		[
		self printOop: messageSelector;cr.
		self printOop: (objectMemory fetchPointer: 5 ofObject: aContext).
		^self ensureCallerContext: spouseFP].
	offset = StackPointerIndex ifTrue:
		[self assert: ReceiverIndex + (self stackPointerIndexForFrame: spouseFP) < (objectMemory lengthOf: aContext).
		^objectMemory integerObjectOf: (self stackPointerIndexForFrame: spouseFP)].
	offset = InstructionPointerIndex ifTrue:
		[| theIP thePage theFPAbove |
		 spouseFP = localFP
			ifTrue: [theIP := self oopForPointer: localIP]
			ifFalse:
				[thePage := stackPages stackPageFor: spouseFP.
				 theFPAbove := self findFrameAbove: spouseFP inPage: thePage.
				 theIP := theFPAbove == 0
							ifTrue: [stackPages longAt: thePage headSP]
							ifFalse:[self oopForPointer: (self frameCallerSavedIP: theFPAbove)]].
		 ^self contextInstructionPointer: theIP frame: spouseFP].
	self error: 'bad index'.
	^0! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
internalAboutToReturn: resultOop through: aContext
	| ourContext |
	<inline: true>
	
	ourContext := self ensureFrameIsMarried: localFP SP: localSP.
	self internalPush: ourContext.
	self internalPush: resultOop.
	self internalPush: aContext.
	messageSelector := objectMemory splObj: SelectorAboutToReturn.
	argumentCount := 2.
	^self normalSend! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
internalCannotReturn: resultOop
	| ourContext |
	<inline: true>
	ourContext := self ensureFrameIsMarried: localFP SP: localSP.
	self internalPush: ourContext.
	self internalPush: resultOop.
	messageSelector := objectMemory splObj: SelectorCannotReturn.
	argumentCount := 1.
	^self normalSend! !

!HStackInterpreterPStep2 methodsFor: 'toRemoveAtTerm' stamp: 'jb 9/29/2011 12:05'!
internalExecuteNewMethod
	| succeeded rcvr |
	<inline: true>
	primitiveFunctionPointer ~~ 0 ifTrue:[
		rcvr := self internalStackValue: argumentCount.	
		(self internalIsHandle: rcvr) ifTrue: [
			self isPrimitiveFunctionPointerAnIndex 
				ifTrue:[^self internalQuickPrimitiveResponseForHandle].
		 
			(self isManagedPrimitive) 
				ifTrue: [^self sendPrimitiveOnHandle]
				ifFalse:[ self internalStackPageAt: argumentCount put: (self handleReceiverOf: rcvr).]].
	
		self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		self externalizeIPandSP.	
		succeeded := self slowPrimitiveResponse.
		self internalizeIPandSP.
		succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!HStackInterpreterPStep2 methodsFor: 'toRemoveAtTerm' stamp: 'jb 9/29/2011 12:05'!
internalQuickPrimitiveResponseForHandle
	"Called under the assumption that primFunctionPtr has been preloaded"
	
	| localPrimIndex rcvr |
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HStackInterpreterPStep2 methodsFor: 'support hprimitive table' stamp: 'jb 9/29/2011 12:05'!
isManagedPrimitive
	
	^true! !

!HStackInterpreterPStep2 methodsFor: '#$%@! of context' stamp: ''!
marryFrame: theFP SP: theSP
	"Marry an unmarried frame.  This means creating a spouse context
	 initialized with a subset of the frame's state (state through the last argument)
	 that references the frame."
	| theContext methodHeader byteSize numArgs numStack closureOrNil plop |
	<inline: false>
	<var: #theFP type: #'char *'>
	<var: #theSP type: #'char *'>
	self print:'marryFrame:' ;cr.
	self assert: (self frameHasContext: theFP) not.
	methodHeader := self headerOf: (self frameMethod: theFP).
	"Decide how much of the stack to preserve in widowed contexts.  Preserving too much
	 state will potentially hold onto garbage.  Holding onto too little may mean that a dead
	 context isn't informative enough in a debugging situation.  We compromise, retaining
	 only the arguments with no temporaries.  Note that we still set the stack pointer to its
	 current value, but stack contents other than the arguments are nil."
	numArgs := self frameNumArgs: theFP.
	numStack := self stackPointerIndexForFrame: theFP WithSP: theSP.
	numStack > 10000 ifTrue:[self print: 'plantage';cr].
		
	closureOrNil := (self frameIsBlockActivation: theFP)
						ifTrue: [self pushedReceiverOrClosureOfFrame: theFP]
						ifFalse: [objectMemory nilObject].
	byteSize := (methodHeader bitAnd: LargeContextBit) ~= 0
					ifTrue: [LargeContextSize]
					ifFalse: [SmallContextSize].

	theContext := objectMemory eeInstantiateMethodContextByteSize: byteSize.
	self assert: numStack + ReceiverIndex << ShiftForWord + BaseHeaderSize <= byteSize. 
	"Mark context as married by setting its sender to the frame pointer plus SmallInteger
	 tags and the InstructionPointer to the saved fp (which ensures correct alignment
	 w.r.t. the frame when we check for validity)"
	objectMemory storePointerUnchecked: SenderIndex
		ofObject: theContext
		withValue: (self withSmallIntegerTags: theFP).
	objectMemory storePointerUnchecked: InstructionPointerIndex
		ofObject: theContext
		withValue: (self withSmallIntegerTags: (self frameCallerFP: theFP)).
	objectMemory storePointerUnchecked: StackPointerIndex
		ofObject: theContext
		withValue: (objectMemory integerObjectOf: numStack).
	objectMemory storePointerUnchecked: MethodIndex
		ofObject: theContext
		withValue: (self frameMethod: theFP).
	objectMemory storePointerUnchecked: ClosureIndex ofObject: theContext withValue: closureOrNil.
	
	objectMemory storePointerUnchecked: ReceiverIndex
		ofObject: theContext
		withValue: (self frameReceiver: theFP).
	"Store just the arguments.  If the frame is divorced the context
	 will have valid arguments but all temporaries will be nil."
	1 to: numArgs do:
		[:i|
		objectMemory storePointerUnchecked: ReceiverIndex + i
			ofObject: theContext "inline self temporary: i - 1 in:theFP" 
			withValue: (stackPages longAt: theFP
										+ FoxCallerSavedIP
										+ ((numArgs - i + 1) * BytesPerWord))].
	
	numArgs + 1 to: numStack do:
		[:i|
		objectMemory storePointerUnchecked: ReceiverIndex + i
			ofObject: theContext
			withValue: objectMemory nilObject].
	
	stackPages longAt: theFP + FoxThisContext put: theContext.
	stackPages byteAt: theFP + FoxFrameFlags + 2 put: 1.
	
	self assert: (self frameHasContext: theFP).
	self assert: (self frameOfMarriedContext: theContext) = theFP.
	self assert: numStack + ReceiverIndex < (objectMemory lengthOf: theContext).

	^theContext
 ! !

!HStackInterpreterPStep2 methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:05'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
							lkupClass :=  (self handleInlineClassLookupOf: rcvr).
							self handleSend.	
	]  ifFalse: [self commonSend].
					.
	
! !

!HStackInterpreterPStep2 methodsFor: 'prim identity' stamp: 'jb 9/29/2011 12:05'!
primitiveEquivalent
"is the receiver the same object as the argument?
In case of handle we should check for all object other object to"
	| thisObject otherObject |
	otherObject := self popStack.
	thisObject := self popStack.
	(self internalIsHandle: otherObject)
		ifTrue:[otherObject :=  (self handleInlineReceiverOf: otherObject).].
	self pushBool: thisObject = otherObject! !

!HStackInterpreterPStep2 methodsFor: 'prim to find where i put it' stamp: 'jb 9/29/2011 12:05'!
primitiveHAdoptInstance
	"Primitive. Change the class of the argument to make it an instance of the receiver
	 given that the format of the receiver matches the format of the argument's class.
	 Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a
	 compact class and the argument isn't, or when the argument's class is compact and
	 the receiver isn't, or when the format of the receiver is different from the format of
	 the argument's class, or when the arguments class is fixed and the receiver's size
	 differs from the size that an instance of the argument's class should have."
	^self primitiveFail! !

!HStackInterpreterPStep2 methodsFor: 'prim to find where i put it' stamp: 'jb 9/29/2011 12:05'!
primitiveHChangeClass
	"Primitive. Change the class of the receiver into the class of the argument given that the format of the receiver matches the format of the argument's class. Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a compact class and the argument isn't, or when the argument's class is compact and the receiver isn't, or when the format of the receiver is different from the format of the argument's class, or when the arguments class is fixed and the receiver's size differs from the size that an instance of the argument's class should have."
	^self primitiveFail
	! !

!HStackInterpreterPStep2 methodsFor: 'prim to find where i put it' stamp: 'jb 9/29/2011 12:05'!
primitiveHClass
	| instance |
	
	<inline: true>
	instance := self stackTop.
	self pop: argumentCount+1 thenPush: (self handleInlineClassLookupOf: instance).

	! !

!HStackInterpreterPStep2 methodsFor: 'prim behavior' stamp: 'jb 9/29/2011 12:05'!
primitiveHExecuteMethod
	"receiver, args, then method are on top of stack. Execute method against receiver and args.
	 Set primitiveFunctionPointer because no cache lookup has been done for the method, and
	 hence primitiveFunctionPointer is stale."
	| methodArgument primitiveIndex |
	methodArgument := self stackTop.
	(objectMemory isOopCompiledMethod: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argumentCount - 1 = (self argumentCountOf: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	newMethod := self popStack.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argumentCount - 1.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPStep2 methodsFor: 'prim behavior' stamp: 'jb 9/29/2011 12:05'!
primitiveHExecuteMethodArgsArray
	"receiver, argsArray, then method are on top of stack.  Execute method against
	 receiver and args.  Allow for up to two extra arguments (e.g. for mirror primitives).
	 Set primitiveFunctionPointer because no cache lookup has been done for the
	 method, and hence primitiveFunctionPointer is stale."
	| methodArgument argCnt argumentArray primitiveIndex |
	methodArgument := self stackTop.
	argumentArray := self stackValue: 1.
	((objectMemory isOopCompiledMethod: methodArgument)
	 and: [objectMemory isArray: argumentArray]) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argCnt := self argumentCountOf: methodArgument.
	argCnt = (objectMemory fetchWordLengthOf: argumentArray) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	argumentCount > 2 ifTrue: "CompiledMethod class>>receiver:withArguments:executeMethod:
								SqueakObjectPrimitives class >> receiver:withArguments:apply:
								VMMirror>>ifFail:object:with:executeMethod: et al"
		[argumentCount > 4 ifTrue:
			[^self primitiveFailFor: PrimErrUnsupported].
		self stackValue: argumentCount put: (self stackValue: 2)]. "replace actual receiver with desired receiver"
	"and push the actual arguments"
	self pop: argumentCount.
	0 to: argCnt - 1 do:
		[:i|
		self push: (objectMemory fetchPointer: i ofObject: argumentArray)].
	newMethod := methodArgument.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argCnt.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPStep2 methodsFor: 'prim identity' stamp: 'jb 9/29/2011 12:05'!
primitiveHIdentical
	"is the receiver/first argument the same object as the (last) argument?.
	 pop argumentCount because this can be used as a mirror primitive."
	| thisObject otherObject |
	otherObject := self stackValue: 1.
	thisObject := self stackTop.
	otherObject :=  (self handleInlineReceiverOf: otherObject).
	self pop: argumentCount + 1 thenPushBool: thisObject = otherObject ! !

!HStackInterpreterPStep2 methodsFor: 'prim identity' stamp: 'jb 9/29/2011 12:05'!
primitiveHIdentityHash
	| thisReceiver |
	thisReceiver := self stackTop.
	thisReceiver := self handleInlineReceiverOf: thisReceiver.
	(objectMemory isIntegerObject: thisReceiver)
		ifTrue: [self primitiveFail]
		ifFalse: [self pop:1 thenPushInteger: (objectMemory hashBitsOf: thisReceiver)]! !

!HStackInterpreterPStep2 methodsFor: 'prim class handle' stamp: 'jb 9/29/2011 12:05'!
primitiveHNew
	"Allocate a new fixed-size instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free. May cause a GC"
	|  handle hClass spaceOkay value handleInstance |
	
	self print: 'primitiveHNew';cr.
	handle := self popStack.
	hClass := self  handleInlineReceiverOf: handle.
	spaceOkay := self sufficientSpaceToInstantiate: hClass indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [value := objectMemory instantiateClass: hClass indexableSize: 0].
	spaceOkay := self sufficientSpaceToInstantiate: (self classHandleInline) indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [handleInstance :=  objectMemory instantiateClass: (self classHandleInline) indexableSize: 0.].
	self initializeHandle: handleInstance withReceiver: value andShadowClass: handle.
	self push: handleInstance.! !

!HStackInterpreterPStep2 methodsFor: 'prim class handle' stamp: 'jb 9/29/2011 12:05'!
primitiveHNewWithArg
	"Allocate a new indexable instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free."
	| size class spaceOkay |
	self print: 'primitiveHNewWithArg';cr.
	size := self positive32BitValueOf: self stackTop.
	class := self stackValue: 1.
	self success: size >= 0.
	self successful
		ifTrue: ["The following may cause GC!!"
			spaceOkay := self sufficientSpaceToInstantiate: class indexableSize: size.
			self success: spaceOkay.
			class := self stackValue: 1].
	self successful ifTrue: [self pop: 2 thenPush: (objectMemory instantiateClass: class indexableSize: size)]! !

!HStackInterpreterPStep2 methodsFor: 'prim fixed field' stamp: 'jb 9/29/2011 12:05'!
primitiveHObjectAt
"Defined for CompiledMethods only"
	| thisReceiver index |
	index  := self stackIntegerValue: 0.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 1.
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	self pop: 2 thenPush: (objectMemory fetchPointer: index - 1 ofObject: thisReceiver)! !

!HStackInterpreterPStep2 methodsFor: 'prim fixed field' stamp: 'jb 9/29/2011 12:05'!
primitiveHObjectAtPut
"Defined for CompiledMethods only"
	| thisReceiver index newValue |
	newValue := self stackValue: 0.
	index := self stackIntegerValue: 1.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 2.
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	objectMemory storePointer: index - 1 ofObject: thisReceiver withValue: newValue.
	self pop: 3 thenPush: newValue! !

!HStackInterpreterPStep2 methodsFor: 'prim to find where i put it' stamp: 'jb 9/29/2011 12:05'!
primitiveHObjectPointsTo
	"This primitive is assumed to be fast (see e.g. MethodDictionary>>includesKey:) so make it so.
	 N.B.  Written to use literalHeaderOf: so that in Cog subclasses cogged methods (whose headers
	 point to the machine code method) are still correctly scanned, for the header as well as literals."
	| rcvr thang header fmt lastField methodHeader |
	thang := self stackTop.
	rcvr := self stackValue: 1.
	(objectMemory isIntegerObject: rcvr) ifTrue:
		[^self pop: 2 thenPushBool: false].

	"Inlined version of lastPointerOf: for speed in determining if rcvr is a context."
	header := objectMemory baseHeader: rcvr.
	fmt := objectMemory formatOfHeader: header.
	fmt <= 4
		ifTrue:
			[(fmt = 3
			  and: [objectMemory isContextHeader: header]) 
				ifTrue:
	 				[(self isMarriedOrWidowedContext: rcvr) ifTrue:
						[self externalWriteBackHeadFramePointers.
						 (self isStillMarriedContext: rcvr) ifTrue:
							[^self pop: 2
									thenPushBool: (self marriedContext: rcvr
														pointsTo: thang
														stackDeltaForCurrentFrame: 2)]].
					"contexts end at the stack pointer"
					lastField := CtxtTempFrameStart + (self fetchStackPointerOf: rcvr) * BytesPerWord]
				ifFalse:
					[lastField := (objectMemory sizeBitsOfSafe: rcvr) - BaseHeaderSize]]
		ifFalse:
			[fmt < 12 "no pointers" ifTrue:
				[^self pop: 2 thenPushBool: false].
			"CompiledMethod: contains both pointers and bytes:"
			methodHeader := self headerOf: rcvr.
			methodHeader = thang ifTrue: [^self pop: 2 thenPushBool: true].
			lastField := ((self literalCountOfHeader: methodHeader) + 1) * BytesPerWord].

	BaseHeaderSize to: lastField by: BytesPerWord do:
		[:i |
		(self longAt: rcvr + i) = thang ifTrue:
			[^self pop: 2 thenPushBool: true]].
	self pop: 2 thenPushBool: false! !

!HStackInterpreterPStep2 methodsFor: 'prim behavior' stamp: 'jb 9/29/2011 12:05'!
primitiveHPerform
	<returnTypeC: #void>
	| performSelector newReceiver lookupClass performMethod |
	performSelector := messageSelector.
	performMethod := newMethod.
	messageSelector := self stackValue: argumentCount - 1.
	newReceiver := self stackValue: argumentCount.

	"NOTE: the following lookup may fail and be converted to #doesNotUnderstand:,
	 so we must adjust argumentCount and slide args now, so that will work."

	"Slide arguments down over selector"
	argumentCount := argumentCount - 1.
	argumentCount to: 1 by: -1 do:
		[:i|
		stackPages
			longAt: stackPointer + (i * BytesPerWord)
			put: (stackPages longAt: stackPointer + ((i - 1) * BytesPerWord))].
	self pop: 1.
	lookupClass := objectMemory fetchClassOf: newReceiver.
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: newReceiver.
	self findNewMethodInClass: lookupClass.

	"Only test CompiledMethods for argument count - other objects will have to take their chances"
	((objectMemory isOopCompiledMethod: newMethod)
	  and: [(self argumentCountOf: newMethod) = argumentCount]) ifFalse:
		["Slide the args back up (sigh) and re-insert the selector."
		self unPop: 1.
		1 to: argumentCount by: 1 do:
			[:i |
			stackPages longAt: stackPointer + ((i - 1) * BytesPerWord)
				put: (stackPages longAt: stackPointer + (i * BytesPerWord))].
		stackPages longAt: stackPointer + (argumentCount * BytesPerWord) put: messageSelector.
		argumentCount := argumentCount + 1.
		newMethod := performMethod.
		messageSelector := performSelector.
		^self primitiveFail].

	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPStep2 methodsFor: 'prim behavior' stamp: 'jb 9/29/2011 12:05'!
primitiveHPerformInSuperclass
	| lookupClass rcvr currentClass |
	lookupClass := self stackTop.
	rcvr := self stackValue: 3.
	currentClass := objectMemory fetchClassOf: rcvr.
	[currentClass ~= lookupClass] whileTrue:
		[currentClass := self superclassOf: currentClass.
		 currentClass = objectMemory nilObject ifTrue: [^self primitiveFailFor: PrimErrBadArgument]].

	self primitiveObject: rcvr "a.k.a. self stackValue: 3"
		perform: (self stackValue: 2)
		withArguments: (self stackValue: 1)
		lookedUpIn: lookupClass "a.k.a. self stackTop"! !

!HStackInterpreterPStep2 methodsFor: 'prim behavior' stamp: 'jb 9/29/2011 12:05'!
primitiveHPerformWithArgs

	| lookupClass rcvr |
	rcvr := self stackValue: 2.
	lookupClass := objectMemory fetchClassOf: rcvr.

	self primitiveObject: rcvr "a.k.a. self stackValue: 2"
		perform: (self stackValue: 1)
		withArguments: self stackTop
		lookedUpIn: lookupClass! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
pushActiveContextBytecode
	| ourContext |
	
	ourContext := self ensureFrameIsMarried: localFP SP: localSP.
	self fetchNextBytecode.
	self internalPush: ourContext! !

!HStackInterpreterPStep2 methodsFor: '1 step' stamp: 'jb 9/29/2011 12:05'!
pushClosureCopyCopiedValuesBytecode
	"The compiler has pushed the values to be copied, if any.  Find numArgs and numCopied in the byte following.
	 Create a Closure with space for the copiedValues and pop numCopied values off the stack into the closure.
	 Set numArgs as specified, and set startpc to the pc following the block size and jump over that code."
	| newClosure numArgsNumCopied numArgs numCopied blockSize context |
	
	numArgsNumCopied := self fetchByte.
	numArgs := numArgsNumCopied bitAnd: 16rF.
	numCopied := numArgsNumCopied bitShift: -4.

	
	"Split blockSize := (self fetchByte * 256) + self fetchByte. into two because evaluation order in C is undefined."
	blockSize := self fetchByte << 8.
	blockSize := blockSize + self fetchByte.
	"No need to record the pushed copied values in the outerContext."
	context := self ensureFrameIsMarried: localFP SP: localSP + (numCopied * BytesPerWord).
	newClosure := self
					closureIn: context
					numArgs: numArgs
					instructionPointer: (self oopForPointer: localIP) + 2 - (method+BaseHeaderSize)
					numCopiedValues: numCopied.
	numCopied > 0 ifTrue:
		[0 to: numCopied - 1 do:
			[:i|
			"Assume: have just allocated a new BlockClosure; it must be young.
			 Thus, can use unchecked stores."
			 objectMemory storePointerUnchecked: i + ClosureFirstCopiedValueIndex
				ofObject: newClosure
				withValue: (self internalStackValue: numCopied - i - 1)].
		 self internalPop: numCopied].
	localIP := localIP + blockSize.
	self fetchNextBytecode.
	self internalPush: newClosure! !

!HStackInterpreterPStep2 methodsFor: 'toRemoveAtTerm' stamp: 'jb 9/29/2011 12:05'!
pushMaybeContextReceiverVariable: fieldIndex
	"Must trap accesses to married and widowed contexts.
	 But don't want to check on all inst var accesses.  This
	 method is only used by the long-form bytecodes, evading
	 the cost. Note that the method, closure and receiver fields
	 of married contexts are correctly initialized so they don't
	 need special treatment on read.  Only sender, instruction
	 pointer and stack pointer need to be intercepted on reads."
	| rcvr |
	<inline: true>
	self print: 'pushMaybeContextReceiverVariable:';cr.
	rcvr := self receiver.
	(fieldIndex < MethodIndex
	and: [self isContextNonInt: rcvr])
		ifTrue:
			[
			self printNameOfClass: (self fetchClassOf: rcvr) count: 1;cr.
			self internalPush: (self instVar: fieldIndex ofContext: rcvr)]
		ifFalse:
			[self internalPush: (objectMemory fetchPointer: fieldIndex ofObject: rcvr)]! !

!HStackInterpreterPStep2 methodsFor: 'support propagation' stamp: 'jb 9/29/2011 12:05'!
pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
<inline: true>
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle).].
	localIP := localIP -1.
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	self fetchNextBytecode
! !

!HStackInterpreterPStep2 methodsFor: 'bytecode self wrapping' stamp: 'jb 9/29/2011 12:05'!
pushReceiverBytecode

	| rcvr |
	self fetchNextBytecode.
	rcvr := self receiver.
	((self internalIsHandle: rcvr) and: [(self handleInlineUseSelfWrapping: rcvr) not] )ifTrue:  [
		 self internalPush: (self handleInlineReceiverOf: rcvr).]
	ifFalse:[self internalPush: rcvr.].
	! !

!HStackInterpreterPStep2 methodsFor: 'support state/propagation' stamp: 'jb 9/29/2011 12:05'!
pushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
<inline: true>
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].
! !

!HStackInterpreterPStep2 methodsFor: 'support state/propagation' stamp: 'jb 9/29/2011 12:05'!
pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  |
self inline: true.
(self handleInlineStateOf: aHandle) 
	ifTrue: [
				stateArray := (self handleInlineStateOf: aHandle).
				self internalPush: (self stObject: stateArray at: (fieldIndex + 1)).]
	ifFalse: [
				self  internalPush: (objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle))].
		
! !

!HStackInterpreterPStep2 methodsFor: 'support propagation' stamp: 'jb 9/29/2011 12:05'!
quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
<inline: true>
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle).].
	"localIP := localIP -1."
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	"self fetchNextBytecode"
! !

!HStackInterpreterPStep2 methodsFor: 'support propagation' stamp: 'jb 9/29/2011 12:05'!
quickPushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
<inline: true>
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].

	! !

!HStackInterpreterPStep2 methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:05'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self dLiteral: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
							lkupClass :=  (self handleInlineClassLookupOf: rcvr).
							self handleSend.	
	]  ifFalse: [self commonSend].
					.
	
! !

!HStackInterpreterPStep2 methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:05'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
							lkupClass :=  (self handleInlineClassLookupOf: rcvr).
							self handleSend.	
	]  ifFalse: [self commonSend].
					.
	
! !

!HStackInterpreterPStep2 methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:05'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
		lkupClass :=  (self handleInlineClassLookupOf: rcvr).
		self handleSend.	
	]  ifFalse: [self commonSend].
					.
	
! !

!HStackInterpreterPStep2 methodsFor: 'toRemoveAtTerm' stamp: 'jb 9/29/2011 12:05'!
sendPrimitiveOnHandle
	
	<inline: true>
	| succeeded primitiveIndex |
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
	self externalizeIPandSP.	
	succeeded := self slowPrimitiveResponse.
	self internalizeIPandSP.
	succeeded ifTrue:
		[self browserPluginReturnIfNeeded.
			^nil].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!HStackInterpreterPStep2 methodsFor: 'support state/propagation' stamp: 'jb 9/29/2011 12:05'!
storeReceiverVariableInHandle: fieldIndex ofObject: aHandle withValue: theValue

| stateArray |
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		self stObject: stateArray at: (fieldIndex + 1) put: theValue.]
	ifFalse: [
		objectMemory storePointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle) withValue: theValue.].

! !

!HStackInterpreterPStep2 methodsFor: 'support behavior' stamp: 'jb 9/29/2011 12:05'!
superclassSend
	"Send a message to self, starting lookup with the superclass of the class
	 containing the currently executing method."
	"Assume: messageSelector and argumentCount have been set, and that
	 the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSupersend' inCase: 133>
	| rcvr |
	lkupClass := self superclassOf: (self methodClassOf: method).
	self assert: lkupClass ~~ objectMemory nilObject.
	"rcvr := self internalStackValue: argumentCount.
	(self internalIsHandle: rcvr) ifTrue: [
							lkupClass :=   self superclassOf: (self handleInlineReceiverOf: rcvr).
							self handleSend.]."
	self commonSend.! !

!HStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:24'!
declareCVarsIn: aCCodeGenerator
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator var: #hPrimitiveTable
		declareC: 'void (*hPrimitiveTable[MaxPrimitiveIndex + 2 /* ', (MaxPrimitiveIndex +2) printString, ' */])(void) = ', self hPrimitiveTableString.
	! !

!HStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:24'!
hPrimitiveTable

	^ HPrimitiveTable! !

!HStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:24'!
hPrimitiveTableString
	"StackInterpreter initializePrimitiveTable primitiveTableString"
	^String streamContents:
		[:s | 
		s nextPut: ${.
		self hPrimitiveTable withIndexDo:
			[:primSpec :index |
			s
				crtab;
				nextPutAll: '/* ';
				print: index - 1;
				nextPutAll: ' */ ';
				nextPutAll: (primSpec isString
								ifTrue: [primSpec == #primitiveFail
											ifTrue: ['(void (*)(void))0']
											ifFalse: [primSpec]]
								ifFalse: ['(void (*)(void))', primSpec printString]);
				nextPut: $,].
			s cr; nextPutAll: ' 0 }']! !

!HStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 10/7/2011 15:14'!
initializeHandlePrimitiveTables 
	"self initializeHandlePrimitiveTables"
	HPrimitiveTable := Array new: MaxPrimitiveIndex + 1.
	self table: HPrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called")
		(1 primitiveAdd)				"not need handle version"
		(2 primitiveSubtract)			"not need handle version"
		(3 primitiveLessThan)			"not need handle version"
		(4 primitiveGreaterThan)		"not need handle version"
		(5 primitiveLessOrEqual)		"not need handle version"
		(6 primitiveGreaterOrEqual)		"not need handle version"
		(7 primitiveEqual)				"not need handle version"
		(8 primitiveNotEqual)			"not need handle version"
		(9 primitiveMultiply)				"not need handle version"
		(10 primitiveDivide)				"not need handle version"
		(11 primitiveMod)				"not need handle version"
		(12 primitiveDiv)				"not need handle version"
		(13 primitiveQuo)				"not need handle version"
		(14 primitiveBitAnd)			"not need handle version"
		(15 primitiveBitOr)				"not need handle version"
		(16 primitiveBitXor)				"not need handle version"
		(17 primitiveBitShift)			"not need handle version"
		(18 primitiveMakePoint)			"not need handle version"
		(19 0) "somtime we need to do bad thing"
		
		"LargeInteger Primitives (20-37)"
		(20 0)								"not need handle version"
		(21 primitiveAddLargeIntegers)					"not need handle version"
		(22 primitiveSubtractLargeIntegers)			"not need handle version"
		(23 primitiveLessThanLargeIntegers)			"not need handle version"
		(24 primitiveGreaterThanLargeIntegers)		"not need handle version"
		(25 primitiveLessOrEqualLargeIntegers)		"not need handle version"
		(26 primitiveGreaterOrEqualLargeIntegers)		"not need handle version"
		(27 primitiveEqualLargeIntegers)				"not need handle version"
		(28 primitiveNotEqualLargeIntegers)			"not need handle version"
		(29 primitiveMultiplyLargeIntegers)				"not need handle version"
		(30 primitiveDivideLargeIntegers)				"not need handle version"
		(31 primitiveModLargeIntegers)				"not need handle version"
		(32 primitiveDivLargeIntegers)					"not need handle version"
		(33 primitiveQuoLargeIntegers)				"not need handle version"
		(34 primitiveBitAndLargeIntegers)				"not need handle version"
		(35 primitiveBitOrLargeIntegers)				"not need handle version"
		(36 primitiveBitXorLargeIntegers)				"not need handle version"
		(37 primitiveBitShiftLargeIntegers)				"not need handle version"

		"Float Primitives (38-59)"
		(38 primitiveFloatAt)							"not need handle version"
		(39 primitiveFloatAtPut)							"not need handle version"
		(40 primitiveAsFloat)							"not need handle version"
		(41 primitiveFloatAdd)							"not need handle version"
		(42 primitiveFloatSubtract)						"not need handle version"
		(43 primitiveFloatLessThan)					"not need handle version"
		(44 primitiveFloatGreaterThan)					"not need handle version"
		(45 primitiveFloatLessOrEqual)					"not need handle version"
		(46 primitiveFloatGreaterOrEqual)				"not need handle version"
		(47 primitiveFloatEqual)							"not need handle version"
		(48 primitiveFloatNotEqual)						"not need handle version"
		(49 primitiveFloatMultiply)						"not need handle version"
		(50 primitiveFloatDivide)						"not need handle version"
		(51 primitiveTruncated)							"not need handle version"
		(52 primitiveFractionalPart)						"not need handle version"
		(53 primitiveExponent)							"not need handle version"
		(54 primitiveTimesTwoPower)					"not need handle version"
		(55 primitiveSquareRoot)						"not need handle version"
		(56 primitiveSine)								"not need handle version"
		(57 primitiveArctan)							"not need handle version"
		(58 primitiveLogN)								"not need handle version"
		(59 primitiveExp)								"not need handle version"

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveHAt)									"state handle"
		(61 primitiveHAtPut)								"state handle"
		(62 primitiveHSize)								"fixed field handle"				
		(63 primitiveStringAt)							"fixed field handle"
		(64 primitiveStringAtPut)						"fixed field handle"
		"The stream primitives no longer pay their way; normal Smalltalk code is faster."
		(65 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(66 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"
		(67 0 "a.k.a. primitiveFail but faster because primitiveFail won't even be called") "not need handle version"

		"StorageManagement Primitives (68-79)"
		(68 primitiveHObjectAt)						"fixed field handle"
		(69 primitiveHObjectAtPut)						"fixed field handle"
		(70 primitiveHNew)								"class handle"
		(71 primitiveHNewWithArg)						"class handle"
		(72 primitiveArrayBecomeOneWay)				"hum hum"
		(73 primitiveHInstVarAt)						"handle version state"
		(74 primitiveHInstVarAtPut)						"handle version state"
		(75 primitiveHIdentityHash)						"handle version identity"
		(76 primitiveStoreStackp)						"not need handle version"		
		(77 primitiveSomeInstance)						"not need handle version"
		(78 primitiveNextInstance)						"not need handle version"
		(79 primitiveNewMethod)						"??????"

		"Control Primitives (80-89)"
		(80 primitiveFail)								"not need handle version"
		(81 primitiveFail)								"not need handle version"
		(82 primitiveFail)								"not need handle version"
		(83 primitiveHPerform)							"shadow handle"
		(84 primitiveHPerformWithArgs)				"shadow handle"
		(85 primitiveSignal)								"not need handle version"
		(86 primitiveWait)								"not need handle version"
		(87 primitiveResume)							"not need handle version"
		(88 primitiveSuspend)							"not need handle version"
		(89 primitiveFlushCache)						"not need handle version"

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)						"not need handle version"
		(91 primitiveTestDisplayDepth)					"not need handle version"
		(92 primitiveSetDisplayMode)					"not need handle version"
		(93 primitiveInputSemaphore)					"not need handle version"
		(94 primitiveGetNextEvent)						"not need handle version"
		(95 primitiveInputWord)						
		(96 primitiveFail)								"not need handle version"
		(97 primitiveSnapshot)							"not need handle version"
		(98 primitiveStoreImageSegment)				"not need handle version"
		(99 primitiveLoadImageSegment)				"not need handle version"
		(100 primitivePerformInSuperclass)				"shadow handle"
		(101 primitiveBeCursor)						"not need handle version"
		(102 primitiveBeDisplay)						"not need handle version"
		(103 primitiveScanCharacters)					
		(104 primitiveFail)	"primitiveDrawLoop"		"not need handle version"
		(105 primitiveStringReplace)			
		(106 primitiveScreenSize)				"not need handle version"
		(107 primitiveMouseButtons)			"not need handle version"
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)			

		"System Primitives (110-119)"
		(110 primitiveHIdentical)		"handle version"
		(111 primitiveHClass)			"handle version"
		(112 primitiveBytesLeft)		"not need handle version"
		(113 primitiveQuit)				"not need handle version"
		(114 primitiveExitToDebugger)	"not need handle version"
		(115 primitiveHChangeClass)	"handle version"
		(116 primitiveFlushCacheByMethod)	"not need handle version"
		(117 primitiveExternalCall)				"not need handle version"
		(118 primitiveDoPrimitiveWithArgs) 	"not need handle version"
		(119 primitiveFlushCacheBySelector)	"not need handle version"
			"Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.
			Both are supported for backward compatibility."

		"Miscellaneous Primitives (120-127)"
		(120 primitiveCalloutToFFI)				"not need handle version"
		(121 primitiveImageName)				"not need handle version"
		(122 primitiveNoop)					"not need handle version"
		(123 primitiveFail)						"not need handle version"
		(124 primitiveLowSpaceSemaphore)	"not need handle version"
		(125 primitiveSignalAtBytesLeft)		"not need handle version"

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)	"not need handle version"
		(127 primitiveShowDisplayRect)		"not need handle version"
		(128 primitiveArrayBecome)			"not need handle version"
		(129 primitiveSpecialObjectsOop)		"not need handle version"
		(130 primitiveFullGC)					"not need handle version"
		(131 primitiveIncrementalGC)			"not need handle version"
		(132 primitiveHObjectPointsTo)		"hum hum"
		(133 primitiveSetInterruptKey)			"not need handle version"
		(134 primitiveInterruptSemaphore)		"not need handle version"
		(135 primitiveMillisecondClock)			"not need handle version"
		(136 primitiveSignalAtMilliseconds)		"not need handle version"
		(137 primitiveSecondsClock)			"not need handle version"
		(138 primitiveSomeObject)				" hum hum"
		(139 primitiveNextObject)				" hum hum"
		(140 primitiveBeep)					"not need handle version"
		(141 primitiveClipboardText)			"not need handle version"
		(142 primitiveVMPath)					"not need handle version"
		(143 primitiveShortAt)					"hum hum"
		(144 primitiveShortAtPut)				"hum hum"
		(145 primitiveConstantFill)				"hum hum"
		"NOTE: When removing the obsolete indexed primitives,
		the following two should go become #primitiveIntegerAt / atPut"
		(146 primitiveFail)						"not need handle version"
		(147 primitiveFail)						"not need handle version"
		(148 primitiveClone)					"not need handle version"
		(149 primitiveGetAttribute)				"not need handle version"

		"File Primitives (150-169) - NO LONGER INDEXED"
		(150 159 primitiveFail)					"not need handle version"
		(160 primitiveAdoptInstance)			"hum hum"
		(161 primitiveSetIdentityHash)
		(162 164 primitiveFail)					"not need handle version"
		(165 primitiveIntegerAt)				"hum hum"
		(166 primitiveIntegerAtPut)				"hum hum"
		(167 primitiveYield)						"hum hum"
		(168 primitiveCopyObject)				"not need handle version"
		(169 primitiveFail)						"not need handle version"

		"Sound Primitives (170-199) - NO LONGER INDEXED"
		(170 174 primitiveFail)

		"CogMemoryManager primitives"
		(175 primitiveBehaviorHash)			"not need handle version"	
		(176 primitiveMaxIdentityHash)			"not need handle version"
		(177 184 primitiveFail)					"not need handle version"

		"CriticalSection primitives"
		(185 primitiveExitCriticalSection)		"not need handle version"
		(186 primitiveEnterCriticalSection) 		"not need handle version"
		(187 primitiveTestAndSetOwnershipOfCriticalSection) "not need handle version"

		"Perform method directly"
		(188 primitiveExecuteMethodArgsArray) 		"shadow handle"
		(189 primitiveExecuteMethod)					"shadow handle"

		"Sound Primitives (continued) - NO LONGER INDEXED"
		(190 194 primitiveFail)					 "not need handle version"

		"Unwind primitives"
		(195 primitiveFindNextUnwindContext)	"not need handle version"
		(196 primitiveTerminateTo)				 "not need handle version"
		(197 primitiveFindHandlerContext)		 "not need handle version"
		(198 primitiveMarkUnwindMethod)		 "not need handle version"
		(199 primitiveMarkHandlerMethod)		 "not need handle version"

		"new closure primitives (were Networking primitives)"
		(200 primitiveClosureCopyWithCopiedValues)	 			"not need handle version"
		(201 primitiveClosureValue)  								"not need handle version"
		(202 primitiveClosureValue)  								"not need handle version"
		(203 primitiveClosureValue) 								"not need handle version"
		(204 primitiveClosureValue) 								"not need handle version"
		(205 primitiveClosureValue)								"not need handle version"
		(206 primitiveClosureValueWithArgs) 	 					"not need handle version"

		(207 209 primitiveFail)	"reserved for Cog primitives"

		(210 primitiveHContextAt)								"hum hum"
		(211 primitiveHContextAtPut)							"hum hum"
		(212 primitiveHContextSize)								"hum hum"
		(213 primitiveHContextXray)								"hum hum"
		(214 primitiveVoidVMState)								"not need handle version"
		(215 217 primitiveFail)	"reserved for Cog primitives"	"not need handle version"
		(218 primitiveDoNamedPrimitiveWithArgs)				"hum hum"
		(219 primitiveFail)										"not need handle version"
		(220 primitiveFail)										"not need handle version"

		(221 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch"	"not need handle version"
		(222 primitiveClosureValueNoContextSwitch) "valueNoContextSwitch:" "not need handle version"

		(223 229 primitiveFail)	"not need handle version"

		(230 primitiveRelinquishProcessor)												"not need handle version"
		(231 primitiveForceDisplayUpdate)												"not need handle version"
		(232 primitiveFormPrint)														"not need handle version"
		(233 primitiveSetFullScreen)													"not need handle version"
		(234 primitiveFail) "primBitmapdecompressfromByteArrayat"					"not need handle version"
		(235 primitiveFail) "primStringcomparewithcollated"							"not need handle version"
		(236 primitiveFail) "primSampledSoundconvert8bitSignedFromto16Bit"			"not need handle version"
		(237 primitiveFail) "primBitmapcompresstoByteArray"							"not need handle version"
		(238 239 primitiveFail) "serial port primitives"									"not need handle version"
		(240 primitiveUTCMicrosecondClock)											"not need handle version"
		(241 primitiveLocalMicrosecondClock)											"not need handle version"
		(242 primitiveSignalAtUTCMicroseconds)										"not need handle version"
		(243 primitiveUpdateTimezone) "primStringtranslatefromtotable"				"not need handle version"
		(244 primitiveFail) "primStringfindFirstInStringinSetstartingAt"					"not need handle version"
		(245 primitiveFail) "primStringindexOfAsciiinStringstartingAt"					"not need handle version"
		(246 primitiveFail) "primStringfindSubstringinstartingAtmatchTable"				"not need handle version"
		(247 primitiveSnapshotEmbedded)												"not need handle version"
		(248 primitiveFail) "primitiveInvokeObjectAsMethod"							"not need handle version"
		(249 primitiveArrayBecomeOneWayCopyHash)									"hum hum"

		"VM Implementor Primitives (250-255)"
		(250 primitiveClearVMProfile)													"not need handle version"
		(251 primitiveControlVMProfiling)												"not need handle version"
		(252 primitiveVMProfileSamplesInto)											"not need handle version"
		(253 primitiveFail )																"not need handle version"
		(254 primitiveVMParameter)													"not need handle version"
		(255 primitiveFail) 																"not need handle version"

		"Quick Push Const Methods"
		(256 nil) "primitivePushSelf"													"handle version"
		(257 nil) "primitivePushTrue"													"not need handle version"
		(258 nil) "primitivePushFalse"													"not need handle version"
		(259 nil) "primitivePushNil"														"not need handle version"
		(260 nil) "primitivePushMinusOne"												"not need handle version"
		(261 nil) "primitivePushZero"													"not need handle version"
		(262 nil) "primitivePushOne"													"not need handle version"
		(263 nil) "primitivePushTwo"													"not need handle version"

		"Quick Push Inst Var Methods"
		(264 519 nil) "primitiveLoadInstVar"											 "Handle"

		(520 primitiveFail)
		"MIDI Primitives (521-539) - NO LONGER INDEXED"
		(521 529 primitiveFail)						 "not need handle version"
		(530 539 primitiveFail)  					 "not need handle version"

		"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
		"Pen Tablet Primitives - NO LONGER INDEXED"
		(540 549 primitiveFail)						 "not need handle version"

		"Sound Codec Primitives - NO LONGER INDEXED"
		(550 569 primitiveFail)						 "not need handle version"

		"External primitive support primitives"
		(570 primitiveFlushExternalPrimitives)		 "not need handle version"
		(571 primitiveUnloadModule)				 "not need handle version"
		(572 primitiveListBuiltinModule)				 "not need handle version"
		(573 primitiveListExternalModule)			 "not need handle version"
		(574 primitiveFail) 							 "not need handle version"
		"Unassigned Primitives"
		(575 primitiveFail)							 "not need handle version")! !

!HStackInterpreterPrimitives class methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:24'!
requiredMethodNames
	^super requiredMethodNames addAll: self hPrimitiveTable; yourself! !

!HStackInterpreterPrimitives methodsFor: 'bytecode identity' stamp: 'jb 8/25/2011 14:59'!
bytecodePrimClass
	| rcvr |
	rcvr := self internalStackTop.
	(self internalIsHandle: rcvr)
		ifTrue:[self internalStackTopPut: (self handleInlineClassLookupOf: rcvr)]
		ifFalse:[self internalStackTopPut: (self fetchClassOf: rcvr).].
	self fetchNextBytecode.
! !

!HStackInterpreterPrimitives methodsFor: 'bytecode identity' stamp: 'jb 8/11/2011 15:10'!
bytecodePrimEquivalent

	| rcvr arg |
	rcvr := self internalStackValue: 1.
	arg := self internalStackValue: 0.
	(self internalIsHandle: arg)
		ifTrue:[arg :=  (self handleInlineReceiverOf: arg).].
	(self internalIsHandle: rcvr)
		ifTrue:[rcvr :=  (self handleInlineReceiverOf: rcvr).].
	self booleanCheat: rcvr = arg.! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/7/2011 15:33'!
commonHAt: stringy
	| rcvr index stateArray value result trcvr |
	rcvr := self stackValue: 1.
	index := self stackTop.
	index := objectMemory integerValueOf: index.
	"The slow but sure way..."
	self initPrimCall.
	(self handleInlineStateOf: rcvr) 
	ifTrue: [
		stateArray := (self handleInlineIndexedFieldOf: rcvr).
		value := self stObject: stateArray at: index.]
	ifFalse: [
		trcvr := self handleInlineReceiverOf: rcvr.
		value := self stObject: trcvr at: index.
	].

	self pop: argumentCount+1.
	self successful ifTrue:
		[stringy ifTrue: [value := self characterForAscii: (objectMemory integerValueOf: value)]].
	
	(self handleInlineUsePropagation: rcvr) 
		ifTrue: [ self pushHandle: rcvr propagateValue: value.] 
		ifFalse:[ self push: value].
	! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/5/2011 17:07'!
commonHAtPut: stringy
	| value index rcvr atIx stateArray |
	value := self stackTop.
	rcvr := self stackValue: 2.
	index := self stackValue: 1.
	index := objectMemory integerValueOf: index.

	"The slow but sure way..."
	self initPrimCall.
	
	(self handleInlineStateOf: rcvr) 
		ifTrue: [rcvr := (self handleInlineIndexedFieldOf: rcvr).]
		ifFalse:[rcvr := (self handleInlineReceiverOf: rcvr).].
	stringy
		ifTrue: [self stObject: rcvr at: index put: (self asciiOfCharacter: value)]
		ifFalse: [self stObject: rcvr at: index put: value].
	self successful ifTrue:
		[^ self pop: argumentCount+1 thenPush: value]! !

!HStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 8/30/2011 12:51'!
extendedStoreBytecode
	| descriptor variableType variableIndex association top rcvr |
	<inline: true>
	descriptor := self fetchByte.
	self fetchNextBytecode.
	variableType := descriptor >> 6 bitAnd: 3.
	variableIndex := descriptor bitAnd: 63.
      top := self internalStackTop.
	rcvr := self receiver.
	variableType = 0 ifTrue:[
		"(self internalIsHandle: top) 
			ifTrue: [top := self handleInlineReceiverOf: top]."
	(self internalIsHandle: rcvr)  	 
		ifTrue: [^ self storeReceiverVariableInHandle: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top.]
		ifFalse: [^objectMemory storePointer: variableIndex ofObject: rcvr withValue: top]].
	variableType = 1 ifTrue:
		[^self temporary: variableIndex in: localFP put: top].
	
	variableType = 3 ifTrue:
		[association := self literal: variableIndex.
		 ^objectMemory storePointer: ValueIndex ofObject: association withValue: top].
	self error: 'illegal store'.
	^nil
! !

!HStackInterpreterPrimitives methodsFor: 'support hprimitive table' stamp: 'jb 9/29/2011 14:34'!
hFunctionPointerFor: primIdx inClass: theClass
	"Find an actual function pointer for this primitiveIndex.  This is an
	opportunity to specialise the prim for the relevant class (format for
	example).  Default for now is simply the entry in the base primitiveTable."

	<returnTypeC: 'void (*hFunctionPointerForinClass(sqInt primIdx,sqInt theClass))(void)'>
	^primIdx > MaxPrimitiveIndex ifTrue: [0] ifFalse: [hPrimitiveTable at: primIdx]! !

!HStackInterpreterPrimitives methodsFor: 'support behavior' stamp: 'jb 9/28/2011 12:50'!
hInternalQuickPrimitiveResponse
	"Called under the assumption that primFunctionPtr has been preloaded"
	<inline:true>
	| localPrimIndex rcvr |
	self print: 'hInternalQuickPrimitiveResponse';cr.
	
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self printNum: localPrimIndex;cr.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 9/28/2011 13:13'!
initializeHandle: handleInstance withReceiver: value andShadowClass: handle
		<inline:true>
		objectMemory storePointer: 0 ofObject: handleInstance withValue: value. 
		objectMemory storePointer: 1 ofObject: handleInstance withValue: handle.
		objectMemory storePointer: 3 ofObject: handleInstance withValue: (objectMemory integerObjectOf:6).
	! !

!HStackInterpreterPrimitives methodsFor: 'support behavior' stamp: 'jb 9/29/2011 14:40'!
internalExecuteNewMethod
	| succeeded primitiveIndex rcvr |
	<inline: true>
	rcvr := self internalStackValue: argumentCount.
	(self internalIsHandle: rcvr) 
	ifTrue: [
		primitiveIndex := self primitiveIndexOf: newMethod.
		primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
		primitiveFunctionPointer ~~ 0 ifTrue: [
			self isPrimitiveFunctionPointerAnIndex ifTrue:
				[^self hInternalQuickPrimitiveResponse].
			self externalizeIPandSP.
			succeeded := self slowPrimitiveResponse.
			self internalizeIPandSP.
			succeeded ifTrue:
				[self browserPluginReturnIfNeeded.
				^nil].
		]]

	ifFalse: [
		primitiveFunctionPointer ~~ 0 ifTrue:
			[self isPrimitiveFunctionPointerAnIndex ifTrue:
				[^self internalQuickPrimitiveResponse].
			self externalizeIPandSP.
			 succeeded := self slowPrimitiveResponse.
			 self internalizeIPandSP.
			 succeeded ifTrue:
				[self browserPluginReturnIfNeeded.
				^nil]]].
		"if not primitive, or primitive failed, activate the method"
		^self internalActivateNewMethod.
	
	

! !

!HStackInterpreterPrimitives methodsFor: 'toRemoveAtTerm' stamp: 'jb 9/22/2011 11:50'!
internalQuickPrimitiveResponseForHandle
	"Called under the assumption that primFunctionPtr has been preloaded"
	
	| localPrimIndex rcvr |
	self assert: self isPrimitiveFunctionPointerAnIndex.
	rcvr := self internalStackTop.		
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue:[					
		self internalPop: 1.
		self quickPushReceiverVariableInHandle: (localPrimIndex - 264) ofObject: rcvr.
		 ^true].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self internalStackTopPut: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self internalStackTopPut: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self internalStackTopPut: objectMemory nilObject. ^true].
	self internalStackTopPut: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true! !

!HStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:13'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend
					.
	
! !

!HStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/25/2011 17:00'!
primitiveEquivalent
"is the receiver the same object as the argument?
In case of handle we should check for all object other object to"
	| thisObject otherObject |
	self print: 'Equivalent';cr.
	otherObject := self popStack.
	thisObject := self stackValue: 1.
	(self internalIsHandle: otherObject)
		ifTrue:[otherObject :=  (self handleInlineReceiverOf: otherObject).].
	self pushBool: thisObject = otherObject! !

!HStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 7/20/2011 18:24'!
primitiveHAdoptInstance
	"Primitive. Change the class of the argument to make it an instance of the receiver
	 given that the format of the receiver matches the format of the argument's class.
	 Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a
	 compact class and the argument isn't, or when the argument's class is compact and
	 the receiver isn't, or when the format of the receiver is different from the format of
	 the argument's class, or when the arguments class is fixed and the receiver's size
	 differs from the size that an instance of the argument's class should have."
	^self primitiveFail! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/10/2011 14:29'!
primitiveHAt
	self commonHAt: false.! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 8/15/2011 11:29'!
primitiveHAtPut

	self commonHAtPut: false.! !

!HStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 7/20/2011 18:24'!
primitiveHChangeClass
	"Primitive. Change the class of the receiver into the class of the argument given that the format of the receiver matches the format of the argument's class. Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a compact class and the argument isn't, or when the argument's class is compact and the receiver isn't, or when the format of the receiver is different from the format of the argument's class, or when the arguments class is fixed and the receiver's size differs from the size that an instance of the argument's class should have."
	^self primitiveFail
	! !

!HStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 8/11/2011 14:52'!
primitiveHClass
	| instance |
	
	<inline: true>
	instance := self stackTop.
	self pop: argumentCount+1 thenPush: (self handleInlineClassLookupOf: instance).

	! !

!HStackInterpreterPrimitives methodsFor: '#$%@! of context' stamp: ''!
primitiveHContextAt
	| index value aContext spouseFP hdr fmt totalLength fixedFields stSize |
	<var: #spouseFP type: #'char *'>
	index := self stackTop.
	(objectMemory isIntegerObject: index) ifFalse:
		[^self primitiveFail].
	index := objectMemory integerValueOf: index.
	aContext := self stackValue: 1.
	"Duplicating much of stObject:at:put: here allows stObject:at:put: to omit tests for contexts."
	hdr := objectMemory baseHeader: aContext.
	(objectMemory isContextHeader: hdr) ifFalse: "might be an instance of a subclass"
		[value := self stObject: aContext at: index.
		 ^self pop: 2 thenPush: value].
	self externalWriteBackHeadFramePointers.
	(self isStillMarriedContext: aContext) ifFalse:
		[fmt := objectMemory formatOfHeader: hdr.
		 totalLength := objectMemory lengthOf: aContext baseHeader: hdr format: fmt.
		 fixedFields := objectMemory fixedFieldsOf: aContext format: fmt length: totalLength.
		 stSize := self stackPointerForMaybeMarriedContext: aContext.
		 (index between: 1 and: stSize) ifFalse:
			[^self primitiveFail].			
		value := self subscript: aContext with: (index + fixedFields) format: fmt.
		^self pop: 2 thenPush: value].
	spouseFP := self frameOfMarriedContext: aContext.
	(index between: 1 and: (self stackPointerIndexForFrame: spouseFP)) ifFalse:
		[^self primitiveFail].
	value := self temporary: index - 1 in: spouseFP.
	self pop: 2 thenPush: value! !

!HStackInterpreterPrimitives methodsFor: '#$%@! of context' stamp: ''!
primitiveHContextAtPut
	| index value aContext spouseFP hdr fmt totalLength fixedFields stSize |
	<var: #spouseFP type: #'char *'>
	value := self stackTop.
	index := self stackValue: 1.
	aContext := self stackValue: 2.
	(objectMemory isIntegerObject: index) ifFalse:
		[^self primitiveFail].
	"Duplicating much of stObject:at:put: here allows stObject:at:put: to omit tests for contexts."
	hdr := objectMemory baseHeader: aContext.
	index := objectMemory integerValueOf: index.
	(objectMemory isContextHeader: hdr) ifFalse: "might be an instance of a subclass"
		[self stObject: aContext at: index put: value.
		 ^self pop: 3 thenPush: value].
	self externalWriteBackHeadFramePointers.
	(self isStillMarriedContext: aContext) ifFalse:
		[fmt := objectMemory formatOfHeader: hdr.
		 totalLength := objectMemory lengthOf: aContext baseHeader: hdr format: fmt.
		 fixedFields := objectMemory fixedFieldsOf: aContext format: fmt length: totalLength.
		 stSize := self stackPointerForMaybeMarriedContext: aContext.
		 (index between: 1 and: stSize) ifFalse:
			[^self primitiveFail].			
		self subscript: aContext with: (index + fixedFields) storing: value format: fmt.
		^self pop: 3 thenPush: value].
	spouseFP := self frameOfMarriedContext: aContext.
	(index between: 1 and: (self stackPointerIndexForFrame: spouseFP)) ifFalse:
		[^self primitiveFail].
	self temporary: index - 1 in: spouseFP put: value.
	^self pop: 3 thenPush: value! !

!HStackInterpreterPrimitives methodsFor: '#$%@! of context' stamp: ''!
primitiveHContextSize
	| rcvr sz hdr fmt totalLength fixedFields |
	rcvr := self stackTop.
	
	hdr := objectMemory baseHeader: rcvr.
	fmt := objectMemory formatOfHeader: hdr.
	totalLength := objectMemory lengthOf: rcvr baseHeader: hdr format: fmt.
	fixedFields := objectMemory fixedFieldsOf: rcvr format: fmt length: totalLength.
	(objectMemory isContextHeader: hdr)
		ifTrue:
			[self externalWriteBackHeadFramePointers.
			sz := self stackPointerForMaybeMarriedContext: rcvr]
		ifFalse: [sz := totalLength - fixedFields].
	self successful ifTrue:
		[self pop: 1 thenPush: (objectMemory integerObjectOf: sz)]! !

!HStackInterpreterPrimitives methodsFor: '#$%@! of context' stamp: ''!
primitiveHContextXray
	"Lift the veil from a context and answer an integer describing its interior state.
	 Used for e.g. VM tests so they can verify they're testing what they think they're testing.
	 0 implies a vanilla heap context.
	 Bit 0 = is or was married to a frame
	 Bit 1 = is still married to a frame
	 Bit 2 = frame is executing machine code
	 Bit 3 = has machine code pc (as opposed to nil or a bytecode pc)
	 Bit 4 = method is currently compiled to machine code"
	| context flags |
	context := self stackTop.
	(self isMarriedOrWidowedContext: context)
		ifTrue:
			[(self checkIsStillMarriedContext: context currentFP: framePointer)
				ifTrue: [flags := 3]
				ifFalse: [flags := 1]]
		ifFalse:
			[flags := 0].
	self pop: 1 thenPush: (objectMemory integerObjectOf: flags)! !

!HStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 7/20/2011 18:24'!
primitiveHExecuteMethod
	"receiver, args, then method are on top of stack. Execute method against receiver and args.
	 Set primitiveFunctionPointer because no cache lookup has been done for the method, and
	 hence primitiveFunctionPointer is stale."
	| methodArgument primitiveIndex |
	methodArgument := self stackTop.
	(objectMemory isOopCompiledMethod: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argumentCount - 1 = (self argumentCountOf: methodArgument) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	newMethod := self popStack.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argumentCount - 1.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 7/20/2011 18:24'!
primitiveHExecuteMethodArgsArray
	"receiver, argsArray, then method are on top of stack.  Execute method against
	 receiver and args.  Allow for up to two extra arguments (e.g. for mirror primitives).
	 Set primitiveFunctionPointer because no cache lookup has been done for the
	 method, and hence primitiveFunctionPointer is stale."
	| methodArgument argCnt argumentArray primitiveIndex |
	methodArgument := self stackTop.
	argumentArray := self stackValue: 1.
	((objectMemory isOopCompiledMethod: methodArgument)
	 and: [objectMemory isArray: argumentArray]) ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	argCnt := self argumentCountOf: methodArgument.
	argCnt = (objectMemory fetchWordLengthOf: argumentArray) ifFalse:
		[^self primitiveFailFor: PrimErrBadNumArgs].
	argumentCount > 2 ifTrue: "CompiledMethod class>>receiver:withArguments:executeMethod:
								SqueakObjectPrimitives class >> receiver:withArguments:apply:
								VMMirror>>ifFail:object:with:executeMethod: et al"
		[argumentCount > 4 ifTrue:
			[^self primitiveFailFor: PrimErrUnsupported].
		self stackValue: argumentCount put: (self stackValue: 2)]. "replace actual receiver with desired receiver"
	"and push the actual arguments"
	self pop: argumentCount.
	0 to: argCnt - 1 do:
		[:i|
		self push: (objectMemory fetchPointer: i ofObject: argumentArray)].
	newMethod := methodArgument.
	primitiveIndex := self primitiveIndexOf: newMethod.
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: nil.
	argumentCount := argCnt.
	"We set the messageSelector for executeMethod below since things
	 like the at cache read messageSelector and so it cannot be left stale."
	messageSelector := objectMemory nilObject.
	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 10/25/2011 17:00'!
primitiveHIdentical
	"is the receiver/first argument the same object as the (last) argument?.
	 pop argumentCount because this can be used as a mirror primitive."
	| thisObject otherObject |
	
	self print: 'Identical';cr.
	otherObject := self stackValue: 1.
	thisObject := self stackTop.
	otherObject :=  (self handleInlineReceiverOf: otherObject).
	(self internalIsHandle: thisObject) ifTrue:[ thisObject :=  (self handleInlineReceiverOf: thisObject).].
	
	self pop: argumentCount + 1 thenPushBool: thisObject = otherObject ! !

!HStackInterpreterPrimitives methodsFor: 'prim identity' stamp: 'jb 8/11/2011 15:10'!
primitiveHIdentityHash
	| thisReceiver |
	thisReceiver := self stackTop.
	thisReceiver := self handleInlineReceiverOf: thisReceiver.
	(objectMemory isIntegerObject: thisReceiver)
		ifTrue: [self primitiveFail]
		ifFalse: [self pop:1 thenPushInteger: (objectMemory hashBitsOf: thisReceiver)]! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 9/29/2011 17:51'!
primitiveHInstVarAt
	| index aHandle stateArray value fieldIndex |

	index := self stackIntegerValue: 0.	
	aHandle := self stackValue: 1.
	self pop: argumentCount + 1.
	(self handleUseState: aHandle) 
		ifTrue: [
			stateArray := (self handleInlineStateOf: aHandle).
			value := self stObject: stateArray at: (index).
			]
	ifFalse: [
		value := objectMemory fetchPointer: (index - 1) ofObject: (self handleInlineReceiverOf: aHandle).].
	
	"(self handleInlineUsePropagation: aHandle) 
		ifTrue: [ self pushHandle: aHandle propagateValue: value.] 
		ifFalse:[ self push: value]."
	self push: value.! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 8/11/2011 15:09'!
primitiveHInstVarAtPut
	| newValue index aHandle hdr fmt totalLength fixedFields stateArray |
	newValue := self stackTop.
	index := self stackIntegerValue: 1.
	aHandle := self stackValue: 2.
	
	
	
	(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		self stObject: stateArray at: (index) put: newValue.]
	ifFalse: [
		objectMemory storePointer: index ofObject: (self handleInlineReceiverOf: aHandle) withValue: newValue.].

	self pop: argumentCount + 1 thenPush: newValue! !

!HStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 9/28/2011 13:01'!
primitiveHNew
	"Allocate a new fixed-size instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free. May cause a GC"
	|  handle hClass spaceOkay value handleInstance |
	
	self print: 'primitiveHNew';cr.
	handle := self popStack.
	hClass := self  handleInlineReceiverOf: handle.
	spaceOkay := self sufficientSpaceToInstantiate: hClass indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [value := objectMemory instantiateClass: hClass indexableSize: 0].
	spaceOkay := self sufficientSpaceToInstantiate: (self classHandleInline) indexableSize: 0.
	self success: spaceOkay.
	self successful ifTrue: [handleInstance :=  objectMemory instantiateClass: (self classHandleInline) indexableSize: 0.].
	self initializeHandle: handleInstance withReceiver: value andShadowClass: handle.
	self push: handleInstance.! !

!HStackInterpreterPrimitives methodsFor: 'prim class handle' stamp: 'jb 8/30/2011 17:17'!
primitiveHNewWithArg
	"Allocate a new indexable instance. Fail if the allocation would leave less than lowSpaceThreshold bytes free."
	| size class spaceOkay |
	self print: 'primitiveHNewWithArg';cr.
	size := self positive32BitValueOf: self stackTop.
	class := self stackValue: 1.
	self success: size >= 0.
	self successful
		ifTrue: ["The following may cause GC!!"
			spaceOkay := self sufficientSpaceToInstantiate: class indexableSize: size.
			self success: spaceOkay.
			class := self stackValue: 1].
	self successful ifTrue: [self pop: 2 thenPush: (objectMemory instantiateClass: class indexableSize: size)]! !

!HStackInterpreterPrimitives methodsFor: 'prim fixed field' stamp: 'jb 7/20/2011 18:24'!
primitiveHObjectAt
"Defined for CompiledMethods only"
	| thisReceiver index |
	index  := self stackIntegerValue: 0.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 1.
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	self pop: 2 thenPush: (objectMemory fetchPointer: index - 1 ofObject: thisReceiver)! !

!HStackInterpreterPrimitives methodsFor: 'prim fixed field' stamp: 'jb 7/20/2011 18:24'!
primitiveHObjectAtPut
"Defined for CompiledMethods only"
	| thisReceiver index newValue |
	newValue := self stackValue: 0.
	index := self stackIntegerValue: 1.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	thisReceiver := self stackValue: 2.
	(index > 0 and: [index <= ((self literalCountOf: thisReceiver) + LiteralStart)]) ifFalse:
		[^self primitiveFailFor: PrimErrBadIndex].
	objectMemory storePointer: index - 1 ofObject: thisReceiver withValue: newValue.
	self pop: 3 thenPush: newValue! !

!HStackInterpreterPrimitives methodsFor: 'prim to find where i put it' stamp: 'jb 7/20/2011 18:24'!
primitiveHObjectPointsTo
	"This primitive is assumed to be fast (see e.g. MethodDictionary>>includesKey:) so make it so.
	 N.B.  Written to use literalHeaderOf: so that in Cog subclasses cogged methods (whose headers
	 point to the machine code method) are still correctly scanned, for the header as well as literals."
	| rcvr thang header fmt lastField methodHeader |
	thang := self stackTop.
	rcvr := self stackValue: 1.
	(objectMemory isIntegerObject: rcvr) ifTrue:
		[^self pop: 2 thenPushBool: false].

	"Inlined version of lastPointerOf: for speed in determining if rcvr is a context."
	header := objectMemory baseHeader: rcvr.
	fmt := objectMemory formatOfHeader: header.
	fmt <= 4
		ifTrue:
			[(fmt = 3
			  and: [objectMemory isContextHeader: header]) 
				ifTrue:
	 				[(self isMarriedOrWidowedContext: rcvr) ifTrue:
						[self externalWriteBackHeadFramePointers.
						 (self isStillMarriedContext: rcvr) ifTrue:
							[^self pop: 2
									thenPushBool: (self marriedContext: rcvr
														pointsTo: thang
														stackDeltaForCurrentFrame: 2)]].
					"contexts end at the stack pointer"
					lastField := CtxtTempFrameStart + (self fetchStackPointerOf: rcvr) * BytesPerWord]
				ifFalse:
					[lastField := (objectMemory sizeBitsOfSafe: rcvr) - BaseHeaderSize]]
		ifFalse:
			[fmt < 12 "no pointers" ifTrue:
				[^self pop: 2 thenPushBool: false].
			"CompiledMethod: contains both pointers and bytes:"
			methodHeader := self headerOf: rcvr.
			methodHeader = thang ifTrue: [^self pop: 2 thenPushBool: true].
			lastField := ((self literalCountOfHeader: methodHeader) + 1) * BytesPerWord].

	BaseHeaderSize to: lastField by: BytesPerWord do:
		[:i |
		(self longAt: rcvr + i) = thang ifTrue:
			[^self pop: 2 thenPushBool: true]].
	self pop: 2 thenPushBool: false! !

!HStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 7/20/2011 18:24'!
primitiveHPerform
	<returnTypeC: #void>
	| performSelector newReceiver lookupClass performMethod |
	performSelector := messageSelector.
	performMethod := newMethod.
	messageSelector := self stackValue: argumentCount - 1.
	newReceiver := self stackValue: argumentCount.

	"NOTE: the following lookup may fail and be converted to #doesNotUnderstand:,
	 so we must adjust argumentCount and slide args now, so that will work."

	"Slide arguments down over selector"
	argumentCount := argumentCount - 1.
	argumentCount to: 1 by: -1 do:
		[:i|
		stackPages
			longAt: stackPointer + (i * BytesPerWord)
			put: (stackPages longAt: stackPointer + ((i - 1) * BytesPerWord))].
	self pop: 1.
	lookupClass := objectMemory fetchClassOf: newReceiver.
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: newReceiver.
	self findNewMethodInClass: lookupClass.

	"Only test CompiledMethods for argument count - other objects will have to take their chances"
	((objectMemory isOopCompiledMethod: newMethod)
	  and: [(self argumentCountOf: newMethod) = argumentCount]) ifFalse:
		["Slide the args back up (sigh) and re-insert the selector."
		self unPop: 1.
		1 to: argumentCount by: 1 do:
			[:i |
			stackPages longAt: stackPointer + ((i - 1) * BytesPerWord)
				put: (stackPages longAt: stackPointer + (i * BytesPerWord))].
		stackPages longAt: stackPointer + (argumentCount * BytesPerWord) put: messageSelector.
		argumentCount := argumentCount + 1.
		newMethod := performMethod.
		messageSelector := performSelector.
		^self primitiveFail].

	self executeNewMethod.
	"Recursive xeq affects primErrorCode"
	self initPrimCall! !

!HStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 7/20/2011 18:24'!
primitiveHPerformInSuperclass
	| lookupClass rcvr currentClass |
	lookupClass := self stackTop.
	rcvr := self stackValue: 3.
	currentClass := objectMemory fetchClassOf: rcvr.
	[currentClass ~= lookupClass] whileTrue:
		[currentClass := self superclassOf: currentClass.
		 currentClass = objectMemory nilObject ifTrue: [^self primitiveFailFor: PrimErrBadArgument]].

	self primitiveObject: rcvr "a.k.a. self stackValue: 3"
		perform: (self stackValue: 2)
		withArguments: (self stackValue: 1)
		lookedUpIn: lookupClass "a.k.a. self stackTop"! !

!HStackInterpreterPrimitives methodsFor: 'prim behavior' stamp: 'jb 7/20/2011 18:24'!
primitiveHPerformWithArgs

	| lookupClass rcvr |
	rcvr := self stackValue: 2.
	lookupClass := objectMemory fetchClassOf: rcvr.

	self primitiveObject: rcvr "a.k.a. self stackValue: 2"
		perform: (self stackValue: 1)
		withArguments: self stackTop
		lookedUpIn: lookupClass! !

!HStackInterpreterPrimitives methodsFor: 'prim state' stamp: 'jb 10/5/2011 18:26'!
primitiveHSize
	| rcvr hdr fmt fixedFields totalLength |
	rcvr := self stackTop.
	rcvr := self handleInlineReceiverOf: rcvr.
	((objectMemory isIntegerObject: rcvr) "Integers are not indexable"
	 or: [hdr := objectMemory baseHeader: rcvr.
		(fmt := objectMemory formatOfHeader: hdr) < 2]) "This is not an indexable object"
		ifTrue:
			[^self primitiveFailFor: PrimErrBadReceiver].
	(fmt = 3 and: [objectMemory isContextHeader: hdr]) ifTrue:
		[^self primitiveContextSize].
	totalLength := objectMemory lengthOf: rcvr baseHeader: hdr format: fmt.
	fixedFields := objectMemory fixedFieldsOf: rcvr format: fmt length: totalLength.
	self pop: argumentCount + 1 thenPush: (objectMemory integerObjectOf: totalLength - fixedFields)! !

!HStackInterpreterPrimitives methodsFor: 'support propagation' stamp: 'jb 8/11/2011 15:19'!
pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
<inline: true>
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle).].
	localIP := localIP -1.
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	self fetchNextBytecode
! !

!HStackInterpreterPrimitives methodsFor: 'bytecode self wrapping' stamp: 'jb 8/11/2011 15:00'!
pushReceiverBytecode

	| rcvr |
	self fetchNextBytecode.
	rcvr := self receiver.
	((self internalIsHandle: rcvr) and: [(self handleInlineUseSelfWrapping: rcvr) not] )ifTrue:  [
		 self internalPush: (self handleInlineReceiverOf: rcvr).]
	ifFalse:[self internalPush: rcvr.].
	! !

!HStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 5/11/2011 13:02'!
pushReceiverVariable: fieldIndex

	| rcvr |
	rcvr := self receiver.
	(self internalIsHandle: rcvr) ifTrue: [
		self pushReceiverVariableInHandle: fieldIndex ofObject: rcvr.]
	ifFalse: [
		self internalPush: (objectMemory fetchPointer: fieldIndex ofObject: rcvr)].! !

!HStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 8/11/2011 15:03'!
pushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
<inline: true>
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self pushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].
! !

!HStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 8/11/2011 15:09'!
pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  |
self inline: true.
(self handleInlineStateOf: aHandle) 
	ifTrue: [
				stateArray := (self handleInlineStateOf: aHandle).
				self internalPush: (self stObject: stateArray at: (fieldIndex + 1)).]
	ifFalse: [
				self  internalPush: (objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle))].
		
! !

!HStackInterpreterPrimitives methodsFor: 'support propagation' stamp: 'jb 8/11/2011 15:20'!
quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle

| stateArray  value |
<inline: true>
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		value := self stObject: stateArray at: (fieldIndex + 1).
		]
	ifFalse: [
		value := objectMemory fetchPointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle).].
	"localIP := localIP -1."
	self externalizeIPandSP.
	self pushHandle: aHandle propagateValue: value.
	self internalizeIPandSP.
	"self fetchNextBytecode"
! !

!HStackInterpreterPrimitives methodsFor: 'support propagation' stamp: 'jb 8/11/2011 15:03'!
quickPushReceiverVariableInHandle: fieldIndex ofObject: aHandle

| stateArray  |
<inline: true>
(self handleInlineUsePropagation: aHandle)
	ifTrue: [
		self quickPushPropagatedReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle]
	ifFalse: [
		self pushReceiverVariableThrougtHandle: fieldIndex ofHandle: aHandle].

	! !

!HStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 14:32'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].
	self commonSend.
					.
	
! !

!HStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:14'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].	
	 self commonSend.
					.
	
! !

!HStackInterpreterPrimitives methodsFor: 'bytecode behavior ' stamp: 'jb 9/29/2011 12:14'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
						(self handleInlineUseBehavior: rcvr) ifTrue: [
							lkupClass :=  (self handleClassLookupOf: rcvr).
							]
						ifFalse: [
							lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
							]].	
	self commonSend.
					.
	
! !

!HStackInterpreterPrimitives methodsFor: 'bytecode state' stamp: 'jb 8/30/2011 12:52'!
storeAndPopReceiverVariableBytecode
	"Note: This code uses 
	storePointerUnchecked:ofObject:withValue: and does the 
	store check explicitely in order to help the translator 
	produce better code."
	| rcvr top |
	rcvr := self receiver.
	top := self internalStackTop.
	
	(self internalIsHandle: rcvr) 
	ifTrue:[
		self storeReceiverVariableInHandle: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top] 
	ifFalse: [
		(self oop: rcvr isLessThan: objectMemory youngStart) ifTrue:
		[objectMemory possibleRootStoreInto: rcvr value: top].
		objectMemory storePointerUnchecked: (currentBytecode bitAnd: 7) ofObject: rcvr withValue: top.].
	
	self fetchNextBytecode.
	self internalPop: 1
	
	

	
! !

!HStackInterpreterPrimitives methodsFor: 'support state/propagation' stamp: 'jb 8/11/2011 15:09'!
storeReceiverVariableInHandle: fieldIndex ofObject: aHandle withValue: theValue

| stateArray |
(self handleInlineStateOf: aHandle) 
	ifTrue: [
		stateArray := (self handleInlineStateOf: aHandle).
		self stObject: stateArray at: (fieldIndex + 1) put: theValue.]
	ifFalse: [
		objectMemory storePointer: fieldIndex ofObject: (self handleInlineReceiverOf: aHandle) withValue: theValue.].

! !

HStackInterpreterPrimitives subclass: #HStackInterpreterPrimitivesForkSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/4/2011 15:47'!
byteHandleSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: (self internalStackValue: argumentCount).
	self hInternalFindNewMethod.
	self hInternalExecuteNewMethod.
	self fetchNextBytecode! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/4/2011 13:19'!
hInternalExecuteNewMethod
	| succeeded primitiveIndex rcvr |
	<inline: true>
	rcvr := self internalStackValue: argumentCount.
		primitiveIndex := self primitiveIndexOf: newMethod.
		primitiveFunctionPointer := (self hFunctionPointerFor: primitiveIndex inClass: nil).
		primitiveFunctionPointer ~~ 0 ifTrue: [
			self isPrimitiveFunctionPointerAnIndex ifTrue:
				[^self hInternalQuickPrimitiveResponse].
			self externalizeIPandSP.
			succeeded := self slowPrimitiveResponse.
			self internalizeIPandSP.
			succeeded ifTrue:
				[self browserPluginReturnIfNeeded.
				^nil].
		].
	
		^self internalActivateNewMethod.! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/5/2011 14:40'!
hInternalFindNewMethod
	| ok rcvr | 
	<inline: true>
	rcvr := self stackValue: argumentCount.
	ok := self lookupInMethodCacheSel: messageSelector class: lkupClass.
	ok ifFalse: "entry was not found in the cache; look it up the hard way"
		[self externalizeIPandSP.
		(self internalIsHandle: lkupClass) 
			ifTrue:[self hLookupMethodInClass: lkupClass]
			ifFalse:[self lookupMethodInClass: lkupClass.].
		self internalizeIPandSP.
		self addNewMethodToCache: lkupClass]! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/18/2011 16:52'!
hLookupMethodInClass: class
	| currentClass dictionary found |
	<inline: false>
	self assert: class ~~ objectMemory nilObject.
	currentClass := class.
	dictionary := self stObject: (self handleStateOf: currentClass) at: (MethodDictionaryIndex + 1).
	found := self lookupMethodInDictionary: dictionary.
	found ifTrue: [^currentClass].
	^self lookupMethodInClass: (self stObject: (self handleStateOf: currentClass) at: (SuperclassIndex + 1)).! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/21/2011 17:13'!
handleSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: (self internalStackValue: argumentCount).
	self hInternalFindNewMethod.
	self hInternalExecuteNewMethod.
	self fetchNextBytecode! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'support behavior' stamp: 'jb 10/4/2011 13:35'!
internalExecuteNewMethod
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~~ 0 ifTrue:
		[self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'identity prim' stamp: 'jb 10/7/2011 15:15'!
isHandle: oop
	<export:true>
	<inline: true>
	^(oop = self classHandle)! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'bytecode behavior ' stamp: 'jb 10/3/2011 13:26'!
normalSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	| rcvr |
	<sharedCodeNamed: 'normalSend' inCase: 131>
	rcvr := self internalStackValue: argumentCount.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
					(self handleInlineUseBehavior: rcvr) ifTrue: [
						lkupClass :=  (self handleClassLookupOf: rcvr).
						]
					ifFalse: [
						lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
						].
			self handleSend.
			]
		ifFalse: [self commonSend.].	
	
! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'identity prim' stamp: 'jb 10/25/2011 16:12'!
primitiveHRealIdentical
	"is the receiver/first argument the same object as the (last) argument?.
	 pop argumentCount because this can be used as a mirror primitive."
	
	<export:true>
	| thisObject otherObject |
	otherObject := self stackValue: 1.
	thisObject := self stackTop.
	self pop: argumentCount + 1 thenPushBool: thisObject = otherObject ! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'identity prim' stamp: 'jb 10/7/2011 15:25'!
primitiveIsHandle
	<export:true>
	
	| oop |
	oop := self stackTop.
	(self internalIsHandle: oop) ifTrue: [ self pop:1 thenPush: objectMemory trueObject ]
	ifFalse: [ self pop:1 thenPush: objectMemory falseObject]
	! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'bytecode behavior ' stamp: 'jb 10/3/2011 17:09'!
sendLiteralSelector0ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 0.
	rcvr := self internalStackValue: 0.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
					(self handleInlineUseBehavior: rcvr) ifTrue: [
						lkupClass :=  (self handleClassLookupOf: rcvr).
						]
					ifFalse: [
						lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
						].
			self byteHandleSend.
			]
		ifFalse: [self commonSend.].	
					.
	
! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'bytecode behavior ' stamp: 'jb 10/3/2011 17:09'!
sendLiteralSelector1ArgBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 1.
	rcvr := self internalStackValue: 1.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
					(self handleInlineUseBehavior: rcvr) ifTrue: [
						lkupClass :=  (self handleClassLookupOf: rcvr).
						]
					ifFalse: [
						lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
						].
			self byteHandleSend.
			]
		ifFalse: [self commonSend.].	
	
					.
	
! !

!HStackInterpreterPrimitivesForkSend methodsFor: 'bytecode behavior ' stamp: 'jb 10/3/2011 17:09'!
sendLiteralSelector2ArgsBytecode
	"Can use any of the first 16 literals for the selector."
	| rcvr |
	
	messageSelector := self literal: (currentBytecode bitAnd: 16rF).
	argumentCount := 2.
	rcvr := self internalStackValue: 2.
	lkupClass := objectMemory fetchClassOf: rcvr.
	self assert: lkupClass ~~ objectMemory nilObject.
	(self internalIsHandle: rcvr) ifTrue: [
					(self handleInlineUseBehavior: rcvr) ifTrue: [
						lkupClass :=  (self handleClassLookupOf: rcvr).
						]
					ifFalse: [
						lkupClass :=  objectMemory fetchClassOf: (self handleReceiverOf: rcvr).
						].
			self byteHandleSend.
			]
		ifFalse: [self commonSend.].	
	
					.
	
! !

!HStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 13:52'!
initialize
	"self initialize"
	super initialize.
	self initializeHandleIndices .! !

!HStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 10/5/2011 16:10'!
initializeHandleIndices
	"self initializeHandleIndices"
	HandleReceiverIndex := 0.
	HandleClassLookupIndex := 1.
	HandleStateIndex := 2.
	HandleIndexedFieldIndex := 3.
	HandleConfigurationIndex := 4.
	
	
	
	"initialize specialObject Array"
	ClassHandle := 56.
	"propagationMethod."
	HandlePropagationSelectorIndex := 57
	
	"bit in the header"! !

!HStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 13:51'!
initializePrimitiveTable
	"self initializePrimitiveTable"
	super initializePrimitiveTable.
	self assert: (PrimitiveTable at: 550) = #primitiveFail.
	PrimitiveTable at: (550) put: #primitiveAsHandle! !

!HStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 13:52'!
objectMemoryClass
	^HNewObjectMemory! !

!HStackInterpreterRoot class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 13:52'!
prepareToBeAddedToCodeGenerator: aCCodeGenerator
	"Override to avoid repeating Cogit's preparations and remove the methods we override."
	self selectors do:
		[:sel|
		 (self includesSelector: sel) ifTrue:
			[aCCodeGenerator removeMethodForSelector: sel]]! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:32'!
classHandle

	<inline: false>
	^objectMemory splObj: ClassHandle! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:02'!
classHandleInline
	<inline: true>
	^objectMemory splObj: ClassHandle! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:32'!
handleClassLookupOf: oop
	<inline: false>
	^objectMemory fetchPointer: HandleClassLookupIndex ofObject: oop! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:32'!
handleConfigurationOf: oop
	<inline: false>
		^objectMemory fetchPointer: HandleConfigurationIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:02'!
handleInlineClassLookupOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleClassLookupIndex ofObject: oop! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:02'!
handleInlineConfigurationOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleConfigurationIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/7/2011 15:02'!
handleInlineIndexedFieldOf: oop
	<inline: true>
	^objectMemory fetchPointer: HandleIndexedFieldIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:01'!
handleInlineIndexedFieldOf: oop push: aArray
	<inline: true>
	"Todo"
		^objectMemory fetchPointer: HandleIndexedFieldIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:01'!
handleInlinePropagateSelector
	<inline: true>
	^objectMemory splObj: HandlePropagationSelectorIndex.! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 8/12/2011 17:11'!
handleInlineReceiverOf: oop
	<inline: true>
		^objectMemory fetchPointer: HandleReceiverIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:01'!
handleInlineStateOf: oop
	<inline: true>
		^objectMemory fetchPointer: HandleStateIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing inline' stamp: 'jb 10/5/2011 17:01'!
handleInlineStateOf: oop push: aArray
	<inline: true>
	"Todo"
		^objectMemory fetchPointer: HandleStateIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 14:56'!
handleInlineUseBehavior: oop
	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1)bitAnd: 2.

! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 14:57'!
handleInlineUsePropagation: oop

	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 8.

! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 14:57'!
handleInlineUseSelfWrapping: oop 
	
	<inline:true>
	^ (self handleInlineConfigurationOf: oop)
		>> 1 bitAnd: 4! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 14:57'!
handleInlineUseState: oop
	<inline:true>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 1.

! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:31'!
handlePropagateSelector
	<inline: false>
	^objectMemory splObj: HandlePropagationSelectorIndex.! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:31'!
handleReceiverOf: oop
	<inline: false>
		^objectMemory fetchPointer: HandleReceiverIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:31'!
handleStateOf: oop
	<inline: false>
		^objectMemory fetchPointer: HandleStateIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:32'!
handleStateOf: oop push: aArray
	<inline: false>
		^objectMemory fetchPointer: HandleStateIndex ofObject: oop
! !

!HStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 8/11/2011 14:58'!
handleUseBehavior: oop

	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1)bitAnd: 2.

! !

!HStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 8/11/2011 14:58'!
handleUsePropagation: oop

	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 8.

! !

!HStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 8/11/2011 14:58'!
handleUseSelfWrapping: oop 
	
	<inline:false>
	^ (self handleInlineConfigurationOf: oop)
		>> 1 bitAnd: 4! !

!HStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 8/11/2011 14:59'!
handleUseState: oop
	
	<inline:false>
	^((self handleInlineConfigurationOf: oop) >> 1) bitAnd: 1.

! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/12/2011 17:57'!
internalIsHandle: oop
	<inline: true>
	<export: false>
	(objectMemory isNonIntegerObject: oop) 
		ifTrue: [
			 ((objectMemory handleBitValueOf: oop) ~~ 0) ifTrue: [
				^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HStackInterpreterRoot methodsFor: 'support' stamp: 'jb 6/6/2011 13:47'!
internalStackPageAt: offset put: value
	stackPages longAtPointer: localSP + (offset * BytesPerWord) put: value.! !

!HStackInterpreterRoot methodsFor: 'handle accessing not inline' stamp: 'jb 8/12/2011 13:08'!
isAHandle: oop
	
	<inline:false>
	<export: false>
	(objectMemory isNonIntegerObject: oop) 
		ifTrue: [
			 ((objectMemory handleBitValueOf: oop) ~~ 0) ifTrue: [^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 15:09'!
isActiveMetaHandle: oop
	| receiverOfHandle |
	
	<inline:true>
	receiverOfHandle := (self handleInlineReceiverOf: oop).
	^(self internalIsHandle: receiverOfHandle).! !

!HStackInterpreterRoot methodsFor: 'handle testing' stamp: 'jb 8/12/2011 13:09'!
isHandle: oop

	<inline: true>
	^(oop = self classHandle)! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 18:34'!
isInstanceOfHandle: oop
	<inline: true>
	^self isSubHandle: (objectMemory fetchClassOf: oop).! !

!HStackInterpreterRoot methodsFor: 'handle testing inline' stamp: 'jb 8/11/2011 16:26'!
isSubHandle: aClass

	|cc|
	<inline: true>
	cc := aClass.
	[cc = objectMemory nilObject.] whileFalse:[(self isHandle: cc) ifTrue:[^true] .
			cc := self superclassOf:  cc].
	^false! !

!HStackInterpreterRoot methodsFor: 'handle primitive' stamp: 'jb 8/12/2011 13:28'!
primitiveAsHandle
	| rcvr |
	<inline: true>
	<export: true>
	rcvr := self stackTop.
	(self isInstanceOfHandle: rcvr) ifTrue: [
		(self isActiveMetaHandle: rcvr)
			ifTrue: [^self primitiveFail.]
			ifFalse:[
				objectMemory setHandleBit: rcvr]].! !

!HStackInterpreterRoot methodsFor: 'handle propagation support' stamp: 'jb 7/20/2011 13:26'!
pushHandle: aHandle propagateValue: aObject
	
|   handleClass handleMetaClass |
      self inline: false.
	self export: true.
	(objectMemory isNonIntegerObject: aObject) ifFalse: [
		self push: aObject.]
	ifTrue: [	
		"initialize Part"
		 
		handleClass := objectMemory fetchClassOf: aHandle.
		handleMetaClass := objectMemory fetchClassOf: handleClass.
		self push:  handleClass.
		self push: aObject.
		messageSelector :=self handlePropagateSelector.
		argumentCount := 1.
		
		"Sending message Part"
		"From here  "
	
		self lookupMethodInClass: handleMetaClass.
		lkupClass := handleMetaClass.
		
		self activateNewMethod.
	].
	! !

StackInterpreterPrimitives subclass: #StackInterpreterFCR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-FCR'!

!StackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 16:59'!
initializePrimitiveTable
	"self initializePrimitiveTable"
	super initializePrimitiveTable.
	self assert: (PrimitiveTable at: 550) = #primitiveFail.
	PrimitiveTable at: (550) put: #primitivecheck.
	! !

!StackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 17:55'!
objectMemoryClass
	^NewObjectMemoryFCR! !

!StackInterpreterFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 16:58'!
prepareToBeAddedToCodeGenerator: aCCodeGenerator
	"Override to avoid repeating Cogit's preparations and remove the methods we override."
	self selectors do:
		[:sel|
		 (self includesSelector: sel) ifTrue:
			[aCCodeGenerator removeMethodForSelector: sel]]! !

!StackInterpreterFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 18:03'!
primitivecheck
	self inline: true.
	self export: true.
	
	
	^self push: (objectMemory instanciateNewReferenceFor: (self stackTop)).! !

StackWindowsConfig subclass: #HStackWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackWindowsConfig methodsFor: 'as yet unclassified' stamp: 'jb 5/13/2011 13:01'!
executableName
	^ 'Handle StackVM'! !

!HStackWindowsConfig methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:20'!
interpreterClass
	^ HStackInterpreter! !

StackUnixConfig subclass: #HStackUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackUnixConfig methodsFor: 'as yet unclassified' stamp: 'jb 5/16/2011 17:12'!
executableName
	^  'HandleVM'! !

!HStackUnixConfig methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:20'!
interpreterClass
	^ HStackInterpreter! !

StackCocoaIOSConfig subclass: #HStackCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackCocoaIOSConfig methodsFor: 'as yet unclassified' stamp: 'jb 5/13/2011 13:33'!
executableName
	^  'HandleVM'! !

!HStackCocoaIOSConfig methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:17'!
interpreterClass
	^ HStackInterpreter! !

StackCocoaIOSConfig subclass: #HStackCocoaIOSConfigExp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackCocoaIOSConfigExp methodsFor: 'as yet unclassified' stamp: 'jb 5/31/2011 16:42'!
executableName
	^  'CautionExperimentalHandleVM'! !

!HStackCocoaIOSConfigExp methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 17:02'!
interpreterClass
	^ StackInterpreterFCR ! !

StackCocoaIOSConfig subclass: #HStackCocoaIOSConfigExpT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

HStackCocoaIOSConfigExpT subclass: #HSCStackCocoaIOSConfigExpTFK
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HSCStackCocoaIOSConfigExpTFK methodsFor: 'as yet unclassified' stamp: 'jb 2/1/2012 18:07'!
interpreterClass
	^ HSCStackInterpreterPrimitivesStateManagement! !

HStackCocoaIOSConfigExpT subclass: #HStackCocoaIDebugOSConfigExpT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackCocoaIDebugOSConfigExpT methodsFor: 'as yet unclassified' stamp: 'jb 9/21/2011 16:26'!
isRelease
	^false.! !

!HStackCocoaIOSConfigExpT methodsFor: 'as yet unclassified' stamp: 'jb 7/18/2011 14:33'!
executableName
	^  'CautionExperimentalHandleVM'! !

!HStackCocoaIOSConfigExpT methodsFor: 'as yet unclassified' stamp: 'jb 7/20/2011 18:32'!
interpreterClass
	^ HStackInterpreterPrimitives ! !

HStackCocoaIOSConfigExpT subclass: #HStackCocoaIOSConfigExpTFK
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackCocoaIOSConfigExpTFK methodsFor: 'as yet unclassified' stamp: 'jb 10/3/2011 13:16'!
interpreterClass
	^ HStackInterpreterPrimitivesForkSend! !

StackCocoaIOSConfig subclass: #HStackCocoaIOSConfigSystemTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HStackCocoaIOSConfigSystemTracer methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 14:37'!
executableName
	^  'CautionExperimentalHandleVM'! !

!HStackCocoaIOSConfigSystemTracer methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 14:38'!
interpreterClass
	^ HStackInterpreterPrimitivesSystemTracer! !

CogMacOSConfig subclass: #HCogMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Config'!

!HCogMacOSConfig methodsFor: 'as yet unclassified' stamp: 'jb 5/13/2011 13:29'!
CFBundleIconFile
	"An application icon"
	^ 'Handle.icns'! !

!HCogMacOSConfig methodsFor: 'as yet unclassified' stamp: 'jb 5/9/2011 15:16'!
interpreterClass
	^ StackInterpreter! !

NewObjectMemory subclass: #HNewObjectMemory
	instanceVariableNames: ''
	classVariableNames: 'HandleBit'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-Interpreter'!

!HNewObjectMemory class methodsFor: 'as yet unclassified' stamp: 'jb 5/9/2011 16:40'!
initialize
	"self initialize"
	super initialize.
	HandleBit := 1 bitShift:BytesPerWord*8 - 3. ! !

!HNewObjectMemory methodsFor: 'handle support' stamp: 'jb 5/9/2011 17:10'!
baseHeader: oop put: aWord
	^ self longAt: oop put:aWord.
! !

!HNewObjectMemory methodsFor: 'handle support' stamp: 'jb 7/22/2011 13:45'!
hInstantiateClass: classPointer indexableSize: size 
	"NOTE: This method supports the backward-compatible split instSize field of the 
	class format word. The sizeHiBits will go away and other shifts change by 2 
	when the split fields get merged in an (incompatible) image change."
	<api>
	| hash header1 header2 cClass byteSize format binc header3 hdrSize newObj sizeHiBits bm1 classFormat class |
	<inline: false>
	class := self handleClassLookupOf: classPointer.
	
	self assert: size >= 0. "'cannot have a negative indexable field count"
	hash := self newObjectHash.
	
	classFormat := self formatOfClass: class.
	"Low 2 bits are 0"
	header1 := (classFormat bitAnd: 16r1FF00) bitOr: (hash bitAnd: HashMaskUnshifted) << HashBitsOffset.
	header2 := class.
	header3 := 0.
	sizeHiBits := (classFormat bitAnd: 16r60000) >> 9.
	cClass := header1 bitAnd: CompactClassMask. "compact class field from format word"
	byteSize := (classFormat bitAnd: SizeMask + Size4Bit) + sizeHiBits.
		"size in bytes -- low 2 bits are 0"
	"Note thi Argument expected ->s byteSize comes from the format word of the class which is pre-shifted
		to 4 bytes per field.  Need another shift for 8 bytes per word..."
	byteSize := byteSize << (ShiftForWord-2).
	format := classFormat >> 8 bitAnd: 15.
	self flag: #sizeLowBits.
	format < 8
		ifTrue:
			[format = 6
				ifTrue: ["long32 bitmaps"
					bm1 := BytesPerWord-1.
					byteSize := byteSize + (size * 4) + bm1 bitAnd: LongSizeMask. "round up"
					binc := bm1 - ((size * 4) + bm1 bitAnd: bm1). "odd bytes"
					"extra low bit (4) for 64-bit VM goes in 4-bit (betw hdr bits and sizeBits)"
					header1 := header1 bitOr: (binc bitAnd: 4)]
				ifFalse: [byteSize := byteSize + (size * BytesPerWord) "Arrays and 64-bit bitmaps"]]
		ifFalse:
			["Strings and Methods"
			bm1 := BytesPerWord-1.
			byteSize := byteSize + size + bm1 bitAnd: LongSizeMask. "round up"
			binc := bm1 - (size + bm1 bitAnd: bm1). "odd bytes"
			"low bits of byte size go in format field"
			header1 := header1 bitOr: (binc bitAnd: 3) << 8.
			"extra low bit (4) for 64-bit VM goes in 4-bit (betw hdr bits and sizeBits)"
			header1 := header1 bitOr: (binc bitAnd: 4)].
	byteSize > 255
		ifTrue: ["requires size header word"
			header3 := byteSize.
			header1 := header1]
		ifFalse: [header1 := header1 bitOr: byteSize].
	
	hdrSize := header3 > 0
				ifTrue: [3 "requires full header"]
				ifFalse: [cClass = 0 ifTrue: [2] ifFalse: [1]].
	newObj := self allocate: byteSize headerSize: hdrSize h1: header1 h2: header2 h3: header3 doFill: true format: format.
	^ newObj! !

!HNewObjectMemory methodsFor: 'handle support' stamp: 'jb 8/11/2011 18:37'!
handleBitValueOf: oop
	<inline:true>
	^(self baseHeader: oop) bitAnd: HandleBit.
! !

!HNewObjectMemory methodsFor: 'handle support' stamp: 'jb 5/10/2011 12:49'!
setHandleBit: oop
	| bitValue |
	bitValue := (self baseHeader: oop).
	bitValue := bitValue bitOr: HandleBit.
	self baseHeader: oop put: bitValue
! !

NewObjectMemory subclass: #HNewObjectMemoryFCR
	instanceVariableNames: ''
	classVariableNames: 'ClassHandle HandleBit HandleClassLookupIndex HandleConfigurationIndex HandlePropagationSelectorIndex HandleReceiverIndex HandleStateIndex'
	poolDictionaries: ''
	category: 'HandleVirtualMachine-FCR'!

!HNewObjectMemoryFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:30'!
initialize
super initialize.
	self initializeHandleIndices .
	! !

!HNewObjectMemoryFCR class methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:30'!
initializeHandleIndices
	"self "
	HandleReceiverIndex := 0.
	HandleClassLookupIndex := 1.
	HandleStateIndex := 2.
	HandleConfigurationIndex := 3.
	
	
	
	"initialize specialObject Array"
	ClassHandle := 56.
	"propagationMethod."
	HandlePropagationSelectorIndex := 57.
	HandleBit := 1 bitShift:BytesPerWord*8 - 3. 
	"bit in the header"! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 8/11/2011 14:30'!
IsHandle: oop
	self inline: false.
	self export: false.
	(self isNonIntegerObject: oop) 
		ifTrue: [
			 ((self handleBitValueOf: oop) ~~ 0) ifTrue: [^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:23'!
baseHeader: oop put: aWord
	^ self longAt: oop put:aWord.
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:26'!
classHandle

	self inline: true.
	^self splObj: ClassHandle! !

!HNewObjectMemoryFCR methodsFor: 'class accessing' stamp: 'jb 6/7/2011 18:13'!
fetchClassFromHandle: oop
	^self handleClassLookupOf: ((self classHeader: oop) bitAnd: AllButTypeMask).! !

!HNewObjectMemoryFCR methodsFor: 'class accessing' stamp: 'jb 2/1/2012 14:55'!
fetchClassOf: oop 
	| ccIndex |
	<inline: true>
	<asmLabel: false>
	
	
	(self isIntegerObject: oop)
		ifTrue: [^self splObj: ClassInteger].
	
	"(self useHandle: oop) ifTrue:[
		^self fetchClassFromHandle: oop.]."
	(ccIndex := (self compactClassIndexOf: oop)) = 0
		ifTrue: [^(self classHeader: oop) bitAnd: AllButTypeMask]
		ifFalse: "look up compact class"
			[^self fetchPointer: ccIndex - 1
				ofObject: (self splObj: CompactClasses)]! !

!HNewObjectMemoryFCR methodsFor: 'class accessing' stamp: 'jb 6/7/2011 11:46'!
fetchClassOfNoCheck: oop 
	<inline: true>
	<asmLabel: false>
	
	^(self useHandle: oop)
		 ifTrue:[self fetchClassFromHandle: oop]
		 ifFalse:[(self classHeader: oop) bitAnd: AllButTypeMask].! !

!HNewObjectMemoryFCR methodsFor: 'class accessing' stamp: 'jb 6/7/2011 11:36'!
fetchClassOfNonInt: oop 
	| ccIndex |
	<inline: true>
	<asmLabel: false>
	
	(self useHandle: oop) ifTrue:[^self fetchClassFromHandle: oop.].
	
	(ccIndex := (self compactClassIndexOf: oop)) = 0
		ifTrue: [^(self classHeader: oop) bitAnd: AllButTypeMask]
		ifFalse: "look up compact class"
			[^self fetchPointer: ccIndex - 1
				ofObject: (self splObj: CompactClasses)]! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:23'!
handleBitValueOf: oop

	^(self baseHeader: oop) bitAnd: HandleBit.
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:26'!
handleClassLookupOf: oop
	self inline: true.
	^self fetchPointer: HandleClassLookupIndex ofObject: oop! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:26'!
handleConfigurationOf: oop
	self inline: true.
		^self fetchPointer: HandleConfigurationIndex ofObject: oop
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 8/11/2011 14:33'!
handleInlineStateOf: oop
	self inline: true.
		^self fetchPointer: HandleStateIndex ofObject: oop
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:26'!
handlePropagateSelector
	self inline: true.
	^self splObj: HandlePropagationSelectorIndex.! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:26'!
handleReceiverOf: oop
	self inline: true.
		^self fetchPointer: HandleReceiverIndex ofObject: oop
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
handleUseBehavior: oop
	^((self handleConfigurationOf: oop) >> 1)bitAnd: 2.

! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
handleUsePropagation: oop
	^((self handleConfigurationOf: oop) >> 1) bitAnd: 8.

! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
handleUseSelfWrapping: oop 
	"Todo"
	^ (self handleConfigurationOf: oop)
		>> 1 bitAnd: 4! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
handleUseState: oop
	^((self handleConfigurationOf: oop) >> 1) bitAnd: 1.

! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
internalIsHandle: oop
	self inline: true.
	self export: false.
	(self isNonIntegerObject: oop) 
		ifTrue: [
			 ((self handleBitValueOf: oop) ~~ 0) ifTrue: [^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
isActiveMetaHandle: oop
	| receiverOfHandle |
	receiverOfHandle := (self handleReceiverOf: oop).
	^(self internalIsHandle: receiverOfHandle).! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 8/11/2011 14:31'!
isHandle: oop
	self inline: false.
	self export: false.
	(self isNonIntegerObject: oop) 
		ifTrue: [
			 ((self handleBitValueOf: oop) ~~ 0) ifTrue: [^true] ifFalse: [^false]]
		ifFalse: [^ false].! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:27'!
isInstanceOfHandle: oop

	self inline: true.
	^self isSubHandle: (self fetchClassOf: oop).! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:28'!
isSubHandle: aClass

	|cc|
	self inline: true.
	cc := aClass.
	[cc = self nilObject.] whileFalse:[(self isHandle: cc) ifTrue:[^true] .
			cc := self superclassOf:  cc].
	^false! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/6/2011 18:23'!
setHandleBit: oop
	| bitValue |
	bitValue := (self baseHeader: oop).
	bitValue := bitValue bitOr: HandleBit.
	self baseHeader: oop put: bitValue
! !

!HNewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 8/11/2011 15:51'!
useHandle: oop
	^(self handleBitValueOf: oop) ~~ 0! !

NewObjectMemory subclass: #NewObjectMemoryFCR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HandleVirtualMachine-FCR'!

!NewObjectMemoryFCR methodsFor: 'as yet unclassified' stamp: 'jb 6/27/2011 17:58'!
instanciateNewReferenceFor: oop
	| ref |
	ref := self instantiateClass: (self classArray) indexableSize: 1.
	self storePointer: 0 ofObject: ref withValue: oop.
	^ref! !
HStackInterpreterRoot initialize!
HSCStackInterpreterRoot initialize!
HSCStackInterpreterPrimitivesBytecodeHack initialize!
HNewObjectMemoryFCR initialize!
HNewObjectMemory initialize!
HSCStackInterpreterPrimitivesBytecodeHack2 initialize!
